// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QClipBlendValueWrapper_H
#define SBK_QClipBlendValueWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DAnimation/qclipblendvalue.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QClipBlendValueWrapper : public Qt3DAnimation::QClipBlendValue
{
public:
    QClipBlendValueWrapper(const QClipBlendValueWrapper &) = delete;
    QClipBlendValueWrapper& operator=(const QClipBlendValueWrapper &) = delete;
    QClipBlendValueWrapper(QClipBlendValueWrapper &&) = delete;
    QClipBlendValueWrapper& operator=(QClipBlendValueWrapper &&) = delete;

    QClipBlendValueWrapper(::Qt3DAnimation::QAbstractAnimationClip * clip, ::Qt3DCore::QNode * parent = nullptr);
    QClipBlendValueWrapper(::Qt3DCore::QNode * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QClipBlendValueWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QClipBlendValueWrapper_H

