// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAspectJobWrapper_H
#define SBK_QAspectJobWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DCore/qaspectjob.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAspectJobWrapper : public Qt3DCore::QAspectJob
{
public:
    QAspectJobWrapper(const QAspectJobWrapper &) = delete;
    QAspectJobWrapper& operator=(const QAspectJobWrapper &) = delete;
    QAspectJobWrapper(QAspectJobWrapper &&) = delete;
    QAspectJobWrapper& operator=(QAspectJobWrapper &&) = delete;

    QAspectJobWrapper();
    bool isRequired() override;
    void postFrame(::Qt3DCore::QAspectEngine * aspectEngine) override;
    void run() override;
    ~QAspectJobWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3];
};

#endif // SBK_QAspectJobWrapper_H

