// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qt3dlogic_python.h"

// main header
#include "qt3dlogic_wrapper.h"

// inner classes
#include "qt3dlogic_qlogicaspect_wrapper.h"
#include "qt3dlogic_qframeaction_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_Qt3DLogic_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_Qt3DLogic_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_Qt3DLogic_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Qt3DLogic_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_Qt3DLogic_Type = nullptr;
static PyTypeObject *Sbk_Qt3DLogic_TypeF(void)
{
    return _Sbk_Qt3DLogic_Type;
}

static PyType_Slot Sbk_Qt3DLogic_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Qt3DLogic_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Qt3DLogic_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Qt3DLogic_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_Qt3DLogic_spec = {
    "2:PySide6.Qt3DLogic.Qt3DLogic",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Qt3DLogic_slots
};

} //extern "C"

// Type conversion functions.

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *Qt3DLogicQt3DLogic_SignatureStrings[] = {
    nullptr}; // Sentinel

PyTypeObject *init_Qt3DLogicQt3DLogic(PyObject *module)
{
    if (SbkPySide6_Qt3DLogicTypeStructs[SBK_Qt3DLogicQt3DLogic_IDX].type != nullptr)
        return SbkPySide6_Qt3DLogicTypeStructs[SBK_Qt3DLogicQt3DLogic_IDX].type;

    Shiboken::AutoDecRef Sbk_Qt3DLogic_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_Qt3DLogic_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "Qt3DLogic",
        "Qt3DLogic",
        &Sbk_Qt3DLogic_spec,
        nullptr,
        Sbk_Qt3DLogic_Type_bases.object(),
        0);
    auto *pyType = Sbk_Qt3DLogic_TypeF(); // references _Sbk_Qt3DLogic_Type
    InitSignatureStrings(pyType, Qt3DLogicQt3DLogic_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_Qt3DLogic_PropertyStrings);
    SbkPySide6_Qt3DLogicTypeStructs[SBK_Qt3DLogicQt3DLogic_IDX].type = pyType;



    return pyType;
}
