// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_PropertyReaderInterfaceWrapper_H
#define SBK_PropertyReaderInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qshaderdata.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class PropertyReaderInterfaceWrapper : public Qt3DRender::PropertyReaderInterface
{
public:
    PropertyReaderInterfaceWrapper(const PropertyReaderInterfaceWrapper &) = delete;
    PropertyReaderInterfaceWrapper& operator=(const PropertyReaderInterfaceWrapper &) = delete;
    PropertyReaderInterfaceWrapper(PropertyReaderInterfaceWrapper &&) = delete;
    PropertyReaderInterfaceWrapper& operator=(PropertyReaderInterfaceWrapper &&) = delete;

    PropertyReaderInterfaceWrapper();
    ::QVariant readProperty(const ::QVariant & v) override;
    ~PropertyReaderInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_PropertyReaderInterfaceWrapper_H

