// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtbluetooth_python.h"

// main header
#include "qlowenergyadvertisingdata_wrapper.h"

// Argument includes
#include <QList>
#include <QString>
#include <QtBluetooth/qbluetoothuuid.h>
#include <QtBluetooth/qlowenergyadvertisingdata.h>
#include <qbytearray.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QLowEnergyAdvertisingData_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QLowEnergyAdvertisingData >()))
        return -1;

    ::QLowEnergyAdvertisingData *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QLowEnergyAdvertisingData", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::QLowEnergyAdvertisingData()
    // 1: QLowEnergyAdvertisingData::QLowEnergyAdvertisingData(QLowEnergyAdvertisingData)
    if (numArgs == 0) {
        overloadId = 0; // QLowEnergyAdvertisingData()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QLowEnergyAdvertisingData(QLowEnergyAdvertisingData)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QLowEnergyAdvertisingData()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QLowEnergyAdvertisingData()
                cptr = new ::QLowEnergyAdvertisingData();
            }
            break;
        }
        case 1: // QLowEnergyAdvertisingData(const QLowEnergyAdvertisingData &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QLowEnergyAdvertisingData cppArg0_local;
            ::QLowEnergyAdvertisingData *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QLowEnergyAdvertisingData(QLowEnergyAdvertisingData)
                cptr = new ::QLowEnergyAdvertisingData(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QLowEnergyAdvertisingData >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_discoverability(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.discoverability";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // discoverability()const
            QLowEnergyAdvertisingData::Discoverability cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->discoverability();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_Discoverability_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_includePowerLevel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.includePowerLevel";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // includePowerLevel()const
            bool cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->includePowerLevel();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_invalidManufacturerId(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.invalidManufacturerId";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // invalidManufacturerId()
            quint16 cppResult = ::QLowEnergyAdvertisingData::invalidManufacturerId();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_localName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.localName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // localName()const
            QString cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->localName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_manufacturerData(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.manufacturerData";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // manufacturerData()const
            QByteArray cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->manufacturerData();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_manufacturerId(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.manufacturerId";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // manufacturerId()const
            quint16 cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->manufacturerId();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_rawData(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.rawData";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // rawData()const
            QByteArray cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->rawData();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_services(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.services";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // services()const
            QList<QBluetoothUuid> cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->services();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypeConverters[SBK_QtBluetooth_QList_QBluetoothUuid_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_setDiscoverability(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setDiscoverability";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::setDiscoverability(QLowEnergyAdvertisingData::Discoverability)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_Discoverability_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setDiscoverability(QLowEnergyAdvertisingData::Discoverability)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QLowEnergyAdvertisingData::Discoverability cppArg0{QLowEnergyAdvertisingData::DiscoverabilityNone};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setDiscoverability(QLowEnergyAdvertisingData::Discoverability)
            cppSelf->setDiscoverability(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_setIncludePowerLevel(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setIncludePowerLevel";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::setIncludePowerLevel(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setIncludePowerLevel(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setIncludePowerLevel(bool)
            cppSelf->setIncludePowerLevel(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_setLocalName(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setLocalName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::setLocalName(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setLocalName(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setLocalName(QString)
            cppSelf->setLocalName(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_setManufacturerData(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setManufacturerData";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "setManufacturerData", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::setManufacturerData(quint16,QByteArray)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[1])))) {
        overloadId = 0; // setManufacturerData(quint16,QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        quint16 cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::QByteArray cppArg1_local;
        ::QByteArray *cppArg1 = &cppArg1_local;
        if (pythonToCpp[1].isValue())
            pythonToCpp[1](pyArgs[1], &cppArg1_local);
        else
            pythonToCpp[1](pyArgs[1], &cppArg1);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setManufacturerData(quint16,QByteArray)
            cppSelf->setManufacturerData(cppArg0, *cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_setRawData(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setRawData";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::setRawData(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArg)))) {
        overloadId = 0; // setRawData(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setRawData(QByteArray)
            cppSelf->setRawData(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_setServices(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setServices";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::setServices(QList<QBluetoothUuid>)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtBluetoothTypeConverters[SBK_QtBluetooth_QList_QBluetoothUuid_IDX], (pyArg)))) {
        overloadId = 0; // setServices(QList<QBluetoothUuid>)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QList<QBluetoothUuid> cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setServices(QList<QBluetoothUuid>)
            cppSelf->setServices(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::swap(QLowEnergyAdvertisingData&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QLowEnergyAdvertisingData&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QLowEnergyAdvertisingData cppArg0_local;
        ::QLowEnergyAdvertisingData *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QLowEnergyAdvertisingData&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QLowEnergyAdvertisingData__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QLowEnergyAdvertisingData_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QLowEnergyAdvertisingData_EnumFlagInfo[] = {
    "Discoverability:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QLowEnergyAdvertisingData_methods[] = {
    {"discoverability", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_discoverability), METH_NOARGS, nullptr},
    {"includePowerLevel", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_includePowerLevel), METH_NOARGS, nullptr},
    {"invalidManufacturerId", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_invalidManufacturerId), METH_NOARGS|METH_STATIC, nullptr},
    {"localName", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_localName), METH_NOARGS, nullptr},
    {"manufacturerData", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_manufacturerData), METH_NOARGS, nullptr},
    {"manufacturerId", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_manufacturerId), METH_NOARGS, nullptr},
    {"rawData", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_rawData), METH_NOARGS, nullptr},
    {"services", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_services), METH_NOARGS, nullptr},
    {"setDiscoverability", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_setDiscoverability), METH_O, nullptr},
    {"setIncludePowerLevel", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_setIncludePowerLevel), METH_O, nullptr},
    {"setLocalName", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_setLocalName), METH_O, nullptr},
    {"setManufacturerData", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_setManufacturerData), METH_VARARGS, nullptr},
    {"setRawData", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_setRawData), METH_O, nullptr},
    {"setServices", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_setServices), METH_O, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingData__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QLowEnergyAdvertisingData_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), (pyArg)))) {
                // operator!=(const QLowEnergyAdvertisingData &b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QLowEnergyAdvertisingData cppArg0_local;
                ::QLowEnergyAdvertisingData *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), (pyArg)))) {
                // operator==(const QLowEnergyAdvertisingData &b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QLowEnergyAdvertisingData cppArg0_local;
                ::QLowEnergyAdvertisingData *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QLowEnergyAdvertisingData_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QLowEnergyAdvertisingData_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QLowEnergyAdvertisingData_Type = nullptr;
static PyTypeObject *Sbk_QLowEnergyAdvertisingData_TypeF(void)
{
    return _Sbk_QLowEnergyAdvertisingData_Type;
}

static PyType_Slot Sbk_QLowEnergyAdvertisingData_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingData_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingData_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingData_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingData_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingData_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QLowEnergyAdvertisingData_spec = {
    "2:PySide6.QtBluetooth.QLowEnergyAdvertisingData",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QLowEnergyAdvertisingData_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QLowEnergyAdvertisingData_Discoverability(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QLowEnergyAdvertisingData::Discoverability>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QLowEnergyAdvertisingData::Discoverability *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QLowEnergyAdvertisingData_Discoverability_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_Discoverability_IDX])))
        return Enum_PythonToCpp_QLowEnergyAdvertisingData_Discoverability;
    return {};
}
static PyObject *QLowEnergyAdvertisingData_Discoverability_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QLowEnergyAdvertisingData::Discoverability *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_Discoverability_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QLowEnergyAdvertisingData_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QLowEnergyAdvertisingData_TypeF()))
        return QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QLowEnergyAdvertisingData_PTR_CppToPython_QLowEnergyAdvertisingData(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QLowEnergyAdvertisingData *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QLowEnergyAdvertisingData_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QLowEnergyAdvertisingData_COPY_CppToPython_QLowEnergyAdvertisingData(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QLowEnergyAdvertisingData *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QLowEnergyAdvertisingData_TypeF(), new ::QLowEnergyAdvertisingData(*source), true, true);
}

// Python to C++ copy conversion.
static void QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QLowEnergyAdvertisingData *>(cppOut) = *reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QLowEnergyAdvertisingData_TypeF()))
        return QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QLowEnergyAdvertisingData_SignatureStrings[] = {
    "1:PySide6.QtBluetooth.QLowEnergyAdvertisingData(self)",
    "0:PySide6.QtBluetooth.QLowEnergyAdvertisingData(self,other:PySide6.QtBluetooth.QLowEnergyAdvertisingData)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.discoverability(self)->PySide6.QtBluetooth.QLowEnergyAdvertisingData.Discoverability",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.includePowerLevel(self)->bool",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.invalidManufacturerId()->quint16",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.localName(self)->QString",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.manufacturerData(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.manufacturerId(self)->quint16",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.rawData(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.services(self)->QList[PySide6.QtBluetooth.QBluetoothUuid]",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setDiscoverability(self,mode:PySide6.QtBluetooth.QLowEnergyAdvertisingData.Discoverability)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setIncludePowerLevel(self,doInclude:bool)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setLocalName(self,name:QString)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setManufacturerData(self,id:quint16,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setRawData(self,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setServices(self,services:QList[PySide6.QtBluetooth.QBluetoothUuid])",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.swap(self,other:PySide6.QtBluetooth.QLowEnergyAdvertisingData)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QLowEnergyAdvertisingData(PyObject *module)
{
    if (SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX].type != nullptr)
        return SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX].type;

    Shiboken::AutoDecRef Sbk_QLowEnergyAdvertisingData_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QLowEnergyAdvertisingData_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QLowEnergyAdvertisingData",
        "QLowEnergyAdvertisingData",
        &Sbk_QLowEnergyAdvertisingData_spec,
        &Shiboken::callCppDestructor< ::QLowEnergyAdvertisingData >,
        Sbk_QLowEnergyAdvertisingData_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QLowEnergyAdvertisingData_TypeF(); // references _Sbk_QLowEnergyAdvertisingData_Type
    InitSignatureStrings(pyType, QLowEnergyAdvertisingData_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QLowEnergyAdvertisingData_PropertyStrings);
    SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_PTR,
        is_QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_PTR_Convertible,
        QLowEnergyAdvertisingData_PTR_CppToPython_QLowEnergyAdvertisingData,
        QLowEnergyAdvertisingData_COPY_CppToPython_QLowEnergyAdvertisingData);

    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingData");
    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingData*");
    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingData&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QLowEnergyAdvertisingData).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_COPY,
        is_QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QLowEnergyAdvertisingData_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Discoverability'.
    const char *Discoverability_Initializer[] = {
        "DiscoverabilityNone",
        "DiscoverabilityLimited",
        "DiscoverabilityGeneral",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Discoverability_InitializerValues[] = {
        uint8_t(QLowEnergyAdvertisingData::Discoverability::DiscoverabilityNone),    //  0x00  0
        uint8_t(QLowEnergyAdvertisingData::Discoverability::DiscoverabilityLimited), //  0x01  1
        uint8_t(QLowEnergyAdvertisingData::Discoverability::DiscoverabilityGeneral)  //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QLowEnergyAdvertisingData_TypeF(),
        "2:PySide6.QtBluetooth.QLowEnergyAdvertisingData.Discoverability",
        Discoverability_Initializer, Discoverability_InitializerValues);
    SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingData_Discoverability_IDX].type = EType;
    // Register converter for enum 'QLowEnergyAdvertisingData::Discoverability'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QLowEnergyAdvertisingData_Discoverability_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QLowEnergyAdvertisingData_Discoverability,
            is_Enum_PythonToCpp_QLowEnergyAdvertisingData_Discoverability_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingData::Discoverability");
        Shiboken::Conversions::registerConverterName(converter, "Discoverability");
    }
    // End of 'Discoverability' enum.

    qRegisterMetaType< ::QLowEnergyAdvertisingData >("QLowEnergyAdvertisingData");
    qRegisterMetaType< ::QLowEnergyAdvertisingData::Discoverability >("QLowEnergyAdvertisingData::Discoverability");

    return pyType;
}
