// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QBarLegendMarkerWrapper_H
#define SBK_QBarLegendMarkerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtCharts/qbarlegendmarker.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QBarLegendMarkerWrapper : public QBarLegendMarker
{
public:
    QBarLegendMarkerWrapper(const QBarLegendMarkerWrapper &) = delete;
    QBarLegendMarkerWrapper& operator=(const QBarLegendMarkerWrapper &) = delete;
    QBarLegendMarkerWrapper(QBarLegendMarkerWrapper &&) = delete;
    QBarLegendMarkerWrapper& operator=(QBarLegendMarkerWrapper &&) = delete;

    QBarLegendMarkerWrapper(::QAbstractBarSeries * series, ::QBarSet * barset, ::QLegend * legend, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QAbstractBarSeries * series() override;
    void timerEvent(::QTimerEvent * event) override;
    ::QLegendMarker::LegendMarkerType type() override;
    ~QBarLegendMarkerWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QBarLegendMarkerWrapper_H

