// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QHorizontalStackedBarSeriesWrapper_H
#define SBK_QHorizontalStackedBarSeriesWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtCharts/qhorizontalstackedbarseries.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QHorizontalStackedBarSeriesWrapper : public QHorizontalStackedBarSeries
{
public:
    QHorizontalStackedBarSeriesWrapper(const QHorizontalStackedBarSeriesWrapper &) = delete;
    QHorizontalStackedBarSeriesWrapper& operator=(const QHorizontalStackedBarSeriesWrapper &) = delete;
    QHorizontalStackedBarSeriesWrapper(QHorizontalStackedBarSeriesWrapper &&) = delete;
    QHorizontalStackedBarSeriesWrapper& operator=(QHorizontalStackedBarSeriesWrapper &&) = delete;

    QHorizontalStackedBarSeriesWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ::QAbstractSeries::SeriesType type() const override;
    ~QHorizontalStackedBarSeriesWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#endif // SBK_QHorizontalStackedBarSeriesWrapper_H

