// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstractEventDispatcherWrapper_H
#define SBK_QAbstractEventDispatcherWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qabstracteventdispatcher.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAbstractEventDispatcherWrapper : public QAbstractEventDispatcher
{
public:
    QAbstractEventDispatcherWrapper(const QAbstractEventDispatcherWrapper &) = delete;
    QAbstractEventDispatcherWrapper& operator=(const QAbstractEventDispatcherWrapper &) = delete;
    QAbstractEventDispatcherWrapper(QAbstractEventDispatcherWrapper &&) = delete;
    QAbstractEventDispatcherWrapper& operator=(QAbstractEventDispatcherWrapper &&) = delete;

    QAbstractEventDispatcherWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void closingDown() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void interrupt() override;
    bool processEvents(::QFlags<QEventLoop::ProcessEventsFlag> flags) override;
    void registerSocketNotifier(::QSocketNotifier * notifier) override;
    void registerTimer(int timerId, qint64 interval, ::Qt::TimerType timerType, ::QObject * object) override;
    ::QList<QAbstractEventDispatcher::TimerInfo> registeredTimers(::QObject * object) const override;
    int remainingTime(int timerId) override;
    void startingUp() override;
    void timerEvent(::QTimerEvent * event) override;
    void unregisterSocketNotifier(::QSocketNotifier * notifier) override;
    bool unregisterTimer(int timerId) override;
    bool unregisterTimers(::QObject * object) override;
    void wakeUp() override;
    ~QAbstractEventDispatcherWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    // Inherited overloads, because the using keyword sux
    inline int registerTimer(qint64 interval, ::Qt::TimerType timerType, ::QObject * object) { return QAbstractEventDispatcher::registerTimer(interval, Qt::TimerType(timerType), object); }
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[19];
};

#endif // SBK_QAbstractEventDispatcherWrapper_H

