// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qcborstringresultstring_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCborStringResultString_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCborStringResultString >()))
        return -1;

    ::QCborStringResultString *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QCborStringResultString.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QCborStringResultString", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QCborStringResultString::QCborStringResultString()
    // 1: QCborStringResultString::QCborStringResultString(QCborStringResultString)
    if (numArgs == 0) {
        overloadId = 0; // QCborStringResultString()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultString_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QCborStringResultString(QCborStringResultString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QCborStringResultString()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QCborStringResultString()
                cptr = new ::QCborStringResultString();
            }
            break;
        }
        case 1: // QCborStringResultString(const QCborStringResultString &QCborStringResultString)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QCborStringResultString cppArg0_local;
            ::QCborStringResultString *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QCborStringResultString(QCborStringResultString)
                cptr = new ::QCborStringResultString(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCborStringResultString >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCborStringResultString__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCborStringResultString *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultString_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultString_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCborStringResultString_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCborStringResultString_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QCborStringResultString__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QCborStringResultString_get_data(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCborStringResultString *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultString_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppSelf->data);
    return pyOut;
}
static int Sbk_QCborStringResultString_set_data(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QCborStringResultString *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultString_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("data");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("data", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->data;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QCborStringResultString_get_status(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCborStringResultString *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultString_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QCborStreamReader::StringResultCode cppOut_local = cppSelf->status;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStreamReader_StringResultCode_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QCborStringResultString_set_status(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QCborStringResultString *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultString_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("status");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStreamReader_StringResultCode_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("status", "StringResultCode");
        return -1;
    }

    auto cppOut_local = cppSelf->status;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->status = cppOut_local;

    return 0;
}

// Getters and Setters for QCborStringResultString
static PyGetSetDef Sbk_QCborStringResultString_getsetlist[] = {
    {const_cast<char *>("data"), Sbk_QCborStringResultString_get_data, Sbk_QCborStringResultString_set_data, nullptr, nullptr},
    {const_cast<char *>("status"), Sbk_QCborStringResultString_get_status, Sbk_QCborStringResultString_set_status, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QCborStringResultString_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCborStringResultString_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCborStringResultString_Type = nullptr;
static PyTypeObject *Sbk_QCborStringResultString_TypeF(void)
{
    return _Sbk_QCborStringResultString_Type;
}

static PyType_Slot Sbk_QCborStringResultString_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCborStringResultString_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCborStringResultString_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCborStringResultString_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QCborStringResultString_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCborStringResultString_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCborStringResultString_spec = {
    "2:PySide6.QtCore.QCborStringResultString",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCborStringResultString_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QCborStringResultString_PythonToCpp_QCborStringResultString_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCborStringResultString_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QCborStringResultString_PythonToCpp_QCborStringResultString_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCborStringResultString_TypeF()))
        return QCborStringResultString_PythonToCpp_QCborStringResultString_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QCborStringResultString_PTR_CppToPython_QCborStringResultString(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const QCborStringResultString *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QCborStringResultString_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QCborStringResultString_COPY_CppToPython_QCborStringResultString(const void *cppIn)
{
    auto *source = reinterpret_cast<const QCborStringResultString *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QCborStringResultString_TypeF(), new ::QCborStringResultString(*source), true, true);
}

// Python to C++ copy conversion.
static void QCborStringResultString_PythonToCpp_QCborStringResultString_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<QCborStringResultString *>(cppOut) = *reinterpret_cast< ::QCborStringResultString *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultString_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QCborStringResultString_PythonToCpp_QCborStringResultString_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QCborStringResultString_TypeF()))
        return QCborStringResultString_PythonToCpp_QCborStringResultString_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QCborStringResultString_SignatureStrings[] = {
    "1:PySide6.QtCore.QCborStringResultString(self)",
    "0:PySide6.QtCore.QCborStringResultString(self,QCborStringResultString:PySide6.QtCore.QCborStringResultString)",
    "PySide6.QtCore.QCborStringResultString.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QCborStringResultString(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultString_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultString_IDX].type;

    Shiboken::AutoDecRef Sbk_QCborStringResultString_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QCborStringResultString_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QCborStringResultString",
        "QCborStringResultString",
        &Sbk_QCborStringResultString_spec,
        &Shiboken::callCppDestructor< ::QCborStringResultString >,
        Sbk_QCborStringResultString_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QCborStringResultString_TypeF(); // references _Sbk_QCborStringResultString_Type
    InitSignatureStrings(pyType, QCborStringResultString_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCborStringResultString_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultString_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QCborStringResultString_PythonToCpp_QCborStringResultString_PTR,
        is_QCborStringResultString_PythonToCpp_QCborStringResultString_PTR_Convertible,
        QCborStringResultString_PTR_CppToPython_QCborStringResultString,
        QCborStringResultString_COPY_CppToPython_QCborStringResultString);

    Shiboken::Conversions::registerConverterName(converter, "QCborStringResultString");
    Shiboken::Conversions::registerConverterName(converter, "QCborStringResultString*");
    Shiboken::Conversions::registerConverterName(converter, "QCborStringResultString&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCborStringResultString).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QCborStringResultString_PythonToCpp_QCborStringResultString_COPY,
        is_QCborStringResultString_PythonToCpp_QCborStringResultString_COPY_Convertible);

    qRegisterMetaType< ::QCborStringResultString >("QCborStringResultString");

    return pyType;
}
