// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qcollatorsortkey_wrapper.h"

// Argument includes
#include <qcollator.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCollatorSortKey_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCollatorSortKey >()))
        return -1;

    ::QCollatorSortKey *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QCollatorSortKey.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QCollatorSortKey", 1, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QCollatorSortKey::QCollatorSortKey(QCollatorSortKey)
    if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCollatorSortKey_IDX]), (pyArgs[0])))) {
        overloadId = 0; // QCollatorSortKey(QCollatorSortKey)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QCollatorSortKey *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // QCollatorSortKey(QCollatorSortKey)
            cptr = new ::QCollatorSortKey(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCollatorSortKey >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCollatorSortKeyFunc_compare(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCollatorSortKey *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCollatorSortKey_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QCollatorSortKey.compare";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCollatorSortKey::compare(QCollatorSortKey)const->int
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCollatorSortKey_IDX]), (pyArg)))) {
        overloadId = 0; // compare(QCollatorSortKey)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QCollatorSortKey *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // compare(QCollatorSortKey)const
            int cppResult = const_cast<const ::QCollatorSortKey *>(cppSelf)->compare(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCollatorSortKeyFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCollatorSortKey *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCollatorSortKey_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QCollatorSortKey.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCollatorSortKey::swap(QCollatorSortKey&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCollatorSortKey_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QCollatorSortKey&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QCollatorSortKey *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QCollatorSortKey&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QCollatorSortKey_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCollatorSortKey_methods[] = {
    {"compare", reinterpret_cast<PyCFunction>(Sbk_QCollatorSortKeyFunc_compare), METH_O, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QCollatorSortKeyFunc_swap), METH_O, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QCollatorSortKey_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCollatorSortKey *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCollatorSortKey_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_LT:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCollatorSortKey_IDX]), (pyArg)))) {
                // operator<(const QCollatorSortKey &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QCollatorSortKey *cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf < (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                return Shiboken::returnFromRichCompare(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QCollatorSortKey_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCollatorSortKey_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCollatorSortKey_Type = nullptr;
static PyTypeObject *Sbk_QCollatorSortKey_TypeF(void)
{
    return _Sbk_QCollatorSortKey_Type;
}

static PyType_Slot Sbk_QCollatorSortKey_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCollatorSortKey_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCollatorSortKey_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QCollatorSortKey_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCollatorSortKey_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCollatorSortKey_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCollatorSortKey_spec = {
    "2:PySide6.QtCore.QCollatorSortKey",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCollatorSortKey_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QCollatorSortKey_PythonToCpp_QCollatorSortKey_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCollatorSortKey_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QCollatorSortKey_PythonToCpp_QCollatorSortKey_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCollatorSortKey_TypeF()))
        return QCollatorSortKey_PythonToCpp_QCollatorSortKey_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QCollatorSortKey_PTR_CppToPython_QCollatorSortKey(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QCollatorSortKey *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QCollatorSortKey_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QCollatorSortKey_SignatureStrings[] = {
    "PySide6.QtCore.QCollatorSortKey(self,other:PySide6.QtCore.QCollatorSortKey)",
    "PySide6.QtCore.QCollatorSortKey.compare(self,key:PySide6.QtCore.QCollatorSortKey)->int",
    "PySide6.QtCore.QCollatorSortKey.swap(self,other:PySide6.QtCore.QCollatorSortKey)",
    nullptr}; // Sentinel

PyTypeObject *init_QCollatorSortKey(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QCollatorSortKey_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QCollatorSortKey_IDX].type;

    Shiboken::AutoDecRef Sbk_QCollatorSortKey_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QCollatorSortKey_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QCollatorSortKey",
        "QCollatorSortKey*",
        &Sbk_QCollatorSortKey_spec,
        &Shiboken::callCppDestructor< ::QCollatorSortKey >,
        Sbk_QCollatorSortKey_Type_bases.object(),
        0);
    auto *pyType = Sbk_QCollatorSortKey_TypeF(); // references _Sbk_QCollatorSortKey_Type
    InitSignatureStrings(pyType, QCollatorSortKey_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCollatorSortKey_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QCollatorSortKey_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QCollatorSortKey_PythonToCpp_QCollatorSortKey_PTR,
        is_QCollatorSortKey_PythonToCpp_QCollatorSortKey_PTR_Convertible,
        QCollatorSortKey_PTR_CppToPython_QCollatorSortKey);

    Shiboken::Conversions::registerConverterName(converter, "QCollatorSortKey");
    Shiboken::Conversions::registerConverterName(converter, "QCollatorSortKey*");
    Shiboken::Conversions::registerConverterName(converter, "QCollatorSortKey&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCollatorSortKey).name());

    qRegisterMetaType< ::QCollatorSortKey *>();

    return pyType;
}
