// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QFutureInterfaceBaseWrapper_H
#define SBK_QFutureInterfaceBaseWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qfutureinterface.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QFutureInterfaceBaseWrapper : public QFutureInterfaceBase
{
public:
    QFutureInterfaceBaseWrapper(const QFutureInterfaceBaseWrapper &) = delete;
    QFutureInterfaceBaseWrapper& operator=(const QFutureInterfaceBaseWrapper &) = delete;
    QFutureInterfaceBaseWrapper(QFutureInterfaceBaseWrapper &&) = delete;
    QFutureInterfaceBaseWrapper& operator=(QFutureInterfaceBaseWrapper &&) = delete;

    QFutureInterfaceBaseWrapper(::QFutureInterfaceBase::State initialState = QFutureInterfaceBase::State::NoState);
    QFutureInterfaceBaseWrapper(const QFutureInterfaceBase& self) : QFutureInterfaceBase(self)
    {
    }

    ~QFutureInterfaceBaseWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QFutureInterfaceBaseWrapper_H

