// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qmetaclassinfo_wrapper.h"

// Argument includes
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QMetaClassInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QMetaClassInfo >()))
        return -1;

    ::QMetaClassInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QMetaClassInfo.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QMetaClassInfo", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QMetaClassInfo::QMetaClassInfo()
    // 1: QMetaClassInfo::QMetaClassInfo(QMetaClassInfo)
    if (numArgs == 0) {
        overloadId = 0; // QMetaClassInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaClassInfo_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QMetaClassInfo(QMetaClassInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QMetaClassInfo()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QMetaClassInfo()
                cptr = new ::QMetaClassInfo();
            }
            break;
        }
        case 1: // QMetaClassInfo(const QMetaClassInfo &QMetaClassInfo)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QMetaClassInfo cppArg0_local;
            ::QMetaClassInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QMetaClassInfo(QMetaClassInfo)
                cptr = new ::QMetaClassInfo(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QMetaClassInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QMetaClassInfoFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QMetaClassInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaClassInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QMetaClassInfo.name";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            const char * cppResult = const_cast<const ::QMetaClassInfo *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QMetaClassInfoFunc_value(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QMetaClassInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaClassInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QMetaClassInfo.value";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // value()const
            const char * cppResult = const_cast<const ::QMetaClassInfo *>(cppSelf)->value();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QMetaClassInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QMetaClassInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaClassInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaClassInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QMetaClassInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QMetaClassInfo_methods[] = {
    {"name", reinterpret_cast<PyCFunction>(Sbk_QMetaClassInfoFunc_name), METH_NOARGS, nullptr},
    {"value", reinterpret_cast<PyCFunction>(Sbk_QMetaClassInfoFunc_value), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QMetaClassInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QMetaClassInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QMetaClassInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QMetaClassInfo_Type = nullptr;
static PyTypeObject *Sbk_QMetaClassInfo_TypeF(void)
{
    return _Sbk_QMetaClassInfo_Type;
}

static PyType_Slot Sbk_QMetaClassInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QMetaClassInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QMetaClassInfo_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QMetaClassInfo_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QMetaClassInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QMetaClassInfo_spec = {
    "2:PySide6.QtCore.QMetaClassInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QMetaClassInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QMetaClassInfo_PythonToCpp_QMetaClassInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QMetaClassInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QMetaClassInfo_PythonToCpp_QMetaClassInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QMetaClassInfo_TypeF()))
        return QMetaClassInfo_PythonToCpp_QMetaClassInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QMetaClassInfo_PTR_CppToPython_QMetaClassInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QMetaClassInfo *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QMetaClassInfo_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QMetaClassInfo_COPY_CppToPython_QMetaClassInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QMetaClassInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QMetaClassInfo_TypeF(), new ::QMetaClassInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void QMetaClassInfo_PythonToCpp_QMetaClassInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QMetaClassInfo *>(cppOut) = *reinterpret_cast< ::QMetaClassInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaClassInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QMetaClassInfo_PythonToCpp_QMetaClassInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QMetaClassInfo_TypeF()))
        return QMetaClassInfo_PythonToCpp_QMetaClassInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QMetaClassInfo_SignatureStrings[] = {
    "1:PySide6.QtCore.QMetaClassInfo(self)",
    "0:PySide6.QtCore.QMetaClassInfo(self,QMetaClassInfo:PySide6.QtCore.QMetaClassInfo)",
    "PySide6.QtCore.QMetaClassInfo.name(self)->char*",
    "PySide6.QtCore.QMetaClassInfo.value(self)->char*",
    "PySide6.QtCore.QMetaClassInfo.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QMetaClassInfo(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QMetaClassInfo_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QMetaClassInfo_IDX].type;

    Shiboken::AutoDecRef Sbk_QMetaClassInfo_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QMetaClassInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QMetaClassInfo",
        "QMetaClassInfo",
        &Sbk_QMetaClassInfo_spec,
        &Shiboken::callCppDestructor< ::QMetaClassInfo >,
        Sbk_QMetaClassInfo_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QMetaClassInfo_TypeF(); // references _Sbk_QMetaClassInfo_Type
    InitSignatureStrings(pyType, QMetaClassInfo_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QMetaClassInfo_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QMetaClassInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QMetaClassInfo_PythonToCpp_QMetaClassInfo_PTR,
        is_QMetaClassInfo_PythonToCpp_QMetaClassInfo_PTR_Convertible,
        QMetaClassInfo_PTR_CppToPython_QMetaClassInfo,
        QMetaClassInfo_COPY_CppToPython_QMetaClassInfo);

    Shiboken::Conversions::registerConverterName(converter, "QMetaClassInfo");
    Shiboken::Conversions::registerConverterName(converter, "QMetaClassInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QMetaClassInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QMetaClassInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QMetaClassInfo_PythonToCpp_QMetaClassInfo_COPY,
        is_QMetaClassInfo_PythonToCpp_QMetaClassInfo_COPY_Convertible);

    qRegisterMetaType< ::QMetaClassInfo >("QMetaClassInfo");

    return pyType;
}
