// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMimeDataWrapper_H
#define SBK_QMimeDataWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qmimedata.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QMimeDataWrapper : public QMimeData
{
public:
    QMimeDataWrapper(const QMimeDataWrapper &) = delete;
    QMimeDataWrapper& operator=(const QMimeDataWrapper &) = delete;
    QMimeDataWrapper(QMimeDataWrapper &&) = delete;
    QMimeDataWrapper& operator=(QMimeDataWrapper &&) = delete;

    QMimeDataWrapper();
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QStringList formats() const override;
    bool hasFormat(const ::QString & mimetype) const override;
    ::QVariant retrieveData(const ::QString & mimetype, ::QMetaType preferredType) const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QMimeDataWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10];
};

#endif // SBK_QMimeDataWrapper_H

