// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qoperatingsystemversion_wrapper.h"

// Argument includes
#include <qoperatingsystemversion.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QOperatingSystemVersion__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QOperatingSystemVersion *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QOperatingSystemVersion_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QOperatingSystemVersion_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QOperatingSystemVersion__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QOperatingSystemVersion_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QOperatingSystemVersion_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QOperatingSystemVersion__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QOperatingSystemVersion *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QOperatingSystemVersion_Type = nullptr;
static PyTypeObject *Sbk_QOperatingSystemVersion_TypeF(void)
{
    return _Sbk_QOperatingSystemVersion_Type;
}

static PyType_Slot Sbk_QOperatingSystemVersion_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QOperatingSystemVersion__repr__)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QOperatingSystemVersion_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QOperatingSystemVersion_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QOperatingSystemVersion_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QOperatingSystemVersion_spec = {
    "2:PySide6.QtCore.QOperatingSystemVersion",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QOperatingSystemVersion_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QOperatingSystemVersion_PythonToCpp_QOperatingSystemVersion_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QOperatingSystemVersion_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QOperatingSystemVersion_PythonToCpp_QOperatingSystemVersion_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QOperatingSystemVersion_TypeF()))
        return QOperatingSystemVersion_PythonToCpp_QOperatingSystemVersion_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QOperatingSystemVersion_PTR_CppToPython_QOperatingSystemVersion(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QOperatingSystemVersion *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QOperatingSystemVersion_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QOperatingSystemVersion_COPY_CppToPython_QOperatingSystemVersion(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QOperatingSystemVersion *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QOperatingSystemVersion_TypeF(), new ::QOperatingSystemVersion(*source), true, true);
}

// Python to C++ copy conversion.
static void QOperatingSystemVersion_PythonToCpp_QOperatingSystemVersion_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QOperatingSystemVersion *>(cppOut) = *reinterpret_cast< ::QOperatingSystemVersion *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QOperatingSystemVersion_PythonToCpp_QOperatingSystemVersion_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QOperatingSystemVersion_TypeF()))
        return QOperatingSystemVersion_PythonToCpp_QOperatingSystemVersion_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QOperatingSystemVersion_SignatureStrings[] = {
    "PySide6.QtCore.QOperatingSystemVersion.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QOperatingSystemVersion(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX].type;

    Shiboken::AutoDecRef Sbk_QOperatingSystemVersion_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]))));

    _Sbk_QOperatingSystemVersion_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QOperatingSystemVersion",
        "QOperatingSystemVersion",
        &Sbk_QOperatingSystemVersion_spec,
        &Shiboken::callCppDestructor< ::QOperatingSystemVersion >,
        Sbk_QOperatingSystemVersion_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QOperatingSystemVersion_TypeF(); // references _Sbk_QOperatingSystemVersion_Type
    InitSignatureStrings(pyType, QOperatingSystemVersion_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QOperatingSystemVersion_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QOperatingSystemVersion_PythonToCpp_QOperatingSystemVersion_PTR,
        is_QOperatingSystemVersion_PythonToCpp_QOperatingSystemVersion_PTR_Convertible,
        QOperatingSystemVersion_PTR_CppToPython_QOperatingSystemVersion,
        QOperatingSystemVersion_COPY_CppToPython_QOperatingSystemVersion);

    Shiboken::Conversions::registerConverterName(converter, "QOperatingSystemVersion");
    Shiboken::Conversions::registerConverterName(converter, "QOperatingSystemVersion*");
    Shiboken::Conversions::registerConverterName(converter, "QOperatingSystemVersion&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QOperatingSystemVersion).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QOperatingSystemVersion_PythonToCpp_QOperatingSystemVersion_COPY,
        is_QOperatingSystemVersion_PythonToCpp_QOperatingSystemVersion_COPY_Convertible);


    return pyType;
}

PyTypeObject *init_QOperatingSystemVersionStaticFields(PyObject *module)
{
    auto *obType = PyObject_GetAttrString(module, "QOperatingSystemVersion");
    auto *type = reinterpret_cast<PyTypeObject *>(obType);
    Shiboken::AutoDecRef dict(PepType_GetDict(type));
    PyDict_SetItemString(dict, "Windows7",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::Windows7));
    PyDict_SetItemString(dict, "Windows8",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::Windows8));
    PyDict_SetItemString(dict, "Windows8_1",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::Windows8_1));
    PyDict_SetItemString(dict, "Windows10",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::Windows10));
    PyDict_SetItemString(dict, "OSXMavericks",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::OSXMavericks));
    PyDict_SetItemString(dict, "OSXYosemite",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::OSXYosemite));
    PyDict_SetItemString(dict, "OSXElCapitan",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::OSXElCapitan));
    PyDict_SetItemString(dict, "MacOSSierra",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::MacOSSierra));
    PyDict_SetItemString(dict, "MacOSHighSierra",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::MacOSHighSierra));
    PyDict_SetItemString(dict, "MacOSMojave",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::MacOSMojave));
    PyDict_SetItemString(dict, "MacOSCatalina",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::MacOSCatalina));
    PyDict_SetItemString(dict, "MacOSBigSur",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::MacOSBigSur));
    PyDict_SetItemString(dict, "MacOSMonterey",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::MacOSMonterey));
    PyDict_SetItemString(dict, "AndroidJellyBean",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::AndroidJellyBean));
    PyDict_SetItemString(dict, "AndroidJellyBean_MR1",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::AndroidJellyBean_MR1));
    PyDict_SetItemString(dict, "AndroidJellyBean_MR2",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::AndroidJellyBean_MR2));
    PyDict_SetItemString(dict, "AndroidKitKat",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::AndroidKitKat));
    PyDict_SetItemString(dict, "AndroidLollipop",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::AndroidLollipop));
    PyDict_SetItemString(dict, "AndroidLollipop_MR1",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::AndroidLollipop_MR1));
    PyDict_SetItemString(dict, "AndroidMarshmallow",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::AndroidMarshmallow));
    PyDict_SetItemString(dict, "AndroidNougat",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::AndroidNougat));
    PyDict_SetItemString(dict, "AndroidNougat_MR1",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::AndroidNougat_MR1));
    PyDict_SetItemString(dict, "AndroidOreo",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::AndroidOreo));
    PyDict_SetItemString(dict, "AndroidOreo_MR1",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::AndroidOreo_MR1));
    PyDict_SetItemString(dict, "AndroidPie",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::AndroidPie));
    PyDict_SetItemString(dict, "Android10",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::Android10));
    PyDict_SetItemString(dict, "Android11",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersion_IDX]), &QOperatingSystemVersion::Android11));
    PyDict_SetItemString(dict, "Windows10_1809",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Windows10_1809));
    PyDict_SetItemString(dict, "Windows10_1903",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Windows10_1903));
    PyDict_SetItemString(dict, "Windows10_1909",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Windows10_1909));
    PyDict_SetItemString(dict, "Windows10_2004",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Windows10_2004));
    PyDict_SetItemString(dict, "Windows10_20H2",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Windows10_20H2));
    PyDict_SetItemString(dict, "Windows10_21H1",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Windows10_21H1));
    PyDict_SetItemString(dict, "Windows10_21H2",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Windows10_21H2));
    PyDict_SetItemString(dict, "Windows10_22H2",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Windows10_22H2));
    PyDict_SetItemString(dict, "Windows11",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Windows11));
    PyDict_SetItemString(dict, "Windows11_21H2",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Windows11_21H2));
    PyDict_SetItemString(dict, "Windows11_22H2",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Windows11_22H2));
    PyDict_SetItemString(dict, "Android12",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Android12));
    PyDict_SetItemString(dict, "Android12L",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Android12L));
    PyDict_SetItemString(dict, "Android13",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::Android13));
    PyDict_SetItemString(dict, "MacOSVentura",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QOperatingSystemVersionBase_IDX]), &QOperatingSystemVersion::MacOSVentura));
    return type;
}
