// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSocketNotifierWrapper_H
#define SBK_QSocketNotifierWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qsocketnotifier.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSocketNotifierWrapper : public QSocketNotifier
{
public:
    QSocketNotifierWrapper(const QSocketNotifierWrapper &) = delete;
    QSocketNotifierWrapper& operator=(const QSocketNotifierWrapper &) = delete;
    QSocketNotifierWrapper(QSocketNotifierWrapper &&) = delete;
    QSocketNotifierWrapper& operator=(QSocketNotifierWrapper &&) = delete;

    QSocketNotifierWrapper(::QSocketNotifier::Type arg__1, ::QObject * parent = nullptr);
    QSocketNotifierWrapper(::qintptr socket, ::QSocketNotifier::Type arg__2, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QSocketNotifierWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QSocketNotifierWrapper_H

