// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qxmlstreamentitydeclaration_wrapper.h"

// Argument includes
#include <QStringView>
#include <qxmlstream.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QXmlStreamEntityDeclaration_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QXmlStreamEntityDeclaration >()))
        return -1;

    ::QXmlStreamEntityDeclaration *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QXmlStreamEntityDeclaration.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QXmlStreamEntityDeclaration", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QXmlStreamEntityDeclaration::QXmlStreamEntityDeclaration()
    // 1: QXmlStreamEntityDeclaration::QXmlStreamEntityDeclaration(QXmlStreamEntityDeclaration)
    if (numArgs == 0) {
        overloadId = 0; // QXmlStreamEntityDeclaration()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QXmlStreamEntityDeclaration(QXmlStreamEntityDeclaration)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QXmlStreamEntityDeclaration()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QXmlStreamEntityDeclaration()
                cptr = new ::QXmlStreamEntityDeclaration();
            }
            break;
        }
        case 1: // QXmlStreamEntityDeclaration(const QXmlStreamEntityDeclaration &QXmlStreamEntityDeclaration)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QXmlStreamEntityDeclaration cppArg0_local;
            ::QXmlStreamEntityDeclaration *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QXmlStreamEntityDeclaration(QXmlStreamEntityDeclaration)
                cptr = new ::QXmlStreamEntityDeclaration(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QXmlStreamEntityDeclaration >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QXmlStreamEntityDeclarationFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QXmlStreamEntityDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QXmlStreamEntityDeclaration.name";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            QStringView cppResult = const_cast<const ::QXmlStreamEntityDeclaration *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringView_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QXmlStreamEntityDeclarationFunc_notationName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QXmlStreamEntityDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QXmlStreamEntityDeclaration.notationName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // notationName()const
            QStringView cppResult = const_cast<const ::QXmlStreamEntityDeclaration *>(cppSelf)->notationName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringView_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QXmlStreamEntityDeclarationFunc_publicId(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QXmlStreamEntityDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QXmlStreamEntityDeclaration.publicId";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // publicId()const
            QStringView cppResult = const_cast<const ::QXmlStreamEntityDeclaration *>(cppSelf)->publicId();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringView_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QXmlStreamEntityDeclarationFunc_systemId(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QXmlStreamEntityDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QXmlStreamEntityDeclaration.systemId";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // systemId()const
            QStringView cppResult = const_cast<const ::QXmlStreamEntityDeclaration *>(cppSelf)->systemId();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringView_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QXmlStreamEntityDeclarationFunc_value(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QXmlStreamEntityDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QXmlStreamEntityDeclaration.value";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // value()const
            QStringView cppResult = const_cast<const ::QXmlStreamEntityDeclaration *>(cppSelf)->value();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringView_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QXmlStreamEntityDeclaration__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QXmlStreamEntityDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QXmlStreamEntityDeclaration_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QXmlStreamEntityDeclaration_methods[] = {
    {"name", reinterpret_cast<PyCFunction>(Sbk_QXmlStreamEntityDeclarationFunc_name), METH_NOARGS, nullptr},
    {"notationName", reinterpret_cast<PyCFunction>(Sbk_QXmlStreamEntityDeclarationFunc_notationName), METH_NOARGS, nullptr},
    {"publicId", reinterpret_cast<PyCFunction>(Sbk_QXmlStreamEntityDeclarationFunc_publicId), METH_NOARGS, nullptr},
    {"systemId", reinterpret_cast<PyCFunction>(Sbk_QXmlStreamEntityDeclarationFunc_systemId), METH_NOARGS, nullptr},
    {"value", reinterpret_cast<PyCFunction>(Sbk_QXmlStreamEntityDeclarationFunc_value), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QXmlStreamEntityDeclaration__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QXmlStreamEntityDeclaration_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QXmlStreamEntityDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX]), (pyArg)))) {
                // operator!=(const QXmlStreamEntityDeclaration &other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QXmlStreamEntityDeclaration cppArg0_local;
                ::QXmlStreamEntityDeclaration *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX]), (pyArg)))) {
                // operator==(const QXmlStreamEntityDeclaration &other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QXmlStreamEntityDeclaration cppArg0_local;
                ::QXmlStreamEntityDeclaration *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QXmlStreamEntityDeclaration_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QXmlStreamEntityDeclaration_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QXmlStreamEntityDeclaration_Type = nullptr;
static PyTypeObject *Sbk_QXmlStreamEntityDeclaration_TypeF(void)
{
    return _Sbk_QXmlStreamEntityDeclaration_Type;
}

static PyType_Slot Sbk_QXmlStreamEntityDeclaration_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QXmlStreamEntityDeclaration_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QXmlStreamEntityDeclaration_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QXmlStreamEntityDeclaration_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QXmlStreamEntityDeclaration_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QXmlStreamEntityDeclaration_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QXmlStreamEntityDeclaration_spec = {
    "2:PySide6.QtCore.QXmlStreamEntityDeclaration",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QXmlStreamEntityDeclaration_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QXmlStreamEntityDeclaration_PythonToCpp_QXmlStreamEntityDeclaration_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QXmlStreamEntityDeclaration_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QXmlStreamEntityDeclaration_PythonToCpp_QXmlStreamEntityDeclaration_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QXmlStreamEntityDeclaration_TypeF()))
        return QXmlStreamEntityDeclaration_PythonToCpp_QXmlStreamEntityDeclaration_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QXmlStreamEntityDeclaration_PTR_CppToPython_QXmlStreamEntityDeclaration(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QXmlStreamEntityDeclaration *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QXmlStreamEntityDeclaration_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QXmlStreamEntityDeclaration_COPY_CppToPython_QXmlStreamEntityDeclaration(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QXmlStreamEntityDeclaration *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QXmlStreamEntityDeclaration_TypeF(), new ::QXmlStreamEntityDeclaration(*source), true, true);
}

// Python to C++ copy conversion.
static void QXmlStreamEntityDeclaration_PythonToCpp_QXmlStreamEntityDeclaration_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QXmlStreamEntityDeclaration *>(cppOut) = *reinterpret_cast< ::QXmlStreamEntityDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QXmlStreamEntityDeclaration_PythonToCpp_QXmlStreamEntityDeclaration_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QXmlStreamEntityDeclaration_TypeF()))
        return QXmlStreamEntityDeclaration_PythonToCpp_QXmlStreamEntityDeclaration_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QXmlStreamEntityDeclaration_SignatureStrings[] = {
    "1:PySide6.QtCore.QXmlStreamEntityDeclaration(self)",
    "0:PySide6.QtCore.QXmlStreamEntityDeclaration(self,QXmlStreamEntityDeclaration:PySide6.QtCore.QXmlStreamEntityDeclaration)",
    "PySide6.QtCore.QXmlStreamEntityDeclaration.name(self)->QStringView",
    "PySide6.QtCore.QXmlStreamEntityDeclaration.notationName(self)->QStringView",
    "PySide6.QtCore.QXmlStreamEntityDeclaration.publicId(self)->QStringView",
    "PySide6.QtCore.QXmlStreamEntityDeclaration.systemId(self)->QStringView",
    "PySide6.QtCore.QXmlStreamEntityDeclaration.value(self)->QStringView",
    "PySide6.QtCore.QXmlStreamEntityDeclaration.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QXmlStreamEntityDeclaration(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX].type;

    Shiboken::AutoDecRef Sbk_QXmlStreamEntityDeclaration_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QXmlStreamEntityDeclaration_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QXmlStreamEntityDeclaration",
        "QXmlStreamEntityDeclaration",
        &Sbk_QXmlStreamEntityDeclaration_spec,
        &Shiboken::callCppDestructor< ::QXmlStreamEntityDeclaration >,
        Sbk_QXmlStreamEntityDeclaration_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QXmlStreamEntityDeclaration_TypeF(); // references _Sbk_QXmlStreamEntityDeclaration_Type
    InitSignatureStrings(pyType, QXmlStreamEntityDeclaration_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QXmlStreamEntityDeclaration_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamEntityDeclaration_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QXmlStreamEntityDeclaration_PythonToCpp_QXmlStreamEntityDeclaration_PTR,
        is_QXmlStreamEntityDeclaration_PythonToCpp_QXmlStreamEntityDeclaration_PTR_Convertible,
        QXmlStreamEntityDeclaration_PTR_CppToPython_QXmlStreamEntityDeclaration,
        QXmlStreamEntityDeclaration_COPY_CppToPython_QXmlStreamEntityDeclaration);

    Shiboken::Conversions::registerConverterName(converter, "QXmlStreamEntityDeclaration");
    Shiboken::Conversions::registerConverterName(converter, "QXmlStreamEntityDeclaration*");
    Shiboken::Conversions::registerConverterName(converter, "QXmlStreamEntityDeclaration&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QXmlStreamEntityDeclaration).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QXmlStreamEntityDeclaration_PythonToCpp_QXmlStreamEntityDeclaration_COPY,
        is_QXmlStreamEntityDeclaration_PythonToCpp_QXmlStreamEntityDeclaration_COPY_Convertible);

    qRegisterMetaType< ::QXmlStreamEntityDeclaration >("QXmlStreamEntityDeclaration");

    return pyType;
}
