// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDesignerCustomWidgetCollectionInterfaceWrapper_H
#define SBK_QDesignerCustomWidgetCollectionInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtUiPlugin/customwidget.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QDesignerCustomWidgetCollectionInterfaceWrapper : public QDesignerCustomWidgetCollectionInterface
{
public:
    QDesignerCustomWidgetCollectionInterfaceWrapper(const QDesignerCustomWidgetCollectionInterfaceWrapper &) = delete;
    QDesignerCustomWidgetCollectionInterfaceWrapper& operator=(const QDesignerCustomWidgetCollectionInterfaceWrapper &) = delete;
    QDesignerCustomWidgetCollectionInterfaceWrapper(QDesignerCustomWidgetCollectionInterfaceWrapper &&) = delete;
    QDesignerCustomWidgetCollectionInterfaceWrapper& operator=(QDesignerCustomWidgetCollectionInterfaceWrapper &&) = delete;

    QDesignerCustomWidgetCollectionInterfaceWrapper();
    ::QList<QDesignerCustomWidgetInterface*> customWidgets() const override;
    ~QDesignerCustomWidgetCollectionInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QDesignerCustomWidgetCollectionInterfaceWrapper_H

