// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtdesigner_python.h"

// main header
#include "qdesignerwidgetboxinterface_category_wrapper.h"

// Argument includes
#include <QString>
#include <QtDesigner/abstractwidgetbox.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDesignerWidgetBoxInterface_Category_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QDesignerWidgetBoxInterface::Category >()))
        return -1;

    ::QDesignerWidgetBoxInterface::Category *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:Category", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: Category::Category(QDesignerWidgetBoxInterface::Category)
    // 1: Category::Category(const QString&=,QDesignerWidgetBoxInterface::Category::Type=)
    if (numArgs == 0) {
        overloadId = 1; // Category(QString,QDesignerWidgetBoxInterface::Category::Type)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // Category(QString,QDesignerWidgetBoxInterface::Category::Type)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_Type_IDX])))->converter, (pyArgs[1])))) {
            overloadId = 1; // Category(QString,QDesignerWidgetBoxInterface::Category::Type)
        }
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), (pyArgs[0])))) {
        overloadId = 0; // Category(QDesignerWidgetBoxInterface::Category)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // Category(const QDesignerWidgetBoxInterface::Category &Category)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDesignerWidgetBoxInterface::Category cppArg0_local;
            ::QDesignerWidgetBoxInterface::Category *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // Category(QDesignerWidgetBoxInterface::Category)
                cptr = new ::QDesignerWidgetBoxInterface::Category(*cppArg0);
            }
            break;
        }
        case 1: // Category(const QString &aname, QDesignerWidgetBoxInterface::Category::Type atype)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_aname = Shiboken::String::createStaticString("aname");
                if (PyDict_Contains(kwds, key_aname) != 0) {
                    value = PyDict_GetItem(kwds, key_aname);
                    if (value != nullptr && pyArgs[0] != nullptr ) {
                        errInfo.reset(key_aname);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[0] = value;
                        if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_aname);
                }
                static PyObject *const key_atype = Shiboken::String::createStaticString("atype");
                if (PyDict_Contains(kwds, key_atype) != 0) {
                    value = PyDict_GetItem(kwds, key_atype);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_atype);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_Type_IDX])))->converter, (pyArgs[1]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_atype);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            ::QString cppArg0 = QString();
            if (pythonToCpp[0])
                pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QDesignerWidgetBoxInterface::Category::Type cppArg1(QDesignerWidgetBoxInterface::Category::Type::Default);
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // Category(QString,QDesignerWidgetBoxInterface::Category::Type)
                cptr = new ::QDesignerWidgetBoxInterface::Category(cppArg0, cppArg1);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QDesignerWidgetBoxInterface::Category >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_CategoryFunc_addWidget(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Category *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.addWidget";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Category::addWidget(QDesignerWidgetBoxInterface::Widget)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), (pyArg)))) {
        overloadId = 0; // addWidget(QDesignerWidgetBoxInterface::Widget)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QDesignerWidgetBoxInterface::Widget cppArg0_local;
        ::QDesignerWidgetBoxInterface::Widget *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // addWidget(QDesignerWidgetBoxInterface::Widget)
            cppSelf->addWidget(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_CategoryFunc_isNull(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Category *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.isNull";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isNull()const
            bool cppResult = const_cast<const ::QDesignerWidgetBoxInterface::Category *>(cppSelf)->isNull();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_CategoryFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Category *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.name";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            QString cppResult = const_cast<const ::QDesignerWidgetBoxInterface::Category *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_CategoryFunc_removeWidget(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Category *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.removeWidget";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Category::removeWidget(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // removeWidget(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // removeWidget(int)
            cppSelf->removeWidget(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_CategoryFunc_setName(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Category *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.setName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Category::setName(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setName(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setName(QString)
            cppSelf->setName(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_CategoryFunc_setType(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Category *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.setType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Category::setType(QDesignerWidgetBoxInterface::Category::Type)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_Type_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setType(QDesignerWidgetBoxInterface::Category::Type)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QDesignerWidgetBoxInterface::Category::Type cppArg0{QDesignerWidgetBoxInterface::Category::Default};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setType(QDesignerWidgetBoxInterface::Category::Type)
            cppSelf->setType(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_CategoryFunc_type(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Category *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.type";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // type()const
            QDesignerWidgetBoxInterface::Category::Type cppResult = const_cast<const ::QDesignerWidgetBoxInterface::Category *>(cppSelf)->type();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_Type_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_CategoryFunc_widget(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Category *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.widget";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Category::widget(int)const->QDesignerWidgetBoxInterface::Widget
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // widget(int)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // widget(int)const
            QDesignerWidgetBoxInterface::Widget cppResult = const_cast<const ::QDesignerWidgetBoxInterface::Category *>(cppSelf)->widget(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_CategoryFunc_widgetCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Category *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.widgetCount";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // widgetCount()const
            int cppResult = const_cast<const ::QDesignerWidgetBoxInterface::Category *>(cppSelf)->widgetCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_Category__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDesignerWidgetBoxInterface::Category *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDesignerWidgetBoxInterface_Category_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QDesignerWidgetBoxInterface_Category_EnumFlagInfo[] = {
    "Type:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDesignerWidgetBoxInterface_Category_methods[] = {
    {"addWidget", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_CategoryFunc_addWidget), METH_O, nullptr},
    {"isNull", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_CategoryFunc_isNull), METH_NOARGS, nullptr},
    {"name", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_CategoryFunc_name), METH_NOARGS, nullptr},
    {"removeWidget", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_CategoryFunc_removeWidget), METH_O, nullptr},
    {"setName", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_CategoryFunc_setName), METH_O, nullptr},
    {"setType", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_CategoryFunc_setType), METH_O, nullptr},
    {"type", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_CategoryFunc_type), METH_NOARGS, nullptr},
    {"widget", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_CategoryFunc_widget), METH_O, nullptr},
    {"widgetCount", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_CategoryFunc_widgetCount), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_Category__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_QDesignerWidgetBoxInterface_Category___nb_bool(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return -1;
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Category *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return !cppSelf->isNull() ? 1 : 0;
}

} // extern "C"

static int Sbk_QDesignerWidgetBoxInterface_Category_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDesignerWidgetBoxInterface_Category_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDesignerWidgetBoxInterface_Category_Type = nullptr;
static PyTypeObject *Sbk_QDesignerWidgetBoxInterface_Category_TypeF(void)
{
    return _Sbk_QDesignerWidgetBoxInterface_Category_Type;
}

static PyType_Slot Sbk_QDesignerWidgetBoxInterface_Category_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDesignerWidgetBoxInterface_Category_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDesignerWidgetBoxInterface_Category_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDesignerWidgetBoxInterface_Category_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDesignerWidgetBoxInterface_Category_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_bool,        reinterpret_cast<void *>(Sbk_QDesignerWidgetBoxInterface_Category___nb_bool)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDesignerWidgetBoxInterface_Category_spec = {
    "2:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDesignerWidgetBoxInterface_Category_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QDesignerWidgetBoxInterface_Category_Type(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QDesignerWidgetBoxInterface::Category::Type>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QDesignerWidgetBoxInterface::Category::Type *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QDesignerWidgetBoxInterface_Category_Type_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_Type_IDX])))
        return Enum_PythonToCpp_QDesignerWidgetBoxInterface_Category_Type;
    return {};
}
static PyObject *QDesignerWidgetBoxInterface_Category_Type_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QDesignerWidgetBoxInterface::Category::Type *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_Type_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void Category_PythonToCpp_Category_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDesignerWidgetBoxInterface_Category_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_Category_PythonToCpp_Category_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDesignerWidgetBoxInterface_Category_TypeF()))
        return Category_PythonToCpp_Category_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *Category_PTR_CppToPython_Category(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QDesignerWidgetBoxInterface::Category *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QDesignerWidgetBoxInterface_Category_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *Category_COPY_CppToPython_Category(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QDesignerWidgetBoxInterface::Category *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QDesignerWidgetBoxInterface_Category_TypeF(), new ::QDesignerWidgetBoxInterface::Category(*source), true, true);
}

// Python to C++ copy conversion.
static void Category_PythonToCpp_Category_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDesignerWidgetBoxInterface::Category *>(cppOut) = *reinterpret_cast< ::QDesignerWidgetBoxInterface::Category *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_Category_PythonToCpp_Category_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QDesignerWidgetBoxInterface_Category_TypeF()))
        return Category_PythonToCpp_Category_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QDesignerWidgetBoxInterface_Category_SignatureStrings[] = {
    "1:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category(self,Category:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category)",
    "0:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category(self,aname:QString=QString(),atype:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.Type=QDesignerWidgetBoxInterface.Category.Type.Default)",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.addWidget(self,awidget:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget)",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.isNull(self)->bool",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.name(self)->QString",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.removeWidget(self,idx:int)",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.setName(self,aname:QString)",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.setType(self,atype:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.Type)",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.type(self)->PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.Type",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.widget(self,idx:int)->PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.widgetCount(self)->int",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QDesignerWidgetBoxInterface_Category(PyObject *enclosingClass)
{
    if (SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX].type != nullptr)
        return SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX].type;

    Shiboken::AutoDecRef Sbk_QDesignerWidgetBoxInterface_Category_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QDesignerWidgetBoxInterface_Category_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "Category",
        "QDesignerWidgetBoxInterface::Category",
        &Sbk_QDesignerWidgetBoxInterface_Category_spec,
        &Shiboken::callCppDestructor< ::QDesignerWidgetBoxInterface::Category >,
        Sbk_QDesignerWidgetBoxInterface_Category_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QDesignerWidgetBoxInterface_Category_TypeF(); // references _Sbk_QDesignerWidgetBoxInterface_Category_Type
    InitSignatureStrings(pyType, QDesignerWidgetBoxInterface_Category_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDesignerWidgetBoxInterface_Category_PropertyStrings);
    SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        Category_PythonToCpp_Category_PTR,
        is_Category_PythonToCpp_Category_PTR_Convertible,
        Category_PTR_CppToPython_Category,
        Category_COPY_CppToPython_Category);

    Shiboken::Conversions::registerConverterName(converter, "QDesignerWidgetBoxInterface::Category");
    Shiboken::Conversions::registerConverterName(converter, "QDesignerWidgetBoxInterface::Category*");
    Shiboken::Conversions::registerConverterName(converter, "QDesignerWidgetBoxInterface::Category&");
    Shiboken::Conversions::registerConverterName(converter, "Category");
    Shiboken::Conversions::registerConverterName(converter, "Category*");
    Shiboken::Conversions::registerConverterName(converter, "Category&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDesignerWidgetBoxInterface::Category).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        Category_PythonToCpp_Category_COPY,
        is_Category_PythonToCpp_Category_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QDesignerWidgetBoxInterface_Category_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Type'.
    const char *Type_Initializer[] = {
        "Default",
        "Scratchpad",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Type_InitializerValues[] = {
        uint8_t(QDesignerWidgetBoxInterface::Category::Type::Default),   //  0x00  0
        uint8_t(QDesignerWidgetBoxInterface::Category::Type::Scratchpad) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QDesignerWidgetBoxInterface_Category_TypeF(),
        "2:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Category.Type",
        Type_Initializer, Type_InitializerValues);
    SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Category_Type_IDX].type = EType;
    // Register converter for enum 'QDesignerWidgetBoxInterface::Category::Type'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QDesignerWidgetBoxInterface_Category_Type_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QDesignerWidgetBoxInterface_Category_Type,
            is_Enum_PythonToCpp_QDesignerWidgetBoxInterface_Category_Type_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QDesignerWidgetBoxInterface::Category::Type");
        Shiboken::Conversions::registerConverterName(converter, "Category::Type");
        Shiboken::Conversions::registerConverterName(converter, "Type");
    }
    // End of 'Type' enum.

    qRegisterMetaType< ::QDesignerWidgetBoxInterface::Category >("Category");
    qRegisterMetaType< ::QDesignerWidgetBoxInterface::Category >("QDesignerWidgetBoxInterface::Category");
    qRegisterMetaType< ::QDesignerWidgetBoxInterface::Category::Type >("Category::Type");
    qRegisterMetaType< ::QDesignerWidgetBoxInterface::Category::Type >("QDesignerWidgetBoxInterface::Category::Type");

    return pyType;
}
