// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QFormBuilderWrapper_H
#define SBK_QFormBuilderWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/formbuilder.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QFormBuilderWrapper : public QFormBuilder
{
public:
    QFormBuilderWrapper(const QFormBuilderWrapper &) = delete;
    QFormBuilderWrapper& operator=(const QFormBuilderWrapper &) = delete;
    QFormBuilderWrapper(QFormBuilderWrapper &&) = delete;
    QFormBuilderWrapper& operator=(QFormBuilderWrapper &&) = delete;

    QFormBuilderWrapper();
    void addMenuAction(::QAction * action) override;
    bool checkProperty(::QObject * obj, const ::QString & prop) const override;
    ::QAction * createAction(::QObject * parent, const ::QString & name) override;
    ::QActionGroup * createActionGroup(::QObject * parent, const ::QString & name) override;
    ::QLayout * createLayout(const ::QString & layoutName, ::QObject * parent, const ::QString & name) override;
    ::QWidget * createWidget(const ::QString & widgetName, ::QWidget * parentWidget, const ::QString & name) override;
    ::QWidget * load(::QIODevice * dev, ::QWidget * parentWidget = nullptr) override;
    void save(::QIODevice * dev, ::QWidget * widget) override;
    void updateCustomWidgets() override;
    ~QFormBuilderWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QFormBuilderWrapper_H

