// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_Q3DSceneWrapper_H
#define SBK_Q3DSceneWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGraphs/q3dscene.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class Q3DSceneWrapper : public Q3DScene
{
public:
    Q3DSceneWrapper(const Q3DSceneWrapper &) = delete;
    Q3DSceneWrapper& operator=(const Q3DSceneWrapper &) = delete;
    Q3DSceneWrapper(Q3DSceneWrapper &&) = delete;
    Q3DSceneWrapper& operator=(Q3DSceneWrapper &&) = delete;

    Q3DSceneWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~Q3DSceneWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_Q3DSceneWrapper_H

