// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCustom3DItemWrapper_H
#define SBK_QCustom3DItemWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGraphs/qcustom3ditem.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QCustom3DItemWrapper : public QCustom3DItem
{
public:
    QCustom3DItemWrapper(const QCustom3DItemWrapper &) = delete;
    QCustom3DItemWrapper& operator=(const QCustom3DItemWrapper &) = delete;
    QCustom3DItemWrapper(QCustom3DItemWrapper &&) = delete;
    QCustom3DItemWrapper& operator=(QCustom3DItemWrapper &&) = delete;

    QCustom3DItemWrapper(::QObject * parent = nullptr);
    QCustom3DItemWrapper(const ::QString & meshFile, const ::QVector3D & position, const ::QVector3D & scaling, const ::QQuaternion & rotation, const ::QImage & texture, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QCustom3DItemWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QCustom3DItemWrapper_H

