// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleActionInterfaceWrapper_H
#define SBK_QAccessibleActionInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAccessibleActionInterfaceWrapper : public QAccessibleActionInterface
{
public:
    QAccessibleActionInterfaceWrapper(const QAccessibleActionInterfaceWrapper &) = delete;
    QAccessibleActionInterfaceWrapper& operator=(const QAccessibleActionInterfaceWrapper &) = delete;
    QAccessibleActionInterfaceWrapper(QAccessibleActionInterfaceWrapper &&) = delete;
    QAccessibleActionInterfaceWrapper& operator=(QAccessibleActionInterfaceWrapper &&) = delete;

    QAccessibleActionInterfaceWrapper();
    ::QStringList actionNames() const override;
    void doAction(const ::QString & actionName) override;
    ::QStringList keyBindingsForAction(const ::QString & actionName) const override;
    ::QString localizedActionDescription(const ::QString & name) const override;
    ::QString localizedActionName(const ::QString & name) const override;
    ~QAccessibleActionInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[5];
};

#endif // SBK_QAccessibleActionInterfaceWrapper_H

