// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleEditableTextInterfaceWrapper_H
#define SBK_QAccessibleEditableTextInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAccessibleEditableTextInterfaceWrapper : public QAccessibleEditableTextInterface
{
public:
    QAccessibleEditableTextInterfaceWrapper(const QAccessibleEditableTextInterfaceWrapper &) = delete;
    QAccessibleEditableTextInterfaceWrapper& operator=(const QAccessibleEditableTextInterfaceWrapper &) = delete;
    QAccessibleEditableTextInterfaceWrapper(QAccessibleEditableTextInterfaceWrapper &&) = delete;
    QAccessibleEditableTextInterfaceWrapper& operator=(QAccessibleEditableTextInterfaceWrapper &&) = delete;

    QAccessibleEditableTextInterfaceWrapper();
    void deleteText(int startOffset, int endOffset) override;
    void insertText(int offset, const ::QString & text) override;
    void replaceText(int startOffset, int endOffset, const ::QString & text) override;
    ~QAccessibleEditableTextInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3];
};

#endif // SBK_QAccessibleEditableTextInterfaceWrapper_H

