// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleInterfaceWrapper_H
#define SBK_QAccessibleInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAccessibleInterfaceWrapper : public QAccessibleInterface
{
public:
    QAccessibleInterfaceWrapper(const QAccessibleInterfaceWrapper &) = delete;
    QAccessibleInterfaceWrapper& operator=(const QAccessibleInterfaceWrapper &) = delete;
    QAccessibleInterfaceWrapper(QAccessibleInterfaceWrapper &&) = delete;
    QAccessibleInterfaceWrapper& operator=(QAccessibleInterfaceWrapper &&) = delete;

    QAccessibleInterfaceWrapper();
    ::QColor backgroundColor() const override;
    ::QAccessibleInterface * child(int index) const override;
    ::QAccessibleInterface * childAt(int x, int y) const override;
    int childCount() const override;
    ::QAccessibleInterface * focusChild() const override;
    ::QColor foregroundColor() const override;
    int indexOfChild(const ::QAccessibleInterface * arg__1) const override;
    void * interface_cast(::QAccessible::InterfaceType arg__1) override;
    bool isValid() const override;
    ::QObject * object() const override;
    ::QAccessibleInterface * parent() const override;
    ::QRect rect() const override;
    ::QList<std::pair< QAccessibleInterface*,QFlags<QAccessible::RelationFlag>>> relations(::QFlags<QAccessible::RelationFlag> match = QAccessible::AllRelations) const override;
    ::QAccessible::Role role() const override;
    void setText(::QAccessible::Text t, const ::QString & text) override;
    ::QAccessible::State state() const override;
    ::QString text(::QAccessible::Text t) const override;
    void virtual_hook(int id, void * data) override;
    ::QWindow * window() const override;
    ~QAccessibleInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[19];
};

#endif // SBK_QAccessibleInterfaceWrapper_H

