// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleTextInterfaceWrapper_H
#define SBK_QAccessibleTextInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAccessibleTextInterfaceWrapper : public QAccessibleTextInterface
{
public:
    QAccessibleTextInterfaceWrapper(const QAccessibleTextInterfaceWrapper &) = delete;
    QAccessibleTextInterfaceWrapper& operator=(const QAccessibleTextInterfaceWrapper &) = delete;
    QAccessibleTextInterfaceWrapper(QAccessibleTextInterfaceWrapper &&) = delete;
    QAccessibleTextInterfaceWrapper& operator=(QAccessibleTextInterfaceWrapper &&) = delete;

    QAccessibleTextInterfaceWrapper();
    void addSelection(int startOffset, int endOffset) override;
    ::QString attributes(int offset, int * startOffset, int * endOffset) const override;
    int characterCount() const override;
    ::QRect characterRect(int offset) const override;
    int cursorPosition() const override;
    int offsetAtPoint(const ::QPoint & point) const override;
    void removeSelection(int selectionIndex) override;
    void scrollToSubstring(int startIndex, int endIndex) override;
    void selection(int selectionIndex, int * startOffset, int * endOffset) const override;
    int selectionCount() const override;
    void setCursorPosition(int position) override;
    void setSelection(int selectionIndex, int startOffset, int endOffset) override;
    ::QString text(int startOffset, int endOffset) const override;
    ::QString textAfterOffset(int offset, ::QAccessible::TextBoundaryType boundaryType, int * startOffset, int * endOffset) const override;
    ::QString textAtOffset(int offset, ::QAccessible::TextBoundaryType boundaryType, int * startOffset, int * endOffset) const override;
    ::QString textBeforeOffset(int offset, ::QAccessible::TextBoundaryType boundaryType, int * startOffset, int * endOffset) const override;
    ~QAccessibleTextInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[16];
};

#endif // SBK_QAccessibleTextInterfaceWrapper_H

