// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCloseEventWrapper_H
#define SBK_QCloseEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QCloseEventWrapper : public QCloseEvent
{
public:
    QCloseEventWrapper(const QCloseEventWrapper &) = delete;
    QCloseEventWrapper& operator=(const QCloseEventWrapper &) = delete;
    QCloseEventWrapper(QCloseEventWrapper &&) = delete;
    QCloseEventWrapper& operator=(QCloseEventWrapper &&) = delete;

    QCloseEventWrapper();
    QCloseEventWrapper(const QCloseEvent& self) : QCloseEvent(self)
    {
    }

    ::QCloseEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QCloseEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QCloseEventWrapper_H

