// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMoveEventWrapper_H
#define SBK_QMoveEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QMoveEventWrapper : public QMoveEvent
{
public:
    QMoveEventWrapper(const QMoveEventWrapper &) = delete;
    QMoveEventWrapper& operator=(const QMoveEventWrapper &) = delete;
    QMoveEventWrapper(QMoveEventWrapper &&) = delete;
    QMoveEventWrapper& operator=(QMoveEventWrapper &&) = delete;

    QMoveEventWrapper(const QMoveEvent& self) : QMoveEvent(self)
    {
    }

    QMoveEventWrapper(const ::QPoint & pos, const ::QPoint & oldPos);
    ::QMoveEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QMoveEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QMoveEventWrapper_H

