// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QNativeGestureEventWrapper_H
#define SBK_QNativeGestureEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QNativeGestureEventWrapper : public QNativeGestureEvent
{
public:
    QNativeGestureEventWrapper(const QNativeGestureEventWrapper &) = delete;
    QNativeGestureEventWrapper& operator=(const QNativeGestureEventWrapper &) = delete;
    QNativeGestureEventWrapper(QNativeGestureEventWrapper &&) = delete;
    QNativeGestureEventWrapper& operator=(QNativeGestureEventWrapper &&) = delete;

    QNativeGestureEventWrapper(::Qt::NativeGestureType type, const ::QPointingDevice * dev, const ::QPointF & localPos, const ::QPointF & scenePos, const ::QPointF & globalPos, qreal value, quint64 sequenceId, quint64 intArgument);
    QNativeGestureEventWrapper(::Qt::NativeGestureType type, const ::QPointingDevice * dev, int fingerCount, const ::QPointF & localPos, const ::QPointF & scenePos, const ::QPointF & globalPos, qreal value, const ::QPointF & delta, quint64 sequenceId = UINT64_MAX);
    QNativeGestureEventWrapper(const QNativeGestureEvent& self) : QNativeGestureEvent(self)
    {
    }

    ::QNativeGestureEvent * clone() const override;
    bool isBeginEvent() const override;
    bool isEndEvent() const override;
    bool isUpdateEvent() const override;
    void setAccepted(bool accepted) override;
    void setTimestamp(quint64 timestamp) override;
    ~QNativeGestureEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[6];
};

#endif // SBK_QNativeGestureEventWrapper_H

