// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qnativeinterface_wrapper.h"

// inner classes
#include "qnativeinterface_qx11application_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_QNativeInterface_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QNativeInterface_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QNativeInterface_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QNativeInterface_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QNativeInterface_Type = nullptr;
static PyTypeObject *Sbk_QNativeInterface_TypeF(void)
{
    return _Sbk_QNativeInterface_Type;
}

static PyType_Slot Sbk_QNativeInterface_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QNativeInterface_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QNativeInterface_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QNativeInterface_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QNativeInterface_spec = {
    "2:PySide6.QtGui.QNativeInterface",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QNativeInterface_slots
};

} //extern "C"

// Type conversion functions.

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtGuiQNativeInterface_SignatureStrings[] = {
    nullptr}; // Sentinel

PyTypeObject *init_QtGuiQNativeInterface(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QtGuiQNativeInterface_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QtGuiQNativeInterface_IDX].type;

    Shiboken::AutoDecRef Sbk_QNativeInterface_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QNativeInterface_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QNativeInterface",
        "QNativeInterface",
        &Sbk_QNativeInterface_spec,
        nullptr,
        Sbk_QNativeInterface_Type_bases.object(),
        0);
    auto *pyType = Sbk_QNativeInterface_TypeF(); // references _Sbk_QNativeInterface_Type
    InitSignatureStrings(pyType, QtGuiQNativeInterface_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QNativeInterface_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QtGuiQNativeInterface_IDX].type = pyType;



    return pyType;
}
