// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPagedPaintDeviceWrapper_H
#define SBK_QPagedPaintDeviceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qpagedpaintdevice.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QPagedPaintDeviceWrapper : public QPagedPaintDevice
{
public:
    QPagedPaintDeviceWrapper(const QPagedPaintDeviceWrapper &) = delete;
    QPagedPaintDeviceWrapper& operator=(const QPagedPaintDeviceWrapper &) = delete;
    QPagedPaintDeviceWrapper(QPagedPaintDeviceWrapper &&) = delete;
    QPagedPaintDeviceWrapper& operator=(QPagedPaintDeviceWrapper &&) = delete;

    int devType() const override;
    void initPainter(::QPainter * painter) const override;
    int metric(::QPaintDevice::PaintDeviceMetric metric) const override;
    bool newPage() override;
    ::QPaintEngine * paintEngine() const override;
    ::QPaintDevice * redirected(::QPoint * offset) const override;
    bool setPageLayout(const ::QPageLayout & pageLayout) override;
    bool setPageMargins(const ::QMarginsF & margins, ::QPageLayout::Unit units = QPageLayout::Millimeter) override;
    bool setPageOrientation(::QPageLayout::Orientation orientation) override;
    void setPageRanges(const ::QPageRanges & ranges) override;
    bool setPageSize(const ::QPageSize & pageSize) override;
    ::QPainter * sharedPainter() const override;
    ~QPagedPaintDeviceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[12];
};

#endif // SBK_QPagedPaintDeviceWrapper_H

