// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qpixelformat_wrapper.h"

// Argument includes
#include <QtGui/qpixelformat.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QPixelFormat_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QPixelFormat >()))
        return -1;

    ::QPixelFormat *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[13];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 13));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
    if (numArgs == 2 || numArgs == 3 || numArgs == 4 || numArgs == 5 || numArgs == 6 || numArgs == 7 || numArgs == 8 || numArgs == 9 || numArgs == 10)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OOOOOOOOOOOOO:QPixelFormat", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3]), &(pyArgs[4]), &(pyArgs[5]), &(pyArgs[6]), &(pyArgs[7]), &(pyArgs[8]), &(pyArgs[9]), &(pyArgs[10]), &(pyArgs[11]), &(pyArgs[12])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QPixelFormat::QPixelFormat()
    // 1: QPixelFormat::QPixelFormat(QPixelFormat::ColorModel,uchar,uchar,uchar,uchar,uchar,uchar,QPixelFormat::AlphaUsage,QPixelFormat::AlphaPosition,QPixelFormat::AlphaPremultiplied,QPixelFormat::TypeInterpretation,QPixelFormat::ByteOrder=,uchar=)
    // 2: QPixelFormat::QPixelFormat(QPixelFormat)
    if (numArgs == 0) {
        overloadId = 0; // QPixelFormat()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QPixelFormat(QPixelFormat)
    } else if (numArgs >= 11
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_ColorModel_IDX])))->converter, (pyArgs[0])))
        && SbkChar_Check(pyArgs[1]) && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), (pyArgs[1])))
        && SbkChar_Check(pyArgs[2]) && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), (pyArgs[2])))
        && SbkChar_Check(pyArgs[3]) && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), (pyArgs[3])))
        && SbkChar_Check(pyArgs[4]) && (pythonToCpp[4] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), (pyArgs[4])))
        && SbkChar_Check(pyArgs[5]) && (pythonToCpp[5] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), (pyArgs[5])))
        && SbkChar_Check(pyArgs[6]) && (pythonToCpp[6] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), (pyArgs[6])))
        && (pythonToCpp[7] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaUsage_IDX])))->converter, (pyArgs[7])))
        && (pythonToCpp[8] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaPosition_IDX])))->converter, (pyArgs[8])))
        && (pythonToCpp[9] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaPremultiplied_IDX])))->converter, (pyArgs[9])))
        && (pythonToCpp[10] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_TypeInterpretation_IDX])))->converter, (pyArgs[10])))) {
        if (numArgs == 11) {
            overloadId = 1; // QPixelFormat(QPixelFormat::ColorModel,uchar,uchar,uchar,uchar,uchar,uchar,QPixelFormat::AlphaUsage,QPixelFormat::AlphaPosition,QPixelFormat::AlphaPremultiplied,QPixelFormat::TypeInterpretation,QPixelFormat::ByteOrder,uchar)
        } else if (numArgs >= 12
            && (pythonToCpp[11] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_ByteOrder_IDX])))->converter, (pyArgs[11])))) {
            if (numArgs == 12) {
                overloadId = 1; // QPixelFormat(QPixelFormat::ColorModel,uchar,uchar,uchar,uchar,uchar,uchar,QPixelFormat::AlphaUsage,QPixelFormat::AlphaPosition,QPixelFormat::AlphaPremultiplied,QPixelFormat::TypeInterpretation,QPixelFormat::ByteOrder,uchar)
            } else if (numArgs >= 13
                && SbkChar_Check(pyArgs[12]) && (pythonToCpp[12] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), (pyArgs[12])))) {
                overloadId = 1; // QPixelFormat(QPixelFormat::ColorModel,uchar,uchar,uchar,uchar,uchar,uchar,QPixelFormat::AlphaUsage,QPixelFormat::AlphaPosition,QPixelFormat::AlphaPremultiplied,QPixelFormat::TypeInterpretation,QPixelFormat::ByteOrder,uchar)
            }
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QPixelFormat()
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }

            if (Shiboken::Errors::occurred() == nullptr) {
                // QPixelFormat()
                cptr = new ::QPixelFormat();
            }
            break;
        }
        case 1: // QPixelFormat(QPixelFormat::ColorModel colorModel, uchar firstSize, uchar secondSize, uchar thirdSize, uchar fourthSize, uchar fifthSize, uchar alphaSize, QPixelFormat::AlphaUsage alphaUsage, QPixelFormat::AlphaPosition alphaPosition, QPixelFormat::AlphaPremultiplied premultiplied, QPixelFormat::TypeInterpretation typeInterpretation, QPixelFormat::ByteOrder byteOrder, uchar subEnum)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_byteOrder = Shiboken::String::createStaticString("byteOrder");
                if (PyDict_Contains(kwds, key_byteOrder) != 0) {
                    value = PyDict_GetItem(kwds, key_byteOrder);
                    if (value != nullptr && pyArgs[11] != nullptr ) {
                        errInfo.reset(key_byteOrder);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[11] = value;
                        if (!(pythonToCpp[11] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_ByteOrder_IDX])))->converter, (pyArgs[11]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_byteOrder);
                }
                static PyObject *const key_subEnum = Shiboken::String::createStaticString("subEnum");
                if (PyDict_Contains(kwds, key_subEnum) != 0) {
                    value = PyDict_GetItem(kwds, key_subEnum);
                    if (value != nullptr && pyArgs[12] != nullptr ) {
                        errInfo.reset(key_subEnum);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[12] = value;
                        if (!SbkChar_Check(pyArgs[12]) && (pythonToCpp[12] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), (pyArgs[12]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_subEnum);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            ::QPixelFormat::ColorModel cppArg0{QPixelFormat::RGB};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            uchar cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            uchar cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);
            uchar cppArg3;
            pythonToCpp[3](pyArgs[3], &cppArg3);
            uchar cppArg4;
            pythonToCpp[4](pyArgs[4], &cppArg4);
            uchar cppArg5;
            pythonToCpp[5](pyArgs[5], &cppArg5);
            uchar cppArg6;
            pythonToCpp[6](pyArgs[6], &cppArg6);
            ::QPixelFormat::AlphaUsage cppArg7{QPixelFormat::UsesAlpha};
            pythonToCpp[7](pyArgs[7], &cppArg7);
            ::QPixelFormat::AlphaPosition cppArg8{QPixelFormat::AtBeginning};
            pythonToCpp[8](pyArgs[8], &cppArg8);
            ::QPixelFormat::AlphaPremultiplied cppArg9{QPixelFormat::NotPremultiplied};
            pythonToCpp[9](pyArgs[9], &cppArg9);
            ::QPixelFormat::TypeInterpretation cppArg10{QPixelFormat::UnsignedInteger};
            pythonToCpp[10](pyArgs[10], &cppArg10);
            ::QPixelFormat::ByteOrder cppArg11(QPixelFormat::ByteOrder::CurrentSystemEndian);
            if (pythonToCpp[11])
                pythonToCpp[11](pyArgs[11], &cppArg11);
            uchar cppArg12 = 0;
            if (pythonToCpp[12])
                pythonToCpp[12](pyArgs[12], &cppArg12);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QPixelFormat(QPixelFormat::ColorModel,uchar,uchar,uchar,uchar,uchar,uchar,QPixelFormat::AlphaUsage,QPixelFormat::AlphaPosition,QPixelFormat::AlphaPremultiplied,QPixelFormat::TypeInterpretation,QPixelFormat::ByteOrder,uchar)
                cptr = new ::QPixelFormat(cppArg0, cppArg1, cppArg2, cppArg3, cppArg4, cppArg5, cppArg6, cppArg7, cppArg8, cppArg9, cppArg10, cppArg11, cppArg12);
            }
            break;
        }
        case 2: // QPixelFormat(const QPixelFormat &QPixelFormat)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QPixelFormat cppArg0_local;
            ::QPixelFormat *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QPixelFormat(QPixelFormat)
                cptr = new ::QPixelFormat(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QPixelFormat >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QPixelFormatFunc_alphaPosition(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.alphaPosition";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // alphaPosition()const
            QPixelFormat::AlphaPosition cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->alphaPosition();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaPosition_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_alphaSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.alphaSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // alphaSize()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->alphaSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_alphaUsage(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.alphaUsage";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // alphaUsage()const
            QPixelFormat::AlphaUsage cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->alphaUsage();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaUsage_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_bitsPerPixel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.bitsPerPixel";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // bitsPerPixel()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->bitsPerPixel();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_blackSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.blackSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // blackSize()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->blackSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_blueSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.blueSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // blueSize()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->blueSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_brightnessSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.brightnessSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // brightnessSize()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->brightnessSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_byteOrder(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.byteOrder";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // byteOrder()const
            QPixelFormat::ByteOrder cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->byteOrder();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_ByteOrder_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_channelCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.channelCount";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // channelCount()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->channelCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_colorModel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.colorModel";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // colorModel()const
            QPixelFormat::ColorModel cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->colorModel();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_ColorModel_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_cyanSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.cyanSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // cyanSize()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->cyanSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_greenSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.greenSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // greenSize()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->greenSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_hueSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.hueSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hueSize()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->hueSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_lightnessSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.lightnessSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // lightnessSize()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->lightnessSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_magentaSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.magentaSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // magentaSize()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->magentaSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_premultiplied(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.premultiplied";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // premultiplied()const
            QPixelFormat::AlphaPremultiplied cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->premultiplied();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaPremultiplied_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_redSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.redSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // redSize()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->redSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_saturationSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.saturationSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // saturationSize()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->saturationSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_subEnum(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.subEnum";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // subEnum()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->subEnum();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_typeInterpretation(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.typeInterpretation";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // typeInterpretation()const
            QPixelFormat::TypeInterpretation cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->typeInterpretation();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_TypeInterpretation_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_yellowSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.yellowSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // yellowSize()const
            uchar cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->yellowSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormatFunc_yuvLayout(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPixelFormat.yuvLayout";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // yuvLayout()const
            QPixelFormat::YUVLayout cppResult = const_cast<const ::QPixelFormat *>(cppSelf)->yuvLayout();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_YUVLayout_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPixelFormat__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QPixelFormat_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QPixelFormat_EnumFlagInfo[] = {
    "AlphaPosition:Enum",
    "AlphaPremultiplied:Enum",
    "AlphaUsage:Enum",
    "ByteOrder:Enum",
    "ColorModel:Enum",
    "Field:IntEnum",
    "FieldWidth:IntEnum",
    "TypeInterpretation:Enum",
    "YUVLayout:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QPixelFormat_methods[] = {
    {"alphaPosition", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_alphaPosition), METH_NOARGS, nullptr},
    {"alphaSize", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_alphaSize), METH_NOARGS, nullptr},
    {"alphaUsage", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_alphaUsage), METH_NOARGS, nullptr},
    {"bitsPerPixel", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_bitsPerPixel), METH_NOARGS, nullptr},
    {"blackSize", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_blackSize), METH_NOARGS, nullptr},
    {"blueSize", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_blueSize), METH_NOARGS, nullptr},
    {"brightnessSize", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_brightnessSize), METH_NOARGS, nullptr},
    {"byteOrder", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_byteOrder), METH_NOARGS, nullptr},
    {"channelCount", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_channelCount), METH_NOARGS, nullptr},
    {"colorModel", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_colorModel), METH_NOARGS, nullptr},
    {"cyanSize", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_cyanSize), METH_NOARGS, nullptr},
    {"greenSize", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_greenSize), METH_NOARGS, nullptr},
    {"hueSize", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_hueSize), METH_NOARGS, nullptr},
    {"lightnessSize", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_lightnessSize), METH_NOARGS, nullptr},
    {"magentaSize", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_magentaSize), METH_NOARGS, nullptr},
    {"premultiplied", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_premultiplied), METH_NOARGS, nullptr},
    {"redSize", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_redSize), METH_NOARGS, nullptr},
    {"saturationSize", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_saturationSize), METH_NOARGS, nullptr},
    {"subEnum", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_subEnum), METH_NOARGS, nullptr},
    {"typeInterpretation", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_typeInterpretation), METH_NOARGS, nullptr},
    {"yellowSize", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_yellowSize), METH_NOARGS, nullptr},
    {"yuvLayout", reinterpret_cast<PyCFunction>(Sbk_QPixelFormatFunc_yuvLayout), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QPixelFormat__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QPixelFormat_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), (pyArg)))) {
                // operator!=(QPixelFormat fmt2)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QPixelFormat cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf != (cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), (pyArg)))) {
                // operator==(QPixelFormat fmt2)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QPixelFormat cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf == (cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QPixelFormat_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QPixelFormat_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QPixelFormat_Type = nullptr;
static PyTypeObject *Sbk_QPixelFormat_TypeF(void)
{
    return _Sbk_QPixelFormat_Type;
}

static PyType_Slot Sbk_QPixelFormat_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QPixelFormat_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QPixelFormat_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QPixelFormat_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QPixelFormat_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QPixelFormat_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QPixelFormat_spec = {
    "2:PySide6.QtGui.QPixelFormat",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QPixelFormat_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QPixelFormat_ColorModel(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QPixelFormat::ColorModel>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QPixelFormat::ColorModel *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QPixelFormat_ColorModel_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_ColorModel_IDX])))
        return Enum_PythonToCpp_QPixelFormat_ColorModel;
    return {};
}
static PyObject *QPixelFormat_ColorModel_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QPixelFormat::ColorModel *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_ColorModel_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QPixelFormat_AlphaUsage(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QPixelFormat::AlphaUsage>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QPixelFormat::AlphaUsage *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QPixelFormat_AlphaUsage_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaUsage_IDX])))
        return Enum_PythonToCpp_QPixelFormat_AlphaUsage;
    return {};
}
static PyObject *QPixelFormat_AlphaUsage_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QPixelFormat::AlphaUsage *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaUsage_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QPixelFormat_AlphaPosition(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QPixelFormat::AlphaPosition>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QPixelFormat::AlphaPosition *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QPixelFormat_AlphaPosition_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaPosition_IDX])))
        return Enum_PythonToCpp_QPixelFormat_AlphaPosition;
    return {};
}
static PyObject *QPixelFormat_AlphaPosition_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QPixelFormat::AlphaPosition *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaPosition_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QPixelFormat_AlphaPremultiplied(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QPixelFormat::AlphaPremultiplied>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QPixelFormat::AlphaPremultiplied *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QPixelFormat_AlphaPremultiplied_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaPremultiplied_IDX])))
        return Enum_PythonToCpp_QPixelFormat_AlphaPremultiplied;
    return {};
}
static PyObject *QPixelFormat_AlphaPremultiplied_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QPixelFormat::AlphaPremultiplied *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaPremultiplied_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QPixelFormat_TypeInterpretation(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QPixelFormat::TypeInterpretation>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QPixelFormat::TypeInterpretation *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QPixelFormat_TypeInterpretation_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_TypeInterpretation_IDX])))
        return Enum_PythonToCpp_QPixelFormat_TypeInterpretation;
    return {};
}
static PyObject *QPixelFormat_TypeInterpretation_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QPixelFormat::TypeInterpretation *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_TypeInterpretation_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QPixelFormat_YUVLayout(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QPixelFormat::YUVLayout>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QPixelFormat::YUVLayout *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QPixelFormat_YUVLayout_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_YUVLayout_IDX])))
        return Enum_PythonToCpp_QPixelFormat_YUVLayout;
    return {};
}
static PyObject *QPixelFormat_YUVLayout_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QPixelFormat::YUVLayout *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_YUVLayout_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QPixelFormat_ByteOrder(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QPixelFormat::ByteOrder>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QPixelFormat::ByteOrder *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QPixelFormat_ByteOrder_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_ByteOrder_IDX])))
        return Enum_PythonToCpp_QPixelFormat_ByteOrder;
    return {};
}
static PyObject *QPixelFormat_ByteOrder_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QPixelFormat::ByteOrder *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_ByteOrder_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QPixelFormat_PythonToCpp_QPixelFormat_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QPixelFormat_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QPixelFormat_PythonToCpp_QPixelFormat_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QPixelFormat_TypeF()))
        return QPixelFormat_PythonToCpp_QPixelFormat_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QPixelFormat_PTR_CppToPython_QPixelFormat(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QPixelFormat *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QPixelFormat_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QPixelFormat_COPY_CppToPython_QPixelFormat(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QPixelFormat *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QPixelFormat_TypeF(), new ::QPixelFormat(*source), true, true);
}

// Python to C++ copy conversion.
static void QPixelFormat_PythonToCpp_QPixelFormat_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QPixelFormat *>(cppOut) = *reinterpret_cast< ::QPixelFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QPixelFormat_PythonToCpp_QPixelFormat_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QPixelFormat_TypeF()))
        return QPixelFormat_PythonToCpp_QPixelFormat_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QPixelFormat_SignatureStrings[] = {
    "2:PySide6.QtGui.QPixelFormat(self)",
    "1:PySide6.QtGui.QPixelFormat(self,colorModel:PySide6.QtGui.QPixelFormat.ColorModel,firstSize:uchar,secondSize:uchar,thirdSize:uchar,fourthSize:uchar,fifthSize:uchar,alphaSize:uchar,alphaUsage:PySide6.QtGui.QPixelFormat.AlphaUsage,alphaPosition:PySide6.QtGui.QPixelFormat.AlphaPosition,premultiplied:PySide6.QtGui.QPixelFormat.AlphaPremultiplied,typeInterpretation:PySide6.QtGui.QPixelFormat.TypeInterpretation,byteOrder:PySide6.QtGui.QPixelFormat.ByteOrder=QPixelFormat.ByteOrder.CurrentSystemEndian,subEnum:uchar=0)",
    "0:PySide6.QtGui.QPixelFormat(self,QPixelFormat:PySide6.QtGui.QPixelFormat)",
    "PySide6.QtGui.QPixelFormat.alphaPosition(self)->PySide6.QtGui.QPixelFormat.AlphaPosition",
    "PySide6.QtGui.QPixelFormat.alphaSize(self)->uchar",
    "PySide6.QtGui.QPixelFormat.alphaUsage(self)->PySide6.QtGui.QPixelFormat.AlphaUsage",
    "PySide6.QtGui.QPixelFormat.bitsPerPixel(self)->uchar",
    "PySide6.QtGui.QPixelFormat.blackSize(self)->uchar",
    "PySide6.QtGui.QPixelFormat.blueSize(self)->uchar",
    "PySide6.QtGui.QPixelFormat.brightnessSize(self)->uchar",
    "PySide6.QtGui.QPixelFormat.byteOrder(self)->PySide6.QtGui.QPixelFormat.ByteOrder",
    "PySide6.QtGui.QPixelFormat.channelCount(self)->uchar",
    "PySide6.QtGui.QPixelFormat.colorModel(self)->PySide6.QtGui.QPixelFormat.ColorModel",
    "PySide6.QtGui.QPixelFormat.cyanSize(self)->uchar",
    "PySide6.QtGui.QPixelFormat.greenSize(self)->uchar",
    "PySide6.QtGui.QPixelFormat.hueSize(self)->uchar",
    "PySide6.QtGui.QPixelFormat.lightnessSize(self)->uchar",
    "PySide6.QtGui.QPixelFormat.magentaSize(self)->uchar",
    "PySide6.QtGui.QPixelFormat.premultiplied(self)->PySide6.QtGui.QPixelFormat.AlphaPremultiplied",
    "PySide6.QtGui.QPixelFormat.redSize(self)->uchar",
    "PySide6.QtGui.QPixelFormat.saturationSize(self)->uchar",
    "PySide6.QtGui.QPixelFormat.subEnum(self)->uchar",
    "PySide6.QtGui.QPixelFormat.typeInterpretation(self)->PySide6.QtGui.QPixelFormat.TypeInterpretation",
    "PySide6.QtGui.QPixelFormat.yellowSize(self)->uchar",
    "PySide6.QtGui.QPixelFormat.yuvLayout(self)->PySide6.QtGui.QPixelFormat.YUVLayout",
    "PySide6.QtGui.QPixelFormat.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QPixelFormat(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX].type;

    Shiboken::AutoDecRef Sbk_QPixelFormat_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QPixelFormat_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QPixelFormat",
        "QPixelFormat",
        &Sbk_QPixelFormat_spec,
        &Shiboken::callCppDestructor< ::QPixelFormat >,
        Sbk_QPixelFormat_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QPixelFormat_TypeF(); // references _Sbk_QPixelFormat_Type
    InitSignatureStrings(pyType, QPixelFormat_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QPixelFormat_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QPixelFormat_PythonToCpp_QPixelFormat_PTR,
        is_QPixelFormat_PythonToCpp_QPixelFormat_PTR_Convertible,
        QPixelFormat_PTR_CppToPython_QPixelFormat,
        QPixelFormat_COPY_CppToPython_QPixelFormat);

    Shiboken::Conversions::registerConverterName(converter, "QPixelFormat");
    Shiboken::Conversions::registerConverterName(converter, "QPixelFormat*");
    Shiboken::Conversions::registerConverterName(converter, "QPixelFormat&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QPixelFormat).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QPixelFormat_PythonToCpp_QPixelFormat_COPY,
        is_QPixelFormat_PythonToCpp_QPixelFormat_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QPixelFormat_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'ColorModel'.
    const char *ColorModel_Initializer[] = {
        "RGB",
        "BGR",
        "Indexed",
        "Grayscale",
        "CMYK",
        "HSL",
        "HSV",
        "YUV",
        "Alpha",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ColorModel_InitializerValues[] = {
        uint8_t(QPixelFormat::ColorModel::RGB),       //  0x00  0
        uint8_t(QPixelFormat::ColorModel::BGR),       //  0x01  1
        uint8_t(QPixelFormat::ColorModel::Indexed),   //  0x02  2
        uint8_t(QPixelFormat::ColorModel::Grayscale), //  0x03  3
        uint8_t(QPixelFormat::ColorModel::CMYK),      //  0x04  4
        uint8_t(QPixelFormat::ColorModel::HSL),       //  0x05  5
        uint8_t(QPixelFormat::ColorModel::HSV),       //  0x06  6
        uint8_t(QPixelFormat::ColorModel::YUV),       //  0x07  7
        uint8_t(QPixelFormat::ColorModel::Alpha)      //  0x08  8
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QPixelFormat_TypeF(),
        "2:PySide6.QtGui.QPixelFormat.ColorModel",
        ColorModel_Initializer, ColorModel_InitializerValues);
    SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_ColorModel_IDX].type = EType;
    // Register converter for enum 'QPixelFormat::ColorModel'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QPixelFormat_ColorModel_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QPixelFormat_ColorModel,
            is_Enum_PythonToCpp_QPixelFormat_ColorModel_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QPixelFormat::ColorModel");
        Shiboken::Conversions::registerConverterName(converter, "ColorModel");
    }
    // End of 'ColorModel' enum.

    // Initialization of enum 'AlphaUsage'.
    const char *AlphaUsage_Initializer[] = {
        "UsesAlpha",
        "IgnoresAlpha",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t AlphaUsage_InitializerValues[] = {
        uint8_t(QPixelFormat::AlphaUsage::UsesAlpha),   //  0x00  0
        uint8_t(QPixelFormat::AlphaUsage::IgnoresAlpha) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QPixelFormat_TypeF(),
        "2:PySide6.QtGui.QPixelFormat.AlphaUsage",
        AlphaUsage_Initializer, AlphaUsage_InitializerValues);
    SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaUsage_IDX].type = EType;
    // Register converter for enum 'QPixelFormat::AlphaUsage'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QPixelFormat_AlphaUsage_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QPixelFormat_AlphaUsage,
            is_Enum_PythonToCpp_QPixelFormat_AlphaUsage_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QPixelFormat::AlphaUsage");
        Shiboken::Conversions::registerConverterName(converter, "AlphaUsage");
    }
    // End of 'AlphaUsage' enum.

    // Initialization of enum 'AlphaPosition'.
    const char *AlphaPosition_Initializer[] = {
        "AtBeginning",
        "AtEnd",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t AlphaPosition_InitializerValues[] = {
        uint8_t(QPixelFormat::AlphaPosition::AtBeginning), //  0x00  0
        uint8_t(QPixelFormat::AlphaPosition::AtEnd)        //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QPixelFormat_TypeF(),
        "2:PySide6.QtGui.QPixelFormat.AlphaPosition",
        AlphaPosition_Initializer, AlphaPosition_InitializerValues);
    SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaPosition_IDX].type = EType;
    // Register converter for enum 'QPixelFormat::AlphaPosition'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QPixelFormat_AlphaPosition_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QPixelFormat_AlphaPosition,
            is_Enum_PythonToCpp_QPixelFormat_AlphaPosition_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QPixelFormat::AlphaPosition");
        Shiboken::Conversions::registerConverterName(converter, "AlphaPosition");
    }
    // End of 'AlphaPosition' enum.

    // Initialization of enum 'AlphaPremultiplied'.
    const char *AlphaPremultiplied_Initializer[] = {
        "NotPremultiplied",
        "Premultiplied",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t AlphaPremultiplied_InitializerValues[] = {
        uint8_t(QPixelFormat::AlphaPremultiplied::NotPremultiplied), //  0x00  0
        uint8_t(QPixelFormat::AlphaPremultiplied::Premultiplied)     //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QPixelFormat_TypeF(),
        "2:PySide6.QtGui.QPixelFormat.AlphaPremultiplied",
        AlphaPremultiplied_Initializer, AlphaPremultiplied_InitializerValues);
    SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_AlphaPremultiplied_IDX].type = EType;
    // Register converter for enum 'QPixelFormat::AlphaPremultiplied'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QPixelFormat_AlphaPremultiplied_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QPixelFormat_AlphaPremultiplied,
            is_Enum_PythonToCpp_QPixelFormat_AlphaPremultiplied_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QPixelFormat::AlphaPremultiplied");
        Shiboken::Conversions::registerConverterName(converter, "AlphaPremultiplied");
    }
    // End of 'AlphaPremultiplied' enum.

    // Initialization of enum 'TypeInterpretation'.
    const char *TypeInterpretation_Initializer[] = {
        "UnsignedInteger",
        "UnsignedShort",
        "UnsignedByte",
        "FloatingPoint",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t TypeInterpretation_InitializerValues[] = {
        uint8_t(QPixelFormat::TypeInterpretation::UnsignedInteger), //  0x00  0
        uint8_t(QPixelFormat::TypeInterpretation::UnsignedShort),   //  0x01  1
        uint8_t(QPixelFormat::TypeInterpretation::UnsignedByte),    //  0x02  2
        uint8_t(QPixelFormat::TypeInterpretation::FloatingPoint)    //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QPixelFormat_TypeF(),
        "2:PySide6.QtGui.QPixelFormat.TypeInterpretation",
        TypeInterpretation_Initializer, TypeInterpretation_InitializerValues);
    SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_TypeInterpretation_IDX].type = EType;
    // Register converter for enum 'QPixelFormat::TypeInterpretation'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QPixelFormat_TypeInterpretation_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QPixelFormat_TypeInterpretation,
            is_Enum_PythonToCpp_QPixelFormat_TypeInterpretation_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QPixelFormat::TypeInterpretation");
        Shiboken::Conversions::registerConverterName(converter, "TypeInterpretation");
    }
    // End of 'TypeInterpretation' enum.

    // Initialization of enum 'YUVLayout'.
    const char *YUVLayout_Initializer[] = {
        "YUV444",
        "YUV422",
        "YUV411",
        "YUV420P",
        "YUV420SP",
        "YV12",
        "UYVY",
        "YUYV",
        "NV12",
        "NV21",
        "IMC1",
        "IMC2",
        "IMC3",
        "IMC4",
        "Y8",
        "Y16",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t YUVLayout_InitializerValues[] = {
        uint8_t(QPixelFormat::YUVLayout::YUV444),   //  0x00  0
        uint8_t(QPixelFormat::YUVLayout::YUV422),   //  0x01  1
        uint8_t(QPixelFormat::YUVLayout::YUV411),   //  0x02  2
        uint8_t(QPixelFormat::YUVLayout::YUV420P),  //  0x03  3
        uint8_t(QPixelFormat::YUVLayout::YUV420SP), //  0x04  4
        uint8_t(QPixelFormat::YUVLayout::YV12),     //  0x05  5
        uint8_t(QPixelFormat::YUVLayout::UYVY),     //  0x06  6
        uint8_t(QPixelFormat::YUVLayout::YUYV),     //  0x07  7
        uint8_t(QPixelFormat::YUVLayout::NV12),     //  0x08  8
        uint8_t(QPixelFormat::YUVLayout::NV21),     //  0x09  9
        uint8_t(QPixelFormat::YUVLayout::IMC1),     //  0x0a  10
        uint8_t(QPixelFormat::YUVLayout::IMC2),     //  0x0b  11
        uint8_t(QPixelFormat::YUVLayout::IMC3),     //  0x0c  12
        uint8_t(QPixelFormat::YUVLayout::IMC4),     //  0x0d  13
        uint8_t(QPixelFormat::YUVLayout::Y8),       //  0x0e  14
        uint8_t(QPixelFormat::YUVLayout::Y16)       //  0x0f  15
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QPixelFormat_TypeF(),
        "2:PySide6.QtGui.QPixelFormat.YUVLayout",
        YUVLayout_Initializer, YUVLayout_InitializerValues);
    SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_YUVLayout_IDX].type = EType;
    // Register converter for enum 'QPixelFormat::YUVLayout'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QPixelFormat_YUVLayout_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QPixelFormat_YUVLayout,
            is_Enum_PythonToCpp_QPixelFormat_YUVLayout_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QPixelFormat::YUVLayout");
        Shiboken::Conversions::registerConverterName(converter, "YUVLayout");
    }
    // End of 'YUVLayout' enum.

    // Initialization of enum 'ByteOrder'.
    const char *ByteOrder_Initializer[] = {
        "LittleEndian",
        "BigEndian",
        "CurrentSystemEndian",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ByteOrder_InitializerValues[] = {
        uint8_t(QPixelFormat::ByteOrder::LittleEndian),       //  0x00  0
        uint8_t(QPixelFormat::ByteOrder::BigEndian),          //  0x01  1
        uint8_t(QPixelFormat::ByteOrder::CurrentSystemEndian) //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QPixelFormat_TypeF(),
        "2:PySide6.QtGui.QPixelFormat.ByteOrder",
        ByteOrder_Initializer, ByteOrder_InitializerValues);
    SbkPySide6_QtGuiTypeStructs[SBK_QPixelFormat_ByteOrder_IDX].type = EType;
    // Register converter for enum 'QPixelFormat::ByteOrder'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QPixelFormat_ByteOrder_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QPixelFormat_ByteOrder,
            is_Enum_PythonToCpp_QPixelFormat_ByteOrder_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QPixelFormat::ByteOrder");
        Shiboken::Conversions::registerConverterName(converter, "ByteOrder");
    }
    // End of 'ByteOrder' enum.

    qRegisterMetaType< ::QPixelFormat >("QPixelFormat");
    qRegisterMetaType< ::QPixelFormat::ColorModel >("QPixelFormat::ColorModel");
    qRegisterMetaType< ::QPixelFormat::AlphaUsage >("QPixelFormat::AlphaUsage");
    qRegisterMetaType< ::QPixelFormat::AlphaPosition >("QPixelFormat::AlphaPosition");
    qRegisterMetaType< ::QPixelFormat::AlphaPremultiplied >("QPixelFormat::AlphaPremultiplied");
    qRegisterMetaType< ::QPixelFormat::TypeInterpretation >("QPixelFormat::TypeInterpretation");
    qRegisterMetaType< ::QPixelFormat::YUVLayout >("QPixelFormat::YUVLayout");
    qRegisterMetaType< ::QPixelFormat::ByteOrder >("QPixelFormat::ByteOrder");

    return pyType;
}
