// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhigles2nativehandles_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiGles2NativeHandles_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiGles2NativeHandles >()))
        return -1;

    ::QRhiGles2NativeHandles *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiGles2NativeHandles.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRhiGles2NativeHandles", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiGles2NativeHandles::QRhiGles2NativeHandles()
    // 1: QRhiGles2NativeHandles::QRhiGles2NativeHandles(QRhiGles2NativeHandles)
    if (numArgs == 0) {
        overloadId = 0; // QRhiGles2NativeHandles()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2NativeHandles_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiGles2NativeHandles(QRhiGles2NativeHandles)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiGles2NativeHandles()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiGles2NativeHandles()
                cptr = new ::QRhiGles2NativeHandles();
            }
            break;
        }
        case 1: // QRhiGles2NativeHandles(const QRhiGles2NativeHandles &QRhiGles2NativeHandles)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiGles2NativeHandles cppArg0_local;
            ::QRhiGles2NativeHandles *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiGles2NativeHandles(QRhiGles2NativeHandles)
                cptr = new ::QRhiGles2NativeHandles(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiGles2NativeHandles >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiGles2NativeHandles__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiGles2NativeHandles *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2NativeHandles_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2NativeHandles_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiGles2NativeHandles_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiGles2NativeHandles_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiGles2NativeHandles__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QRhiGles2NativeHandles_get_context(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGles2NativeHandles *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2NativeHandles_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QOpenGLContext_IDX]), cppSelf->context);
    return pyOut;
}
static int Sbk_QRhiGles2NativeHandles_set_context(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGles2NativeHandles *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2NativeHandles_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("context");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QOpenGLContext_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("context", "QOpenGLContext");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->context;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "context", pyIn);
    return 0;
}

// Getters and Setters for QRhiGles2NativeHandles
static PyGetSetDef Sbk_QRhiGles2NativeHandles_getsetlist[] = {
    {const_cast<char *>("context"), Sbk_QRhiGles2NativeHandles_get_context, Sbk_QRhiGles2NativeHandles_set_context, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiGles2NativeHandles_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiGles2NativeHandles_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiGles2NativeHandles_Type = nullptr;
static PyTypeObject *Sbk_QRhiGles2NativeHandles_TypeF(void)
{
    return _Sbk_QRhiGles2NativeHandles_Type;
}

static PyType_Slot Sbk_QRhiGles2NativeHandles_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiGles2NativeHandles_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiGles2NativeHandles_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiGles2NativeHandles_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QRhiGles2NativeHandles_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiGles2NativeHandles_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiGles2NativeHandles_spec = {
    "2:PySide6.QtGui.QRhiGles2NativeHandles",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiGles2NativeHandles_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiGles2NativeHandles_PythonToCpp_QRhiGles2NativeHandles_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiGles2NativeHandles_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiGles2NativeHandles_PythonToCpp_QRhiGles2NativeHandles_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiGles2NativeHandles_TypeF()))
        return QRhiGles2NativeHandles_PythonToCpp_QRhiGles2NativeHandles_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiGles2NativeHandles_PTR_CppToPython_QRhiGles2NativeHandles(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QRhiGles2NativeHandles *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QRhiGles2NativeHandles_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QRhiGles2NativeHandles_COPY_CppToPython_QRhiGles2NativeHandles(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiGles2NativeHandles *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiGles2NativeHandles_TypeF(), new ::QRhiGles2NativeHandles(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiGles2NativeHandles_PythonToCpp_QRhiGles2NativeHandles_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiGles2NativeHandles *>(cppOut) = *reinterpret_cast< ::QRhiGles2NativeHandles *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2NativeHandles_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiGles2NativeHandles_PythonToCpp_QRhiGles2NativeHandles_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiGles2NativeHandles_TypeF()))
        return QRhiGles2NativeHandles_PythonToCpp_QRhiGles2NativeHandles_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRhiGles2NativeHandles_SignatureStrings[] = {
    "1:PySide6.QtGui.QRhiGles2NativeHandles(self)",
    "0:PySide6.QtGui.QRhiGles2NativeHandles(self,QRhiGles2NativeHandles:PySide6.QtGui.QRhiGles2NativeHandles)",
    "PySide6.QtGui.QRhiGles2NativeHandles.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRhiGles2NativeHandles(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2NativeHandles_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2NativeHandles_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiGles2NativeHandles_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiNativeHandles_IDX]))));

    _Sbk_QRhiGles2NativeHandles_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiGles2NativeHandles",
        "QRhiGles2NativeHandles",
        &Sbk_QRhiGles2NativeHandles_spec,
        &Shiboken::callCppDestructor< ::QRhiGles2NativeHandles >,
        Sbk_QRhiGles2NativeHandles_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiGles2NativeHandles_TypeF(); // references _Sbk_QRhiGles2NativeHandles_Type
    InitSignatureStrings(pyType, QRhiGles2NativeHandles_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiGles2NativeHandles_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2NativeHandles_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiGles2NativeHandles_PythonToCpp_QRhiGles2NativeHandles_PTR,
        is_QRhiGles2NativeHandles_PythonToCpp_QRhiGles2NativeHandles_PTR_Convertible,
        QRhiGles2NativeHandles_PTR_CppToPython_QRhiGles2NativeHandles,
        QRhiGles2NativeHandles_COPY_CppToPython_QRhiGles2NativeHandles);

    Shiboken::Conversions::registerConverterName(converter, "QRhiGles2NativeHandles");
    Shiboken::Conversions::registerConverterName(converter, "QRhiGles2NativeHandles*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiGles2NativeHandles&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiGles2NativeHandles).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiGles2NativeHandles_PythonToCpp_QRhiGles2NativeHandles_COPY,
        is_QRhiGles2NativeHandles_PythonToCpp_QRhiGles2NativeHandles_COPY_Convertible);

    qRegisterMetaType< ::QRhiGles2NativeHandles >("QRhiGles2NativeHandles");

    return pyType;
}
