// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRhiSwapChainWrapper_H
#define SBK_QRhiSwapChainWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QRhiSwapChainWrapper : public QRhiSwapChain
{
public:
    QRhiSwapChainWrapper(const QRhiSwapChainWrapper &) = delete;
    QRhiSwapChainWrapper& operator=(const QRhiSwapChainWrapper &) = delete;
    QRhiSwapChainWrapper(QRhiSwapChainWrapper &&) = delete;
    QRhiSwapChainWrapper& operator=(QRhiSwapChainWrapper &&) = delete;

    bool createOrResize() override;
    ::QRhiCommandBuffer * currentFrameCommandBuffer() override;
    ::QRhiRenderTarget * currentFrameRenderTarget() override;
    ::QRhiRenderTarget * currentFrameRenderTarget(::QRhiSwapChain::StereoTargetBuffer targetBuffer) override;
    void destroy() override;
    bool isFormatSupported(::QRhiSwapChain::Format f) override;
    ::QRhiRenderPassDescriptor * newCompatibleRenderPassDescriptor() override;
    ::QRhiResource::Type resourceType() const override;
    ::QSize surfacePixelSize() override;
    ~QRhiSwapChainWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QRhiSwapChainWrapper_H

