// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhitextureuploaddescription_wrapper.h"

// Argument includes
#include <QList>
#include <rhi/qrhi.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiTextureUploadDescription_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiTextureUploadDescription >()))
        return -1;

    ::QRhiTextureUploadDescription *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadDescription.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRhiTextureUploadDescription", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiTextureUploadDescription::QRhiTextureUploadDescription()
    // 1: QRhiTextureUploadDescription::QRhiTextureUploadDescription(QRhiTextureUploadEntry)
    if (numArgs == 0) {
        overloadId = 0; // QRhiTextureUploadDescription()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiTextureUploadDescription(QRhiTextureUploadEntry)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiTextureUploadDescription()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureUploadDescription()
                cptr = new ::QRhiTextureUploadDescription();
            }
            break;
        }
        case 1: // QRhiTextureUploadDescription(const QRhiTextureUploadEntry &entry)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiTextureUploadEntry cppArg0_local;
            ::QRhiTextureUploadEntry *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureUploadDescription(QRhiTextureUploadEntry)
                cptr = new ::QRhiTextureUploadDescription(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiTextureUploadDescription >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiTextureUploadDescriptionFunc_cbeginEntries(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadDescription.cbeginEntries";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // cbeginEntries()const
            const QRhiTextureUploadEntry * cppResult = const_cast<const ::QRhiTextureUploadDescription *>(cppSelf)->cbeginEntries();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureUploadDescriptionFunc_cendEntries(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadDescription.cendEntries";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // cendEntries()const
            const QRhiTextureUploadEntry * cppResult = const_cast<const ::QRhiTextureUploadDescription *>(cppSelf)->cendEntries();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureUploadDescriptionFunc_entryAt(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadDescription.entryAt";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureUploadDescription::entryAt(qsizetype)const->const QRhiTextureUploadEntry*
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), (pyArg)))) {
        overloadId = 0; // entryAt(qsizetype)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        qsizetype cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // entryAt(qsizetype)const
            const QRhiTextureUploadEntry * cppResult = const_cast<const ::QRhiTextureUploadDescription *>(cppSelf)->entryAt(cppArg0);
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureUploadDescriptionFunc_entryCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadDescription.entryCount";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // entryCount()const
            qsizetype cppResult = const_cast<const ::QRhiTextureUploadDescription *>(cppSelf)->entryCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureUploadDescriptionFunc_setEntries(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadDescription.setEntries";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureUploadDescription::setEntries(QList<QRhiTextureUploadEntry>)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtGuiTypeConverters[SBK_QtGui_QList_QRhiTextureUploadEntry_IDX], (pyArg)))) {
        overloadId = 0; // setEntries(QList<QRhiTextureUploadEntry>)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QList<QRhiTextureUploadEntry> cppArg0;
        pythonToCpp(pyArg, &cppArg0);
        SBK_UNUSED(cppArg0)

        if (Shiboken::Errors::occurred() == nullptr) {
            // setEntries(QList<QRhiTextureUploadEntry>)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: ../glue/qtgui.cpp (qrhi-initializer-list)]
            cppSelf->setEntries(cppArg0.cbegin(), cppArg0.cend());
            // END of custom code block [file: ../glue/qtgui.cpp (qrhi-initializer-list)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureUploadDescription__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiTextureUploadDescription_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiTextureUploadDescription_methods[] = {
    {"cbeginEntries", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadDescriptionFunc_cbeginEntries), METH_NOARGS, nullptr},
    {"cendEntries", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadDescriptionFunc_cendEntries), METH_NOARGS, nullptr},
    {"entryAt", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadDescriptionFunc_entryAt), METH_O, nullptr},
    {"entryCount", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadDescriptionFunc_entryCount), METH_NOARGS, nullptr},
    {"setEntries", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadDescriptionFunc_setEntries), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadDescription__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiTextureUploadDescription_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiTextureUploadDescription_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiTextureUploadDescription_Type = nullptr;
static PyTypeObject *Sbk_QRhiTextureUploadDescription_TypeF(void)
{
    return _Sbk_QRhiTextureUploadDescription_Type;
}

static PyType_Slot Sbk_QRhiTextureUploadDescription_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiTextureUploadDescription_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiTextureUploadDescription_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiTextureUploadDescription_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiTextureUploadDescription_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiTextureUploadDescription_spec = {
    "2:PySide6.QtGui.QRhiTextureUploadDescription",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiTextureUploadDescription_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiTextureUploadDescription_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureUploadDescription_TypeF()))
        return QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiTextureUploadDescription_PTR_CppToPython_QRhiTextureUploadDescription(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QRhiTextureUploadDescription *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QRhiTextureUploadDescription_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QRhiTextureUploadDescription_COPY_CppToPython_QRhiTextureUploadDescription(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiTextureUploadDescription *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiTextureUploadDescription_TypeF(), new ::QRhiTextureUploadDescription(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiTextureUploadDescription *>(cppOut) = *reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureUploadDescription_TypeF()))
        return QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_COPY;
    return {};
}

// Implicit conversions.
static void constQRhiTextureUploadEntryREF_PythonToCpp_QRhiTextureUploadDescription(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiTextureUploadDescription *>(cppOut) = ::QRhiTextureUploadDescription( *reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(pyIn))));
}
static PythonToCppFunc is_constQRhiTextureUploadEntryREF_PythonToCpp_QRhiTextureUploadDescription_Convertible(PyObject *pyIn)
{
    if (SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), pyIn))
        return constQRhiTextureUploadEntryREF_PythonToCpp_QRhiTextureUploadDescription;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRhiTextureUploadDescription_SignatureStrings[] = {
    "1:PySide6.QtGui.QRhiTextureUploadDescription(self)",
    "0:PySide6.QtGui.QRhiTextureUploadDescription(self,entry:PySide6.QtGui.QRhiTextureUploadEntry)",
    "PySide6.QtGui.QRhiTextureUploadDescription.cbeginEntries(self)->PySide6.QtGui.QRhiTextureUploadEntry",
    "PySide6.QtGui.QRhiTextureUploadDescription.cendEntries(self)->PySide6.QtGui.QRhiTextureUploadEntry",
    "PySide6.QtGui.QRhiTextureUploadDescription.entryAt(self,index:qsizetype)->PySide6.QtGui.QRhiTextureUploadEntry",
    "PySide6.QtGui.QRhiTextureUploadDescription.entryCount(self)->qsizetype",
    "PySide6.QtGui.QRhiTextureUploadDescription.setEntries(self,entries:QList[PySide6.QtGui.QRhiTextureUploadEntry])",
    "PySide6.QtGui.QRhiTextureUploadDescription.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRhiTextureUploadDescription(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiTextureUploadDescription_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRhiTextureUploadDescription_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiTextureUploadDescription",
        "QRhiTextureUploadDescription",
        &Sbk_QRhiTextureUploadDescription_spec,
        &Shiboken::callCppDestructor< ::QRhiTextureUploadDescription >,
        Sbk_QRhiTextureUploadDescription_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiTextureUploadDescription_TypeF(); // references _Sbk_QRhiTextureUploadDescription_Type
    InitSignatureStrings(pyType, QRhiTextureUploadDescription_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiTextureUploadDescription_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_PTR,
        is_QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_PTR_Convertible,
        QRhiTextureUploadDescription_PTR_CppToPython_QRhiTextureUploadDescription,
        QRhiTextureUploadDescription_COPY_CppToPython_QRhiTextureUploadDescription);

    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureUploadDescription");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureUploadDescription*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureUploadDescription&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiTextureUploadDescription).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_COPY,
        is_QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        constQRhiTextureUploadEntryREF_PythonToCpp_QRhiTextureUploadDescription,
        is_constQRhiTextureUploadEntryREF_PythonToCpp_QRhiTextureUploadDescription_Convertible);

    qRegisterMetaType< ::QRhiTextureUploadDescription >("QRhiTextureUploadDescription");

    return pyType;
}
