// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QShortcutWrapper_H
#define SBK_QShortcutWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qshortcut.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QShortcutWrapper : public QShortcut
{
public:
    QShortcutWrapper(const QShortcutWrapper &) = delete;
    QShortcutWrapper& operator=(const QShortcutWrapper &) = delete;
    QShortcutWrapper(QShortcutWrapper &&) = delete;
    QShortcutWrapper& operator=(QShortcutWrapper &&) = delete;

    QShortcutWrapper(::QKeySequence::StandardKey key, ::QObject * parent, const char * member = nullptr, const char * ambiguousMember = nullptr, ::Qt::ShortcutContext context = Qt::WindowShortcut);
    QShortcutWrapper(::QObject * parent);
    QShortcutWrapper(const ::QKeySequence & key, ::QObject * parent, const char * member = nullptr, const char * ambiguousMember = nullptr, ::Qt::ShortcutContext context = Qt::WindowShortcut);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * e) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QShortcutWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QShortcutWrapper_H

