// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QShortcutEventWrapper_H
#define SBK_QShortcutEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QShortcutEventWrapper : public QShortcutEvent
{
public:
    QShortcutEventWrapper(const QShortcutEventWrapper &) = delete;
    QShortcutEventWrapper& operator=(const QShortcutEventWrapper &) = delete;
    QShortcutEventWrapper(QShortcutEventWrapper &&) = delete;
    QShortcutEventWrapper& operator=(QShortcutEventWrapper &&) = delete;

    QShortcutEventWrapper(const ::QKeySequence & key, const ::QShortcut * shortcut = nullptr, bool ambiguous = false);
    QShortcutEventWrapper(const ::QKeySequence & key, int id, bool ambiguous = false);
    QShortcutEventWrapper(const QShortcutEvent& self) : QShortcutEvent(self)
    {
    }

    ::QShortcutEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QShortcutEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QShortcutEventWrapper_H

