// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QStandardItemWrapper_H
#define SBK_QStandardItemWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qstandarditemmodel.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QStandardItemWrapper : public QStandardItem
{
public:
    QStandardItemWrapper(const QStandardItemWrapper &) = delete;
    QStandardItemWrapper& operator=(const QStandardItemWrapper &) = delete;
    QStandardItemWrapper(QStandardItemWrapper &&) = delete;
    QStandardItemWrapper& operator=(QStandardItemWrapper &&) = delete;

    QStandardItemWrapper();
    QStandardItemWrapper(const ::QIcon & icon, const ::QString & text);
    QStandardItemWrapper(const QStandardItem& self) : QStandardItem(self)
    {
    }

    QStandardItemWrapper(const ::QString & text);
    QStandardItemWrapper(int rows, int columns = 1);
    ::QStandardItem * clone() const override;
    ::QVariant data(int role = Qt::UserRole + 1) const override;
    bool operator<(const ::QStandardItem & other) const override;
    void read(::QDataStream & in) override;
    void setData(const ::QVariant & value, int role = Qt::UserRole + 1) override;
    int type() const override;
    void write(::QDataStream & out) const override;
    ~QStandardItemWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QStandardItemWrapper_H

