// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QStatusTipEventWrapper_H
#define SBK_QStatusTipEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QStatusTipEventWrapper : public QStatusTipEvent
{
public:
    QStatusTipEventWrapper(const QStatusTipEventWrapper &) = delete;
    QStatusTipEventWrapper& operator=(const QStatusTipEventWrapper &) = delete;
    QStatusTipEventWrapper(QStatusTipEventWrapper &&) = delete;
    QStatusTipEventWrapper& operator=(QStatusTipEventWrapper &&) = delete;

    QStatusTipEventWrapper(const QStatusTipEvent& self) : QStatusTipEvent(self)
    {
    }

    QStatusTipEventWrapper(const ::QString & tip);
    ::QStatusTipEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QStatusTipEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QStatusTipEventWrapper_H

