// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSurfaceWrapper_H
#define SBK_QSurfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qsurface.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSurfaceWrapper : public QSurface
{
public:
    QSurfaceWrapper(const QSurfaceWrapper &) = delete;
    QSurfaceWrapper& operator=(const QSurfaceWrapper &) = delete;
    QSurfaceWrapper(QSurfaceWrapper &&) = delete;
    QSurfaceWrapper& operator=(QSurfaceWrapper &&) = delete;

    QSurfaceWrapper(::QSurface::SurfaceClass type);
    ::QSurfaceFormat format() const override;
    ::QSize size() const override;
    ::QPlatformSurface * surfaceHandle() const override;
    ::QSurface::SurfaceType surfaceType() const override;
    ~QSurfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[4];
};

#endif // SBK_QSurfaceWrapper_H

