// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTextBlockUserDataWrapper_H
#define SBK_QTextBlockUserDataWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qtextobject.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QTextBlockUserDataWrapper : public QTextBlockUserData
{
public:
    QTextBlockUserDataWrapper(const QTextBlockUserDataWrapper &) = delete;
    QTextBlockUserDataWrapper& operator=(const QTextBlockUserDataWrapper &) = delete;
    QTextBlockUserDataWrapper(QTextBlockUserDataWrapper &&) = delete;
    QTextBlockUserDataWrapper& operator=(QTextBlockUserDataWrapper &&) = delete;

    QTextBlockUserDataWrapper();
    ~QTextBlockUserDataWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QTextBlockUserDataWrapper_H

