// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qtextlayout_formatrange_wrapper.h"

// Argument includes
#include <QTextLayout>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QTextLayout_FormatRange_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QTextLayout::FormatRange >()))
        return -1;

    ::QTextLayout::FormatRange *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QTextLayout.FormatRange.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "FormatRange", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: FormatRange::FormatRange()
    // 1: FormatRange::FormatRange(QTextLayout::FormatRange)
    if (numArgs == 0) {
        overloadId = 0; // FormatRange()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), (pyArgs[0])))) {
        overloadId = 1; // FormatRange(QTextLayout::FormatRange)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // FormatRange()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // FormatRange()
                cptr = new ::QTextLayout::FormatRange();
            }
            break;
        }
        case 1: // FormatRange(const QTextLayout::FormatRange &FormatRange)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QTextLayout::FormatRange cppArg0_local;
            ::QTextLayout::FormatRange *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // FormatRange(QTextLayout::FormatRange)
                cptr = new ::QTextLayout::FormatRange(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QTextLayout::FormatRange >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QTextLayout_FormatRange__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QTextLayout::FormatRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QTextLayout_FormatRange_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QTextLayout_FormatRange_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QTextLayout_FormatRange__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QTextLayout_FormatRange_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QTextLayout::FormatRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), (pyArg)))) {
                // operator!=(const QTextLayout::FormatRange &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QTextLayout::FormatRange cppArg0_local;
                ::QTextLayout::FormatRange *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), (pyArg)))) {
                // operator==(const QTextLayout::FormatRange &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QTextLayout::FormatRange cppArg0_local;
                ::QTextLayout::FormatRange *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

static PyObject *Sbk_QTextLayout_FormatRange_get_start(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTextLayout::FormatRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->start;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QTextLayout_FormatRange_set_start(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QTextLayout::FormatRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("start");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("start", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->start;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->start = cppOut_local;

    return 0;
}

static PyObject *Sbk_QTextLayout_FormatRange_get_length(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTextLayout::FormatRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->length;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QTextLayout_FormatRange_set_length(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QTextLayout::FormatRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("length");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("length", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->length;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->length = cppOut_local;

    return 0;
}

static PyObject *Sbk_QTextLayout_FormatRange_get_format(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTextLayout::FormatRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->format)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextCharFormat_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->format))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->format)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextCharFormat_IDX]), &(cppSelf->format), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QTextLayout_FormatRange_set_format(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QTextLayout::FormatRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("format");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextCharFormat_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("format", "QTextCharFormat");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->format;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for FormatRange
static PyGetSetDef Sbk_QTextLayout_FormatRange_getsetlist[] = {
    {const_cast<char *>("start"), Sbk_QTextLayout_FormatRange_get_start, Sbk_QTextLayout_FormatRange_set_start, nullptr, nullptr},
    {const_cast<char *>("length"), Sbk_QTextLayout_FormatRange_get_length, Sbk_QTextLayout_FormatRange_set_length, nullptr, nullptr},
    {const_cast<char *>("format"), Sbk_QTextLayout_FormatRange_get_format, Sbk_QTextLayout_FormatRange_set_format, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QTextLayout_FormatRange_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QTextLayout_FormatRange_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QTextLayout_FormatRange_Type = nullptr;
static PyTypeObject *Sbk_QTextLayout_FormatRange_TypeF(void)
{
    return _Sbk_QTextLayout_FormatRange_Type;
}

static PyType_Slot Sbk_QTextLayout_FormatRange_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QTextLayout_FormatRange_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QTextLayout_FormatRange_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QTextLayout_FormatRange_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QTextLayout_FormatRange_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QTextLayout_FormatRange_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QTextLayout_FormatRange_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QTextLayout_FormatRange_spec = {
    "2:PySide6.QtGui.QTextLayout.FormatRange",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QTextLayout_FormatRange_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void FormatRange_PythonToCpp_FormatRange_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QTextLayout_FormatRange_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_FormatRange_PythonToCpp_FormatRange_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QTextLayout_FormatRange_TypeF()))
        return FormatRange_PythonToCpp_FormatRange_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *FormatRange_PTR_CppToPython_FormatRange(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QTextLayout::FormatRange *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QTextLayout_FormatRange_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *FormatRange_COPY_CppToPython_FormatRange(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QTextLayout::FormatRange *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QTextLayout_FormatRange_TypeF(), new ::QTextLayout::FormatRange(*source), true, true);
}

// Python to C++ copy conversion.
static void FormatRange_PythonToCpp_FormatRange_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QTextLayout::FormatRange *>(cppOut) = *reinterpret_cast< ::QTextLayout::FormatRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_FormatRange_PythonToCpp_FormatRange_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QTextLayout_FormatRange_TypeF()))
        return FormatRange_PythonToCpp_FormatRange_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QTextLayout_FormatRange_SignatureStrings[] = {
    "1:PySide6.QtGui.QTextLayout.FormatRange(self)",
    "0:PySide6.QtGui.QTextLayout.FormatRange(self,FormatRange:PySide6.QtGui.QTextLayout.FormatRange)",
    "PySide6.QtGui.QTextLayout.FormatRange.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QTextLayout_FormatRange(PyObject *enclosingClass)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX].type;

    Shiboken::AutoDecRef Sbk_QTextLayout_FormatRange_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QTextLayout_FormatRange_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "FormatRange",
        "QTextLayout::FormatRange",
        &Sbk_QTextLayout_FormatRange_spec,
        &Shiboken::callCppDestructor< ::QTextLayout::FormatRange >,
        Sbk_QTextLayout_FormatRange_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QTextLayout_FormatRange_TypeF(); // references _Sbk_QTextLayout_FormatRange_Type
    InitSignatureStrings(pyType, QTextLayout_FormatRange_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QTextLayout_FormatRange_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QTextLayout_FormatRange_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        FormatRange_PythonToCpp_FormatRange_PTR,
        is_FormatRange_PythonToCpp_FormatRange_PTR_Convertible,
        FormatRange_PTR_CppToPython_FormatRange,
        FormatRange_COPY_CppToPython_FormatRange);

    Shiboken::Conversions::registerConverterName(converter, "QTextLayout::FormatRange");
    Shiboken::Conversions::registerConverterName(converter, "QTextLayout::FormatRange*");
    Shiboken::Conversions::registerConverterName(converter, "QTextLayout::FormatRange&");
    Shiboken::Conversions::registerConverterName(converter, "FormatRange");
    Shiboken::Conversions::registerConverterName(converter, "FormatRange*");
    Shiboken::Conversions::registerConverterName(converter, "FormatRange&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QTextLayout::FormatRange).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        FormatRange_PythonToCpp_FormatRange_COPY,
        is_FormatRange_PythonToCpp_FormatRange_COPY_Convertible);

    qRegisterMetaType< ::QTextLayout::FormatRange >("FormatRange");
    qRegisterMetaType< ::QTextLayout::FormatRange >("QTextLayout::FormatRange");

    return pyType;
}
