// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qtguihelper_qoverridecursorguard_wrapper.h"

// Argument includes
#include <qtguihelper.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>

using namespace QtGuiHelper;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QtGuiHelper_QOverrideCursorGuard_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QtGuiHelper::QOverrideCursorGuard >()))
        return -1;

    ::QtGuiHelper::QOverrideCursorGuard *cptr{};
    static const char fullName[] = "PySide6.QtGui.QOverrideCursorGuard.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // QOverrideCursorGuard()
            cptr = new ::QtGuiHelper::QOverrideCursorGuard();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QtGuiHelper::QOverrideCursorGuard >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QtGuiHelper_QOverrideCursorGuardFunc___enter__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtGuiHelper::QOverrideCursorGuard *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QtGuiHelper_QOverrideCursorGuard_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QOverrideCursorGuard.__enter__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // __enter__()
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: ../glue/qtcore.cpp (default-enter)]
            Py_INCREF(self);
            pyResult = self;
            // END of custom code block [file: ../glue/qtcore.cpp (default-enter)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QtGuiHelper_QOverrideCursorGuardFunc___exit__(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtGuiHelper::QOverrideCursorGuard *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QtGuiHelper_QOverrideCursorGuard_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QOverrideCursorGuard.__exit__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "__exit__", 3, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QOverrideCursorGuard::__exit__(PyObject*,PyObject*,PyObject*)
    if (numArgs == 3
        && true
        && true
        && true) {
        overloadId = 0; // __exit__(PyObject*,PyObject*,PyObject*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // __exit__(PyObject*,PyObject*,PyObject*)
            // Begin code injection
            cppSelf->restoreOverrideCursor();
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QtGuiHelper_QOverrideCursorGuardFunc_restoreOverrideCursor(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtGuiHelper::QOverrideCursorGuard *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QtGuiHelper_QOverrideCursorGuard_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PySide6.QtGui.QOverrideCursorGuard.restoreOverrideCursor";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // restoreOverrideCursor()
            cppSelf->restoreOverrideCursor();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QtGuiHelper_QOverrideCursorGuard_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QtGuiHelper_QOverrideCursorGuard_methods[] = {
    {"__enter__", reinterpret_cast<PyCFunction>(Sbk_QtGuiHelper_QOverrideCursorGuardFunc___enter__), METH_NOARGS, nullptr},
    {"__exit__", reinterpret_cast<PyCFunction>(Sbk_QtGuiHelper_QOverrideCursorGuardFunc___exit__), METH_VARARGS, nullptr},
    {"restoreOverrideCursor", reinterpret_cast<PyCFunction>(Sbk_QtGuiHelper_QOverrideCursorGuardFunc_restoreOverrideCursor), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QtGuiHelper_QOverrideCursorGuard_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QtGuiHelper_QOverrideCursorGuard_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QtGuiHelper_QOverrideCursorGuard_Type = nullptr;
static PyTypeObject *Sbk_QtGuiHelper_QOverrideCursorGuard_TypeF(void)
{
    return _Sbk_QtGuiHelper_QOverrideCursorGuard_Type;
}

static PyType_Slot Sbk_QtGuiHelper_QOverrideCursorGuard_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QtGuiHelper_QOverrideCursorGuard_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QtGuiHelper_QOverrideCursorGuard_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QtGuiHelper_QOverrideCursorGuard_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QtGuiHelper_QOverrideCursorGuard_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QtGuiHelper_QOverrideCursorGuard_spec = {
    "2:PySide6.QtGui.QOverrideCursorGuard",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QtGuiHelper_QOverrideCursorGuard_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QOverrideCursorGuard_PythonToCpp_QOverrideCursorGuard_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QtGuiHelper_QOverrideCursorGuard_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QOverrideCursorGuard_PythonToCpp_QOverrideCursorGuard_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QtGuiHelper_QOverrideCursorGuard_TypeF()))
        return QOverrideCursorGuard_PythonToCpp_QOverrideCursorGuard_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QOverrideCursorGuard_PTR_CppToPython_QOverrideCursorGuard(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QtGuiHelper::QOverrideCursorGuard *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QtGuiHelper_QOverrideCursorGuard_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtGuiHelper_QOverrideCursorGuard_SignatureStrings[] = {
    "PySide6.QtGui.QOverrideCursorGuard(self)",
    "PySide6.QtGui.QOverrideCursorGuard.__enter__(self)->PySide6.QtGui.QOverrideCursorGuard",
    "PySide6.QtGui.QOverrideCursorGuard.__exit__(self,arg__1:PyObject,arg__2:PyObject,arg__3:PyObject)",
    "PySide6.QtGui.QOverrideCursorGuard.restoreOverrideCursor(self)",
    nullptr}; // Sentinel

PyTypeObject *init_QtGuiHelper_QOverrideCursorGuard(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QtGuiHelper_QOverrideCursorGuard_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QtGuiHelper_QOverrideCursorGuard_IDX].type;

    Shiboken::AutoDecRef Sbk_QtGuiHelper_QOverrideCursorGuard_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QtGuiHelper_QOverrideCursorGuard_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QOverrideCursorGuard",
        "QtGuiHelper::QOverrideCursorGuard*",
        &Sbk_QtGuiHelper_QOverrideCursorGuard_spec,
        &Shiboken::callCppDestructor< ::QtGuiHelper::QOverrideCursorGuard >,
        Sbk_QtGuiHelper_QOverrideCursorGuard_Type_bases.object(),
        0);
    auto *pyType = Sbk_QtGuiHelper_QOverrideCursorGuard_TypeF(); // references _Sbk_QtGuiHelper_QOverrideCursorGuard_Type
    InitSignatureStrings(pyType, QtGuiHelper_QOverrideCursorGuard_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QtGuiHelper_QOverrideCursorGuard_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QtGuiHelper_QOverrideCursorGuard_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QOverrideCursorGuard_PythonToCpp_QOverrideCursorGuard_PTR,
        is_QOverrideCursorGuard_PythonToCpp_QOverrideCursorGuard_PTR_Convertible,
        QOverrideCursorGuard_PTR_CppToPython_QOverrideCursorGuard);

    Shiboken::Conversions::registerConverterName(converter, "QtGuiHelper::QOverrideCursorGuard");
    Shiboken::Conversions::registerConverterName(converter, "QtGuiHelper::QOverrideCursorGuard*");
    Shiboken::Conversions::registerConverterName(converter, "QtGuiHelper::QOverrideCursorGuard&");
    Shiboken::Conversions::registerConverterName(converter, "QOverrideCursorGuard");
    Shiboken::Conversions::registerConverterName(converter, "QOverrideCursorGuard*");
    Shiboken::Conversions::registerConverterName(converter, "QOverrideCursorGuard&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QtGuiHelper::QOverrideCursorGuard).name());

    qRegisterMetaType< ::QtGuiHelper::QOverrideCursorGuard *>();

    return pyType;
}
