// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qthelp_python.h"

// main header
#include "qcompressedhelpinfo_wrapper.h"

// Argument includes
#include <QString>
#include <QtHelp/qcompressedhelpinfo.h>
#include <qversionnumber.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCompressedHelpInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCompressedHelpInfo >()))
        return -1;

    ::QCompressedHelpInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtHelp.QCompressedHelpInfo.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QCompressedHelpInfo", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QCompressedHelpInfo::QCompressedHelpInfo()
    // 1: QCompressedHelpInfo::QCompressedHelpInfo(QCompressedHelpInfo)
    if (numArgs == 0) {
        overloadId = 0; // QCompressedHelpInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QCompressedHelpInfo(QCompressedHelpInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QCompressedHelpInfo()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QCompressedHelpInfo()
                cptr = new ::QCompressedHelpInfo();
            }
            break;
        }
        case 1: // QCompressedHelpInfo(const QCompressedHelpInfo &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QCompressedHelpInfo cppArg0_local;
            ::QCompressedHelpInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QCompressedHelpInfo(QCompressedHelpInfo)
                cptr = new ::QCompressedHelpInfo(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCompressedHelpInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCompressedHelpInfoFunc_component(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCompressedHelpInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtHelp.QCompressedHelpInfo.component";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // component()const
            QString cppResult = const_cast<const ::QCompressedHelpInfo *>(cppSelf)->component();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCompressedHelpInfoFunc_fromCompressedHelpFile(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtHelp.QCompressedHelpInfo.fromCompressedHelpFile";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QCompressedHelpInfo::fromCompressedHelpFile(QString)->QCompressedHelpInfo
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // fromCompressedHelpFile(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // fromCompressedHelpFile(QString)
            QCompressedHelpInfo cppResult = ::QCompressedHelpInfo::fromCompressedHelpFile(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCompressedHelpInfoFunc_isNull(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCompressedHelpInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtHelp.QCompressedHelpInfo.isNull";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isNull()const
            bool cppResult = const_cast<const ::QCompressedHelpInfo *>(cppSelf)->isNull();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCompressedHelpInfoFunc_namespaceName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCompressedHelpInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtHelp.QCompressedHelpInfo.namespaceName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // namespaceName()const
            QString cppResult = const_cast<const ::QCompressedHelpInfo *>(cppSelf)->namespaceName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCompressedHelpInfoFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCompressedHelpInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtHelp.QCompressedHelpInfo.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCompressedHelpInfo::swap(QCompressedHelpInfo&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QCompressedHelpInfo&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QCompressedHelpInfo cppArg0_local;
        ::QCompressedHelpInfo *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QCompressedHelpInfo&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCompressedHelpInfoFunc_version(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCompressedHelpInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtHelp.QCompressedHelpInfo.version";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // version()const
            QVersionNumber cppResult = const_cast<const ::QCompressedHelpInfo *>(cppSelf)->version();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QVersionNumber_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCompressedHelpInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCompressedHelpInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCompressedHelpInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCompressedHelpInfo_methods[] = {
    {"component", reinterpret_cast<PyCFunction>(Sbk_QCompressedHelpInfoFunc_component), METH_NOARGS, nullptr},
    {"fromCompressedHelpFile", reinterpret_cast<PyCFunction>(Sbk_QCompressedHelpInfoFunc_fromCompressedHelpFile), METH_O|METH_STATIC, nullptr},
    {"isNull", reinterpret_cast<PyCFunction>(Sbk_QCompressedHelpInfoFunc_isNull), METH_NOARGS, nullptr},
    {"namespaceName", reinterpret_cast<PyCFunction>(Sbk_QCompressedHelpInfoFunc_namespaceName), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QCompressedHelpInfoFunc_swap), METH_O, nullptr},
    {"version", reinterpret_cast<PyCFunction>(Sbk_QCompressedHelpInfoFunc_version), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QCompressedHelpInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_QCompressedHelpInfo___nb_bool(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return -1;
    auto *cppSelf = reinterpret_cast< ::QCompressedHelpInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return !cppSelf->isNull() ? 1 : 0;
}

} // extern "C"

static int Sbk_QCompressedHelpInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCompressedHelpInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCompressedHelpInfo_Type = nullptr;
static PyTypeObject *Sbk_QCompressedHelpInfo_TypeF(void)
{
    return _Sbk_QCompressedHelpInfo_Type;
}

static PyType_Slot Sbk_QCompressedHelpInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCompressedHelpInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCompressedHelpInfo_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCompressedHelpInfo_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCompressedHelpInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_bool,        reinterpret_cast<void *>(Sbk_QCompressedHelpInfo___nb_bool)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCompressedHelpInfo_spec = {
    "2:PySide6.QtHelp.QCompressedHelpInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC,
    Sbk_QCompressedHelpInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QCompressedHelpInfo_PythonToCpp_QCompressedHelpInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCompressedHelpInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QCompressedHelpInfo_PythonToCpp_QCompressedHelpInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCompressedHelpInfo_TypeF()))
        return QCompressedHelpInfo_PythonToCpp_QCompressedHelpInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QCompressedHelpInfo_PTR_CppToPython_QCompressedHelpInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QCompressedHelpInfo *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QCompressedHelpInfo_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QCompressedHelpInfo_COPY_CppToPython_QCompressedHelpInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QCompressedHelpInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QCompressedHelpInfo_TypeF(), new ::QCompressedHelpInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void QCompressedHelpInfo_PythonToCpp_QCompressedHelpInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QCompressedHelpInfo *>(cppOut) = *reinterpret_cast< ::QCompressedHelpInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QCompressedHelpInfo_PythonToCpp_QCompressedHelpInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QCompressedHelpInfo_TypeF()))
        return QCompressedHelpInfo_PythonToCpp_QCompressedHelpInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QCompressedHelpInfo_SignatureStrings[] = {
    "1:PySide6.QtHelp.QCompressedHelpInfo(self)",
    "0:PySide6.QtHelp.QCompressedHelpInfo(self,other:PySide6.QtHelp.QCompressedHelpInfo)",
    "PySide6.QtHelp.QCompressedHelpInfo.component(self)->QString",
    "PySide6.QtHelp.QCompressedHelpInfo.fromCompressedHelpFile(documentationFileName:QString)->PySide6.QtHelp.QCompressedHelpInfo",
    "PySide6.QtHelp.QCompressedHelpInfo.isNull(self)->bool",
    "PySide6.QtHelp.QCompressedHelpInfo.namespaceName(self)->QString",
    "PySide6.QtHelp.QCompressedHelpInfo.swap(self,other:PySide6.QtHelp.QCompressedHelpInfo)",
    "PySide6.QtHelp.QCompressedHelpInfo.version(self)->PySide6.QtCore.QVersionNumber",
    "PySide6.QtHelp.QCompressedHelpInfo.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QCompressedHelpInfo(PyObject *module)
{
    if (SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX].type != nullptr)
        return SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX].type;

    Shiboken::AutoDecRef Sbk_QCompressedHelpInfo_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QCompressedHelpInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QCompressedHelpInfo",
        "QCompressedHelpInfo",
        &Sbk_QCompressedHelpInfo_spec,
        &Shiboken::callCppDestructor< ::QCompressedHelpInfo >,
        Sbk_QCompressedHelpInfo_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QCompressedHelpInfo_TypeF(); // references _Sbk_QCompressedHelpInfo_Type
    InitSignatureStrings(pyType, QCompressedHelpInfo_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCompressedHelpInfo_PropertyStrings);
    SbkPySide6_QtHelpTypeStructs[SBK_QCompressedHelpInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QCompressedHelpInfo_PythonToCpp_QCompressedHelpInfo_PTR,
        is_QCompressedHelpInfo_PythonToCpp_QCompressedHelpInfo_PTR_Convertible,
        QCompressedHelpInfo_PTR_CppToPython_QCompressedHelpInfo,
        QCompressedHelpInfo_COPY_CppToPython_QCompressedHelpInfo);

    Shiboken::Conversions::registerConverterName(converter, "QCompressedHelpInfo");
    Shiboken::Conversions::registerConverterName(converter, "QCompressedHelpInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QCompressedHelpInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCompressedHelpInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QCompressedHelpInfo_PythonToCpp_QCompressedHelpInfo_COPY,
        is_QCompressedHelpInfo_PythonToCpp_QCompressedHelpInfo_COPY_Convertible);

    qRegisterMetaType< ::QCompressedHelpInfo >("QCompressedHelpInfo");

    return pyType;
}
