// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGeoRouteReplyWrapper_H
#define SBK_QGeoRouteReplyWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qgeoroutereply.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGeoRouteReplyWrapper : public QGeoRouteReply
{
public:
    QGeoRouteReplyWrapper(const QGeoRouteReplyWrapper &) = delete;
    QGeoRouteReplyWrapper& operator=(const QGeoRouteReplyWrapper &) = delete;
    QGeoRouteReplyWrapper(QGeoRouteReplyWrapper &&) = delete;
    QGeoRouteReplyWrapper& operator=(QGeoRouteReplyWrapper &&) = delete;

    QGeoRouteReplyWrapper(::QGeoRouteReply::Error error, const ::QString & errorString, ::QObject * parent = nullptr);
    QGeoRouteReplyWrapper(const ::QGeoRouteRequest & request, ::QObject * parent = nullptr);
    void abort() override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QGeoRouteReplyWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#endif // SBK_QGeoRouteReplyWrapper_H

