// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtmultimedia_python.h"

// main header
#include "qaudio_wrapper.h"

// Argument includes
#include <QtMultimedia/qaudio.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>



// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QAudioFunc_convertVolume(PyObject *self, PyObject *args)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QAudio.convertVolume";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "convertVolume", 3, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QAudio::convertVolume(float,QAudio::VolumeScale,QAudio::VolumeScale)->float
    if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QAudio_VolumeScale_IDX])))->converter, (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QAudio_VolumeScale_IDX])))->converter, (pyArgs[2])))) {
        overloadId = 0; // convertVolume(float,QAudio::VolumeScale,QAudio::VolumeScale)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        float cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QAudio::VolumeScale cppArg1{QAudio::LinearVolumeScale};
        pythonToCpp[1](pyArgs[1], &cppArg1);
        ::QAudio::VolumeScale cppArg2{QAudio::LinearVolumeScale};
        pythonToCpp[2](pyArgs[2], &cppArg2);

        if (Shiboken::Errors::occurred() == nullptr) {
            // convertVolume(float,QAudio::VolumeScale,QAudio::VolumeScale)
            float cppResult = ::QAudio::convertVolume(cppArg0, cppArg1, cppArg2);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QAudio_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QAudio_EnumFlagInfo[] = {
    "Error:Enum",
    "State:Enum",
    "VolumeScale:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QAudio_methods[] = {
    {"convertVolume", reinterpret_cast<PyCFunction>(Sbk_QAudioFunc_convertVolume), METH_VARARGS|METH_STATIC, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QAudio_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QAudio_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QAudio_Type = nullptr;
static PyTypeObject *Sbk_QAudio_TypeF(void)
{
    return _Sbk_QAudio_Type;
}

static PyType_Slot Sbk_QAudio_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QAudio_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QAudio_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QAudio_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QAudio_spec = {
    "2:PySide6.QtMultimedia.QAudio",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QAudio_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QAudio_Error(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QAudio::Error>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QAudio::Error *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QAudio_Error_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QAudio_Error_IDX])))
        return Enum_PythonToCpp_QAudio_Error;
    return {};
}
static PyObject *QAudio_Error_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QAudio::Error *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QAudio_Error_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QAudio_State(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QAudio::State>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QAudio::State *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QAudio_State_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QAudio_State_IDX])))
        return Enum_PythonToCpp_QAudio_State;
    return {};
}
static PyObject *QAudio_State_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QAudio::State *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QAudio_State_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QAudio_VolumeScale(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QAudio::VolumeScale>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QAudio::VolumeScale *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QAudio_VolumeScale_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QAudio_VolumeScale_IDX])))
        return Enum_PythonToCpp_QAudio_VolumeScale;
    return {};
}
static PyObject *QAudio_VolumeScale_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QAudio::VolumeScale *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QAudio_VolumeScale_IDX]), castCppIn);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtMultimediaQAudio_SignatureStrings[] = {
    "PySide6.QtMultimedia.QAudio.convertVolume(volume:float,from:PySide6.QtMultimedia.QAudio.VolumeScale,to:PySide6.QtMultimedia.QAudio.VolumeScale)->float",
    nullptr}; // Sentinel

PyTypeObject *init_QtMultimediaQAudio(PyObject *module)
{
    if (SbkPySide6_QtMultimediaTypeStructs[SBK_QtMultimediaQAudio_IDX].type != nullptr)
        return SbkPySide6_QtMultimediaTypeStructs[SBK_QtMultimediaQAudio_IDX].type;

    Shiboken::AutoDecRef Sbk_QAudio_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QAudio_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QAudio",
        "QAudio",
        &Sbk_QAudio_spec,
        nullptr,
        Sbk_QAudio_Type_bases.object(),
        0);
    auto *pyType = Sbk_QAudio_TypeF(); // references _Sbk_QAudio_Type
    InitSignatureStrings(pyType, QtMultimediaQAudio_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QAudio_PropertyStrings);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QtMultimediaQAudio_IDX].type = pyType;



    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QAudio_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Error'.
    const char *Error_Initializer[] = {
        "NoError",
        "OpenError",
        "IOError",
        "UnderrunError",
        "FatalError",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Error_InitializerValues[] = {
        uint8_t(QAudio::Error::NoError),       //  0x00  0
        uint8_t(QAudio::Error::OpenError),     //  0x01  1
        uint8_t(QAudio::Error::IOError),       //  0x02  2
        uint8_t(QAudio::Error::UnderrunError), //  0x03  3
        uint8_t(QAudio::Error::FatalError)     //  0x04  4
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QAudio_TypeF(),
        "2:PySide6.QtMultimedia.QAudio.Error",
        Error_Initializer, Error_InitializerValues);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QAudio_Error_IDX].type = EType;
    // Register converter for enum 'QAudio::Error'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QAudio_Error_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QAudio_Error,
            is_Enum_PythonToCpp_QAudio_Error_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QAudio::Error");
        Shiboken::Conversions::registerConverterName(converter, "Error");
    }
    // End of 'Error' enum.

    // Initialization of enum 'State'.
    const char *State_Initializer[] = {
        "ActiveState",
        "SuspendedState",
        "StoppedState",
        "IdleState",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t State_InitializerValues[] = {
        uint8_t(QAudio::State::ActiveState),    //  0x00  0
        uint8_t(QAudio::State::SuspendedState), //  0x01  1
        uint8_t(QAudio::State::StoppedState),   //  0x02  2
        uint8_t(QAudio::State::IdleState)       //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QAudio_TypeF(),
        "2:PySide6.QtMultimedia.QAudio.State",
        State_Initializer, State_InitializerValues);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QAudio_State_IDX].type = EType;
    // Register converter for enum 'QAudio::State'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QAudio_State_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QAudio_State,
            is_Enum_PythonToCpp_QAudio_State_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QAudio::State");
        Shiboken::Conversions::registerConverterName(converter, "State");
    }
    // End of 'State' enum.

    // Initialization of enum 'VolumeScale'.
    const char *VolumeScale_Initializer[] = {
        "LinearVolumeScale",
        "CubicVolumeScale",
        "LogarithmicVolumeScale",
        "DecibelVolumeScale",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t VolumeScale_InitializerValues[] = {
        uint8_t(QAudio::VolumeScale::LinearVolumeScale),      //  0x00  0
        uint8_t(QAudio::VolumeScale::CubicVolumeScale),       //  0x01  1
        uint8_t(QAudio::VolumeScale::LogarithmicVolumeScale), //  0x02  2
        uint8_t(QAudio::VolumeScale::DecibelVolumeScale)      //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QAudio_TypeF(),
        "2:PySide6.QtMultimedia.QAudio.VolumeScale",
        VolumeScale_Initializer, VolumeScale_InitializerValues);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QAudio_VolumeScale_IDX].type = EType;
    // Register converter for enum 'QAudio::VolumeScale'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QAudio_VolumeScale_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QAudio_VolumeScale,
            is_Enum_PythonToCpp_QAudio_VolumeScale_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QAudio::VolumeScale");
        Shiboken::Conversions::registerConverterName(converter, "VolumeScale");
    }
    // End of 'VolumeScale' enum.


    // Begin code injection
    // ========================================================================
    // START of custom code block [file: ../glue/qtmultimedia.cpp (qtaudio-namespace-compatibility-alias)]
    Py_INCREF(pyType);
    PyModule_AddObject(module, "QtAudio", reinterpret_cast<PyObject *>(pyType));
    // END of custom code block [file: ../glue/qtmultimedia.cpp (qtaudio-namespace-compatibility-alias)]
    // ========================================================================
    // End of code injection

    qRegisterMetaType< ::QAudio::Error >("QAudio::Error");
    qRegisterMetaType< ::QAudio::State >("QAudio::State");
    qRegisterMetaType< ::QAudio::VolumeScale >("QAudio::VolumeScale");

    return pyType;
}

