// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDnsLookupWrapper_H
#define SBK_QDnsLookupWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetwork/qdnslookup.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QDnsLookupWrapper : public QDnsLookup
{
public:
    QDnsLookupWrapper(const QDnsLookupWrapper &) = delete;
    QDnsLookupWrapper& operator=(const QDnsLookupWrapper &) = delete;
    QDnsLookupWrapper(QDnsLookupWrapper &&) = delete;
    QDnsLookupWrapper& operator=(QDnsLookupWrapper &&) = delete;

    QDnsLookupWrapper(::QDnsLookup::Type type, const ::QString & name, ::QObject * parent = nullptr);
    QDnsLookupWrapper(::QDnsLookup::Type type, const ::QString & name, const ::QHostAddress & nameserver, ::QObject * parent = nullptr);
    QDnsLookupWrapper(::QDnsLookup::Type type, const ::QString & name, const ::QHostAddress & nameserver, quint16 port, ::QObject * parent = nullptr);
    QDnsLookupWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QDnsLookupWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QDnsLookupWrapper_H

