// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnetwork_python.h"

// main header
#include "qsslellipticcurve_wrapper.h"

// Argument includes
#include <QString>
#include <QtNetwork/qsslellipticcurve.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSslEllipticCurve_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSslEllipticCurve >()))
        return -1;

    ::QSslEllipticCurve *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QSslEllipticCurve.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QSslEllipticCurve", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QSslEllipticCurve::QSslEllipticCurve()
    // 1: QSslEllipticCurve::QSslEllipticCurve(QSslEllipticCurve)
    if (numArgs == 0) {
        overloadId = 0; // QSslEllipticCurve()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QSslEllipticCurve(QSslEllipticCurve)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QSslEllipticCurve()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QSslEllipticCurve()
                cptr = new ::QSslEllipticCurve();
            }
            break;
        }
        case 1: // QSslEllipticCurve(const QSslEllipticCurve &QSslEllipticCurve)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QSslEllipticCurve cppArg0_local;
            ::QSslEllipticCurve *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QSslEllipticCurve(QSslEllipticCurve)
                cptr = new ::QSslEllipticCurve(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSslEllipticCurve >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QSslEllipticCurveFunc_fromLongName(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QSslEllipticCurve.fromLongName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QSslEllipticCurve::fromLongName(QString)->QSslEllipticCurve
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // fromLongName(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // fromLongName(QString)
            QSslEllipticCurve cppResult = ::QSslEllipticCurve::fromLongName(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslEllipticCurveFunc_fromShortName(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QSslEllipticCurve.fromShortName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QSslEllipticCurve::fromShortName(QString)->QSslEllipticCurve
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // fromShortName(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // fromShortName(QString)
            QSslEllipticCurve cppResult = ::QSslEllipticCurve::fromShortName(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslEllipticCurveFunc_isTlsNamedCurve(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslEllipticCurve *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QSslEllipticCurve.isTlsNamedCurve";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isTlsNamedCurve()const
            bool cppResult = const_cast<const ::QSslEllipticCurve *>(cppSelf)->isTlsNamedCurve();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslEllipticCurveFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslEllipticCurve *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QSslEllipticCurve.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::QSslEllipticCurve *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslEllipticCurveFunc_longName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslEllipticCurve *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QSslEllipticCurve.longName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // longName()const
            QString cppResult = const_cast<const ::QSslEllipticCurve *>(cppSelf)->longName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslEllipticCurveFunc_shortName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslEllipticCurve *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QSslEllipticCurve.shortName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // shortName()const
            QString cppResult = const_cast<const ::QSslEllipticCurve *>(cppSelf)->shortName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslEllipticCurve__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSslEllipticCurve *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QSslEllipticCurve_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSslEllipticCurve_methods[] = {
    {"fromLongName", reinterpret_cast<PyCFunction>(Sbk_QSslEllipticCurveFunc_fromLongName), METH_O|METH_STATIC, nullptr},
    {"fromShortName", reinterpret_cast<PyCFunction>(Sbk_QSslEllipticCurveFunc_fromShortName), METH_O|METH_STATIC, nullptr},
    {"isTlsNamedCurve", reinterpret_cast<PyCFunction>(Sbk_QSslEllipticCurveFunc_isTlsNamedCurve), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QSslEllipticCurveFunc_isValid), METH_NOARGS, nullptr},
    {"longName", reinterpret_cast<PyCFunction>(Sbk_QSslEllipticCurveFunc_longName), METH_NOARGS, nullptr},
    {"shortName", reinterpret_cast<PyCFunction>(Sbk_QSslEllipticCurveFunc_shortName), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QSslEllipticCurve__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QSslEllipticCurve_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSslEllipticCurve *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), (pyArg)))) {
                // operator!=(QSslEllipticCurve rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QSslEllipticCurve cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf != (cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), (pyArg)))) {
                // operator==(QSslEllipticCurve rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QSslEllipticCurve cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf == (cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static Py_hash_t Sbk_QSslEllipticCurve_HashFunc(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslEllipticCurve *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return Py_hash_t(qHash(*cppSelf));
}

static int Sbk_QSslEllipticCurve_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSslEllipticCurve_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QSslEllipticCurve__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslEllipticCurve *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSslEllipticCurve_Type = nullptr;
static PyTypeObject *Sbk_QSslEllipticCurve_TypeF(void)
{
    return _Sbk_QSslEllipticCurve_Type;
}

static PyType_Slot Sbk_QSslEllipticCurve_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QSslEllipticCurve__repr__)},
    {Py_tp_hash,        reinterpret_cast<void *>(&Sbk_QSslEllipticCurve_HashFunc)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSslEllipticCurve_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSslEllipticCurve_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QSslEllipticCurve_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSslEllipticCurve_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSslEllipticCurve_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSslEllipticCurve_spec = {
    "2:PySide6.QtNetwork.QSslEllipticCurve",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSslEllipticCurve_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QSslEllipticCurve_PythonToCpp_QSslEllipticCurve_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSslEllipticCurve_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QSslEllipticCurve_PythonToCpp_QSslEllipticCurve_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QSslEllipticCurve_TypeF()))
        return QSslEllipticCurve_PythonToCpp_QSslEllipticCurve_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QSslEllipticCurve_PTR_CppToPython_QSslEllipticCurve(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QSslEllipticCurve *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QSslEllipticCurve_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QSslEllipticCurve_COPY_CppToPython_QSslEllipticCurve(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QSslEllipticCurve *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QSslEllipticCurve_TypeF(), new ::QSslEllipticCurve(*source), true, true);
}

// Python to C++ copy conversion.
static void QSslEllipticCurve_PythonToCpp_QSslEllipticCurve_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QSslEllipticCurve *>(cppOut) = *reinterpret_cast< ::QSslEllipticCurve *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QSslEllipticCurve_PythonToCpp_QSslEllipticCurve_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QSslEllipticCurve_TypeF()))
        return QSslEllipticCurve_PythonToCpp_QSslEllipticCurve_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QSslEllipticCurve_SignatureStrings[] = {
    "1:PySide6.QtNetwork.QSslEllipticCurve(self)",
    "0:PySide6.QtNetwork.QSslEllipticCurve(self,QSslEllipticCurve:PySide6.QtNetwork.QSslEllipticCurve)",
    "PySide6.QtNetwork.QSslEllipticCurve.fromLongName(name:QString)->PySide6.QtNetwork.QSslEllipticCurve",
    "PySide6.QtNetwork.QSslEllipticCurve.fromShortName(name:QString)->PySide6.QtNetwork.QSslEllipticCurve",
    "PySide6.QtNetwork.QSslEllipticCurve.isTlsNamedCurve(self)->bool",
    "PySide6.QtNetwork.QSslEllipticCurve.isValid(self)->bool",
    "PySide6.QtNetwork.QSslEllipticCurve.longName(self)->QString",
    "PySide6.QtNetwork.QSslEllipticCurve.shortName(self)->QString",
    "PySide6.QtNetwork.QSslEllipticCurve.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QSslEllipticCurve(PyObject *module)
{
    if (SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX].type != nullptr)
        return SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX].type;

    Shiboken::AutoDecRef Sbk_QSslEllipticCurve_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QSslEllipticCurve_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QSslEllipticCurve",
        "QSslEllipticCurve",
        &Sbk_QSslEllipticCurve_spec,
        &Shiboken::callCppDestructor< ::QSslEllipticCurve >,
        Sbk_QSslEllipticCurve_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QSslEllipticCurve_TypeF(); // references _Sbk_QSslEllipticCurve_Type
    InitSignatureStrings(pyType, QSslEllipticCurve_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSslEllipticCurve_PropertyStrings);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSslEllipticCurve_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QSslEllipticCurve_PythonToCpp_QSslEllipticCurve_PTR,
        is_QSslEllipticCurve_PythonToCpp_QSslEllipticCurve_PTR_Convertible,
        QSslEllipticCurve_PTR_CppToPython_QSslEllipticCurve,
        QSslEllipticCurve_COPY_CppToPython_QSslEllipticCurve);

    Shiboken::Conversions::registerConverterName(converter, "QSslEllipticCurve");
    Shiboken::Conversions::registerConverterName(converter, "QSslEllipticCurve*");
    Shiboken::Conversions::registerConverterName(converter, "QSslEllipticCurve&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSslEllipticCurve).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QSslEllipticCurve_PythonToCpp_QSslEllipticCurve_COPY,
        is_QSslEllipticCurve_PythonToCpp_QSslEllipticCurve_COPY_Convertible);

    qRegisterMetaType< ::QSslEllipticCurve >("QSslEllipticCurve");

    return pyType;
}
