// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOAuth2AuthorizationCodeFlowWrapper_H
#define SBK_QOAuth2AuthorizationCodeFlowWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetworkAuth/qoauth2authorizationcodeflow.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QOAuth2AuthorizationCodeFlowWrapper : public QOAuth2AuthorizationCodeFlow
{
public:
    QOAuth2AuthorizationCodeFlowWrapper(const QOAuth2AuthorizationCodeFlowWrapper &) = delete;
    QOAuth2AuthorizationCodeFlowWrapper& operator=(const QOAuth2AuthorizationCodeFlowWrapper &) = delete;
    QOAuth2AuthorizationCodeFlowWrapper(QOAuth2AuthorizationCodeFlowWrapper &&) = delete;
    QOAuth2AuthorizationCodeFlowWrapper& operator=(QOAuth2AuthorizationCodeFlowWrapper &&) = delete;

    QOAuth2AuthorizationCodeFlowWrapper(::QNetworkAccessManager * manager, ::QObject * parent = nullptr);
    QOAuth2AuthorizationCodeFlowWrapper(::QObject * parent = nullptr);
    QOAuth2AuthorizationCodeFlowWrapper(const ::QString & clientIdentifier, ::QNetworkAccessManager * manager, ::QObject * parent = nullptr);
    QOAuth2AuthorizationCodeFlowWrapper(const ::QString & clientIdentifier, const ::QUrl & authorizationUrl, const ::QUrl & accessTokenUrl, ::QNetworkAccessManager * manager, ::QObject * parent = nullptr);
    QOAuth2AuthorizationCodeFlowWrapper(const ::QUrl & authorizationUrl, const ::QUrl & accessTokenUrl, ::QNetworkAccessManager * manager, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QUrl createAuthenticatedUrl(const ::QUrl & url, const ::QMap<QString,QVariant> & parameters = QVariantMap()) override;
    void customEvent(::QEvent * event) override;
    ::QNetworkReply * deleteResource(const ::QUrl & url, const ::QMap<QString,QVariant> & parameters = QVariantMap()) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QNetworkReply * get(const ::QUrl & url, const ::QMap<QString,QVariant> & parameters = QVariantMap()) override;
    void grant() override;
    ::QNetworkReply * head(const ::QUrl & url, const ::QMap<QString,QVariant> & parameters = QVariantMap()) override;
    ::QNetworkReply * post(const ::QUrl & url, ::QHttpMultiPart * multiPart) override;
    ::QNetworkReply * post(const ::QUrl & url, const ::QByteArray & data) override;
    ::QNetworkReply * post(const ::QUrl & url, const ::QMap<QString,QVariant> & parameters = QVariantMap()) override;
    void prepareRequest(::QNetworkRequest * request, const ::QByteArray & verb, const ::QByteArray & body = QByteArray()) override;
    ::QNetworkReply * put(const ::QUrl & url, ::QHttpMultiPart * multiPart) override;
    ::QNetworkReply * put(const ::QUrl & url, const ::QByteArray & data) override;
    ::QNetworkReply * put(const ::QUrl & url, const ::QMap<QString,QVariant> & parameters = QVariantMap()) override;
    void resourceOwnerAuthorization(const ::QUrl & url, const ::QMultiMap<QString,QVariant> & parameters = {}) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QOAuth2AuthorizationCodeFlowWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[20];
};

#endif // SBK_QOAuth2AuthorizationCodeFlowWrapper_H

