// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnfc_python.h"

// main header
#include "qndefnfciconrecord_wrapper.h"

// Argument includes
#include <QtNfc/qndefrecord.h>
#include <qbytearray.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QNdefNfcIconRecord_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QNdefNfcIconRecord >()))
        return -1;

    ::QNdefNfcIconRecord *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcIconRecord.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QNdefNfcIconRecord", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QNdefNfcIconRecord::QNdefNfcIconRecord()
    // 1: QNdefNfcIconRecord::QNdefNfcIconRecord(QNdefNfcIconRecord)
    // 2: QNdefNfcIconRecord::QNdefNfcIconRecord(QNdefRecord)
    if (numArgs == 0) {
        overloadId = 0; // QNdefNfcIconRecord()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcIconRecord_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QNdefNfcIconRecord(QNdefNfcIconRecord)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QNdefNfcIconRecord(QNdefRecord)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QNdefNfcIconRecord()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QNdefNfcIconRecord()
                cptr = new ::QNdefNfcIconRecord();
            }
            break;
        }
        case 1: // QNdefNfcIconRecord(const QNdefNfcIconRecord &QNdefNfcIconRecord)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QNdefNfcIconRecord cppArg0_local;
            ::QNdefNfcIconRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QNdefNfcIconRecord(QNdefNfcIconRecord)
                cptr = new ::QNdefNfcIconRecord(*cppArg0);
            }
            break;
        }
        case 2: // QNdefNfcIconRecord(const QNdefRecord &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QNdefRecord cppArg0_local;
            ::QNdefRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QNdefNfcIconRecord(QNdefRecord)
                cptr = new ::QNdefNfcIconRecord(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QNdefNfcIconRecord >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QNdefNfcIconRecordFunc_data(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcIconRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcIconRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcIconRecord.data";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // data()const
            QByteArray cppResult = const_cast<const ::QNdefNfcIconRecord *>(cppSelf)->data();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcIconRecordFunc_setData(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcIconRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcIconRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcIconRecord.setData";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefNfcIconRecord::setData(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArg)))) {
        overloadId = 0; // setData(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setData(QByteArray)
            cppSelf->setData(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QNdefNfcIconRecord__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QNdefNfcIconRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcIconRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcIconRecord_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QNdefNfcIconRecord_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QNdefNfcIconRecord_methods[] = {
    {"data", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcIconRecordFunc_data), METH_NOARGS, nullptr},
    {"setData", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcIconRecordFunc_setData), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcIconRecord__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QNdefNfcIconRecord_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QNdefNfcIconRecord_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QNdefNfcIconRecord_Type = nullptr;
static PyTypeObject *Sbk_QNdefNfcIconRecord_TypeF(void)
{
    return _Sbk_QNdefNfcIconRecord_Type;
}

static PyType_Slot Sbk_QNdefNfcIconRecord_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QNdefNfcIconRecord_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QNdefNfcIconRecord_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QNdefNfcIconRecord_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QNdefNfcIconRecord_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QNdefNfcIconRecord_spec = {
    "2:PySide6.QtNfc.QNdefNfcIconRecord",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QNdefNfcIconRecord_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QNdefNfcIconRecord_PythonToCpp_QNdefNfcIconRecord_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QNdefNfcIconRecord_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QNdefNfcIconRecord_PythonToCpp_QNdefNfcIconRecord_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QNdefNfcIconRecord_TypeF()))
        return QNdefNfcIconRecord_PythonToCpp_QNdefNfcIconRecord_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QNdefNfcIconRecord_PTR_CppToPython_QNdefNfcIconRecord(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QNdefNfcIconRecord *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QNdefNfcIconRecord_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QNdefNfcIconRecord_COPY_CppToPython_QNdefNfcIconRecord(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QNdefNfcIconRecord *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QNdefNfcIconRecord_TypeF(), new ::QNdefNfcIconRecord(*source), true, true);
}

// Python to C++ copy conversion.
static void QNdefNfcIconRecord_PythonToCpp_QNdefNfcIconRecord_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QNdefNfcIconRecord *>(cppOut) = *reinterpret_cast< ::QNdefNfcIconRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcIconRecord_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QNdefNfcIconRecord_PythonToCpp_QNdefNfcIconRecord_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QNdefNfcIconRecord_TypeF()))
        return QNdefNfcIconRecord_PythonToCpp_QNdefNfcIconRecord_COPY;
    return {};
}

// Implicit conversions.
static void constQNdefRecordREF_PythonToCpp_QNdefNfcIconRecord(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QNdefNfcIconRecord *>(cppOut) = ::QNdefNfcIconRecord( *reinterpret_cast< ::QNdefRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_IDX]), reinterpret_cast<SbkObject *>(pyIn))));
}
static PythonToCppFunc is_constQNdefRecordREF_PythonToCpp_QNdefNfcIconRecord_Convertible(PyObject *pyIn)
{
    if (SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_IDX]), pyIn))
        return constQNdefRecordREF_PythonToCpp_QNdefNfcIconRecord;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QNdefNfcIconRecord_SignatureStrings[] = {
    "2:PySide6.QtNfc.QNdefNfcIconRecord(self)",
    "1:PySide6.QtNfc.QNdefNfcIconRecord(self,QNdefNfcIconRecord:typing.Union[PySide6.QtNfc.QNdefNfcIconRecord, PySide6.QtNfc.QNdefRecord])",
    "0:PySide6.QtNfc.QNdefNfcIconRecord(self,other:PySide6.QtNfc.QNdefRecord)",
    "PySide6.QtNfc.QNdefNfcIconRecord.data(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtNfc.QNdefNfcIconRecord.setData(self,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtNfc.QNdefNfcIconRecord.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QNdefNfcIconRecord(PyObject *module)
{
    if (SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcIconRecord_IDX].type != nullptr)
        return SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcIconRecord_IDX].type;

    Shiboken::AutoDecRef Sbk_QNdefNfcIconRecord_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_IDX]))));

    _Sbk_QNdefNfcIconRecord_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QNdefNfcIconRecord",
        "QNdefNfcIconRecord",
        &Sbk_QNdefNfcIconRecord_spec,
        &Shiboken::callCppDestructor< ::QNdefNfcIconRecord >,
        Sbk_QNdefNfcIconRecord_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QNdefNfcIconRecord_TypeF(); // references _Sbk_QNdefNfcIconRecord_Type
    InitSignatureStrings(pyType, QNdefNfcIconRecord_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QNdefNfcIconRecord_PropertyStrings);
    SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcIconRecord_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QNdefNfcIconRecord_PythonToCpp_QNdefNfcIconRecord_PTR,
        is_QNdefNfcIconRecord_PythonToCpp_QNdefNfcIconRecord_PTR_Convertible,
        QNdefNfcIconRecord_PTR_CppToPython_QNdefNfcIconRecord,
        QNdefNfcIconRecord_COPY_CppToPython_QNdefNfcIconRecord);

    Shiboken::Conversions::registerConverterName(converter, "QNdefNfcIconRecord");
    Shiboken::Conversions::registerConverterName(converter, "QNdefNfcIconRecord*");
    Shiboken::Conversions::registerConverterName(converter, "QNdefNfcIconRecord&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QNdefNfcIconRecord).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QNdefNfcIconRecord_PythonToCpp_QNdefNfcIconRecord_COPY,
        is_QNdefNfcIconRecord_PythonToCpp_QNdefNfcIconRecord_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        constQNdefRecordREF_PythonToCpp_QNdefNfcIconRecord,
        is_constQNdefRecordREF_PythonToCpp_QNdefNfcIconRecord_Convertible);

    qRegisterMetaType< ::QNdefNfcIconRecord >("QNdefNfcIconRecord");

    return pyType;
}
