// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGeoAreaMonitorSourceWrapper_H
#define SBK_QGeoAreaMonitorSourceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtPositioning/qgeoareamonitorsource.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGeoAreaMonitorSourceWrapper : public QGeoAreaMonitorSource
{
public:
    QGeoAreaMonitorSourceWrapper(const QGeoAreaMonitorSourceWrapper &) = delete;
    QGeoAreaMonitorSourceWrapper& operator=(const QGeoAreaMonitorSourceWrapper &) = delete;
    QGeoAreaMonitorSourceWrapper(QGeoAreaMonitorSourceWrapper &&) = delete;
    QGeoAreaMonitorSourceWrapper& operator=(QGeoAreaMonitorSourceWrapper &&) = delete;

    QGeoAreaMonitorSourceWrapper(::QObject * parent);
    ::QList<QGeoAreaMonitorInfo> activeMonitors() const override;
    ::QList<QGeoAreaMonitorInfo> activeMonitors(const ::QGeoShape & lookupArea) const override;
    ::QVariant backendProperty(const ::QString & name) const override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    ::QGeoAreaMonitorSource::Error error() const override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QGeoPositionInfoSource * positionInfoSource() const override;
    bool requestUpdate(const ::QGeoAreaMonitorInfo & monitor, const char * signal) override;
    bool setBackendProperty(const ::QString & name, const ::QVariant & value) override;
    void setPositionInfoSource(::QGeoPositionInfoSource * source) override;
    bool startMonitoring(const ::QGeoAreaMonitorInfo & monitor) override;
    bool stopMonitoring(const ::QGeoAreaMonitorInfo & monitor) override;
    ::QFlags<QGeoAreaMonitorSource::AreaMonitorFeature> supportedAreaMonitorFeatures() const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QGeoAreaMonitorSourceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[18];
};

#endif // SBK_QGeoAreaMonitorSourceWrapper_H

