// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPrinterWrapper_H
#define SBK_QPrinterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtPrintSupport/qprinter.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QPrinterWrapper : public QPrinter
{
public:
    QPrinterWrapper(const QPrinterWrapper &) = delete;
    QPrinterWrapper& operator=(const QPrinterWrapper &) = delete;
    QPrinterWrapper(QPrinterWrapper &&) = delete;
    QPrinterWrapper& operator=(QPrinterWrapper &&) = delete;

    QPrinterWrapper(::QPrinter::PrinterMode mode = QPrinter::PrinterMode::ScreenResolution);
    QPrinterWrapper(const ::QPrinterInfo & printer, ::QPrinter::PrinterMode mode = QPrinter::PrinterMode::ScreenResolution);
    int devType() const override;
    void initPainter(::QPainter * painter) const override;
    int metric(::QPaintDevice::PaintDeviceMetric arg__1) const override;
    bool newPage() override;
    ::QPaintEngine * paintEngine() const override;
    ::QPaintDevice * redirected(::QPoint * offset) const override;
    bool setPageLayout(const ::QPageLayout & pageLayout) override;
    bool setPageMargins(const ::QMarginsF & margins, ::QPageLayout::Unit units = QPageLayout::Millimeter) override;
    bool setPageOrientation(::QPageLayout::Orientation orientation) override;
    void setPageRanges(const ::QPageRanges & ranges) override;
    ::QPainter * sharedPainter() const override;
    ~QPrinterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[11];
};

#endif // SBK_QPrinterWrapper_H

