// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtqml_python.h"

// main header
#include "qqmlcontext_propertypair_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QQmlContext_PropertyPair_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QQmlContext::PropertyPair >()))
        return -1;

    ::QQmlContext::PropertyPair *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QQmlContext.PropertyPair.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "PropertyPair", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: PropertyPair::PropertyPair()
    // 1: PropertyPair::PropertyPair(QQmlContext::PropertyPair)
    if (numArgs == 0) {
        overloadId = 0; // PropertyPair()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_PropertyPair_IDX]), (pyArgs[0])))) {
        overloadId = 1; // PropertyPair(QQmlContext::PropertyPair)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // PropertyPair()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // PropertyPair()
                cptr = new ::QQmlContext::PropertyPair();
            }
            break;
        }
        case 1: // PropertyPair(const QQmlContext::PropertyPair &PropertyPair)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QQmlContext::PropertyPair cppArg0_local;
            ::QQmlContext::PropertyPair *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // PropertyPair(QQmlContext::PropertyPair)
                cptr = new ::QQmlContext::PropertyPair(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QQmlContext::PropertyPair >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QQmlContext_PropertyPair__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QQmlContext::PropertyPair *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_PropertyPair_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_PropertyPair_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QQmlContext_PropertyPair_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQmlContext_PropertyPair_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QQmlContext_PropertyPair__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QQmlContext_PropertyPair_get_name(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlContext::PropertyPair *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_PropertyPair_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppSelf->name);
    return pyOut;
}
static int Sbk_QQmlContext_PropertyPair_set_name(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QQmlContext::PropertyPair *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_PropertyPair_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("name");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("name", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->name;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QQmlContext_PropertyPair_get_value(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlContext::PropertyPair *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_PropertyPair_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppSelf->value);
    return pyOut;
}
static int Sbk_QQmlContext_PropertyPair_set_value(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QQmlContext::PropertyPair *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_PropertyPair_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("value");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("value", "QVariant");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->value;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for PropertyPair
static PyGetSetDef Sbk_QQmlContext_PropertyPair_getsetlist[] = {
    {const_cast<char *>("name"), Sbk_QQmlContext_PropertyPair_get_name, Sbk_QQmlContext_PropertyPair_set_name, nullptr, nullptr},
    {const_cast<char *>("value"), Sbk_QQmlContext_PropertyPair_get_value, Sbk_QQmlContext_PropertyPair_set_value, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QQmlContext_PropertyPair_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QQmlContext_PropertyPair_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQmlContext_PropertyPair_Type = nullptr;
static PyTypeObject *Sbk_QQmlContext_PropertyPair_TypeF(void)
{
    return _Sbk_QQmlContext_PropertyPair_Type;
}

static PyType_Slot Sbk_QQmlContext_PropertyPair_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQmlContext_PropertyPair_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQmlContext_PropertyPair_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQmlContext_PropertyPair_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QQmlContext_PropertyPair_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QQmlContext_PropertyPair_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQmlContext_PropertyPair_spec = {
    "2:PySide6.QtQml.QQmlContext.PropertyPair",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQmlContext_PropertyPair_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void PropertyPair_PythonToCpp_PropertyPair_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QQmlContext_PropertyPair_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_PropertyPair_PythonToCpp_PropertyPair_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QQmlContext_PropertyPair_TypeF()))
        return PropertyPair_PythonToCpp_PropertyPair_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *PropertyPair_PTR_CppToPython_PropertyPair(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QQmlContext::PropertyPair *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QQmlContext_PropertyPair_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *PropertyPair_COPY_CppToPython_PropertyPair(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QQmlContext::PropertyPair *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QQmlContext_PropertyPair_TypeF(), new ::QQmlContext::PropertyPair(*source), true, true);
}

// Python to C++ copy conversion.
static void PropertyPair_PythonToCpp_PropertyPair_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QQmlContext::PropertyPair *>(cppOut) = *reinterpret_cast< ::QQmlContext::PropertyPair *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_PropertyPair_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_PropertyPair_PythonToCpp_PropertyPair_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QQmlContext_PropertyPair_TypeF()))
        return PropertyPair_PythonToCpp_PropertyPair_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QQmlContext_PropertyPair_SignatureStrings[] = {
    "1:PySide6.QtQml.QQmlContext.PropertyPair(self)",
    "0:PySide6.QtQml.QQmlContext.PropertyPair(self,PropertyPair:PySide6.QtQml.QQmlContext.PropertyPair)",
    "PySide6.QtQml.QQmlContext.PropertyPair.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QQmlContext_PropertyPair(PyObject *enclosingClass)
{
    if (SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_PropertyPair_IDX].type != nullptr)
        return SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_PropertyPair_IDX].type;

    Shiboken::AutoDecRef Sbk_QQmlContext_PropertyPair_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QQmlContext_PropertyPair_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "PropertyPair",
        "QQmlContext::PropertyPair",
        &Sbk_QQmlContext_PropertyPair_spec,
        &Shiboken::callCppDestructor< ::QQmlContext::PropertyPair >,
        Sbk_QQmlContext_PropertyPair_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QQmlContext_PropertyPair_TypeF(); // references _Sbk_QQmlContext_PropertyPair_Type
    InitSignatureStrings(pyType, QQmlContext_PropertyPair_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QQmlContext_PropertyPair_PropertyStrings);
    SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_PropertyPair_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        PropertyPair_PythonToCpp_PropertyPair_PTR,
        is_PropertyPair_PythonToCpp_PropertyPair_PTR_Convertible,
        PropertyPair_PTR_CppToPython_PropertyPair,
        PropertyPair_COPY_CppToPython_PropertyPair);

    Shiboken::Conversions::registerConverterName(converter, "QQmlContext::PropertyPair");
    Shiboken::Conversions::registerConverterName(converter, "QQmlContext::PropertyPair*");
    Shiboken::Conversions::registerConverterName(converter, "QQmlContext::PropertyPair&");
    Shiboken::Conversions::registerConverterName(converter, "PropertyPair");
    Shiboken::Conversions::registerConverterName(converter, "PropertyPair*");
    Shiboken::Conversions::registerConverterName(converter, "PropertyPair&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQmlContext::PropertyPair).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        PropertyPair_PythonToCpp_PropertyPair_COPY,
        is_PropertyPair_PythonToCpp_PropertyPair_COPY_Convertible);

    qRegisterMetaType< ::QQmlContext::PropertyPair >("PropertyPair");
    qRegisterMetaType< ::QQmlContext::PropertyPair >("QQmlContext::PropertyPair");

    return pyType;
}
