// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQmlParserStatusWrapper_H
#define SBK_QQmlParserStatusWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlparserstatus.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QQmlParserStatusWrapper : public QQmlParserStatus
{
public:
    QQmlParserStatusWrapper(const QQmlParserStatusWrapper &) = delete;
    QQmlParserStatusWrapper& operator=(const QQmlParserStatusWrapper &) = delete;
    QQmlParserStatusWrapper(QQmlParserStatusWrapper &&) = delete;
    QQmlParserStatusWrapper& operator=(QQmlParserStatusWrapper &&) = delete;

    QQmlParserStatusWrapper();
    void classBegin() override;
    void componentComplete() override;
    ~QQmlParserStatusWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QQmlParserStatusWrapper_H

