// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtquick_python.h"

// main header
#include "qsggeometry_coloredpoint2d_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSGGeometry_ColoredPoint2D_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSGGeometry::ColoredPoint2D >()))
        return -1;

    ::QSGGeometry::ColoredPoint2D *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQuick.QSGGeometry.ColoredPoint2D.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "ColoredPoint2D", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: ColoredPoint2D::ColoredPoint2D()
    // 1: ColoredPoint2D::ColoredPoint2D(QSGGeometry::ColoredPoint2D)
    if (numArgs == 0) {
        overloadId = 0; // ColoredPoint2D()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), (pyArgs[0])))) {
        overloadId = 1; // ColoredPoint2D(QSGGeometry::ColoredPoint2D)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // ColoredPoint2D()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // ColoredPoint2D()
                cptr = new ::QSGGeometry::ColoredPoint2D();
            }
            break;
        }
        case 1: // ColoredPoint2D(const QSGGeometry::ColoredPoint2D &ColoredPoint2D)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QSGGeometry::ColoredPoint2D cppArg0_local;
            ::QSGGeometry::ColoredPoint2D *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // ColoredPoint2D(QSGGeometry::ColoredPoint2D)
                cptr = new ::QSGGeometry::ColoredPoint2D(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSGGeometry::ColoredPoint2D >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QSGGeometry_ColoredPoint2DFunc_set(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQuick.QSGGeometry.ColoredPoint2D.set";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[6];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "set", 6, 6, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3]), &(pyArgs[4]), &(pyArgs[5])) == 0)
        return {};


    // Overloaded function decisor
    // 0: ColoredPoint2D::set(float,float,uchar,uchar,uchar,uchar)
    if (numArgs == 6
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyArgs[1])))
        && SbkChar_Check(pyArgs[2]) && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), (pyArgs[2])))
        && SbkChar_Check(pyArgs[3]) && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), (pyArgs[3])))
        && SbkChar_Check(pyArgs[4]) && (pythonToCpp[4] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), (pyArgs[4])))
        && SbkChar_Check(pyArgs[5]) && (pythonToCpp[5] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uchar>(), (pyArgs[5])))) {
        overloadId = 0; // set(float,float,uchar,uchar,uchar,uchar)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        float cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        float cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        uchar cppArg2;
        pythonToCpp[2](pyArgs[2], &cppArg2);
        uchar cppArg3;
        pythonToCpp[3](pyArgs[3], &cppArg3);
        uchar cppArg4;
        pythonToCpp[4](pyArgs[4], &cppArg4);
        uchar cppArg5;
        pythonToCpp[5](pyArgs[5], &cppArg5);

        if (Shiboken::Errors::occurred() == nullptr) {
            // set(float,float,uchar,uchar,uchar,uchar)
            cppSelf->set(cppArg0, cppArg1, cppArg2, cppArg3, cppArg4, cppArg5);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QSGGeometry_ColoredPoint2D__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QSGGeometry_ColoredPoint2D_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSGGeometry_ColoredPoint2D_methods[] = {
    {"set", reinterpret_cast<PyCFunction>(Sbk_QSGGeometry_ColoredPoint2DFunc_set), METH_VARARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QSGGeometry_ColoredPoint2D__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QSGGeometry_ColoredPoint2D_get_x(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppSelf->x);
    return pyOut;
}
static int Sbk_QSGGeometry_ColoredPoint2D_set_x(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("x");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("x", "float");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->x;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QSGGeometry_ColoredPoint2D_get_y(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppSelf->y);
    return pyOut;
}
static int Sbk_QSGGeometry_ColoredPoint2D_set_y(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("y");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("y", "float");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->y;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QSGGeometry_ColoredPoint2D_get_r(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    unsigned char cppOut_local = cppSelf->r;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned char>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QSGGeometry_ColoredPoint2D_set_r(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("r");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!SbkChar_Check(pyIn) && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned char>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("r", "unsigned char");
        return -1;
    }

    auto cppOut_local = cppSelf->r;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->r = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGGeometry_ColoredPoint2D_get_g(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    unsigned char cppOut_local = cppSelf->g;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned char>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QSGGeometry_ColoredPoint2D_set_g(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("g");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!SbkChar_Check(pyIn) && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned char>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("g", "unsigned char");
        return -1;
    }

    auto cppOut_local = cppSelf->g;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->g = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGGeometry_ColoredPoint2D_get_b(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    unsigned char cppOut_local = cppSelf->b;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned char>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QSGGeometry_ColoredPoint2D_set_b(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("b");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!SbkChar_Check(pyIn) && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned char>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("b", "unsigned char");
        return -1;
    }

    auto cppOut_local = cppSelf->b;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->b = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGGeometry_ColoredPoint2D_get_a(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    unsigned char cppOut_local = cppSelf->a;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned char>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QSGGeometry_ColoredPoint2D_set_a(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("a");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!SbkChar_Check(pyIn) && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned char>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("a", "unsigned char");
        return -1;
    }

    auto cppOut_local = cppSelf->a;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->a = cppOut_local;

    return 0;
}

// Getters and Setters for ColoredPoint2D
static PyGetSetDef Sbk_QSGGeometry_ColoredPoint2D_getsetlist[] = {
    {const_cast<char *>("x"), Sbk_QSGGeometry_ColoredPoint2D_get_x, Sbk_QSGGeometry_ColoredPoint2D_set_x, nullptr, nullptr},
    {const_cast<char *>("y"), Sbk_QSGGeometry_ColoredPoint2D_get_y, Sbk_QSGGeometry_ColoredPoint2D_set_y, nullptr, nullptr},
    {const_cast<char *>("r"), Sbk_QSGGeometry_ColoredPoint2D_get_r, Sbk_QSGGeometry_ColoredPoint2D_set_r, nullptr, nullptr},
    {const_cast<char *>("g"), Sbk_QSGGeometry_ColoredPoint2D_get_g, Sbk_QSGGeometry_ColoredPoint2D_set_g, nullptr, nullptr},
    {const_cast<char *>("b"), Sbk_QSGGeometry_ColoredPoint2D_get_b, Sbk_QSGGeometry_ColoredPoint2D_set_b, nullptr, nullptr},
    {const_cast<char *>("a"), Sbk_QSGGeometry_ColoredPoint2D_get_a, Sbk_QSGGeometry_ColoredPoint2D_set_a, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QSGGeometry_ColoredPoint2D_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSGGeometry_ColoredPoint2D_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSGGeometry_ColoredPoint2D_Type = nullptr;
static PyTypeObject *Sbk_QSGGeometry_ColoredPoint2D_TypeF(void)
{
    return _Sbk_QSGGeometry_ColoredPoint2D_Type;
}

static PyType_Slot Sbk_QSGGeometry_ColoredPoint2D_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSGGeometry_ColoredPoint2D_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSGGeometry_ColoredPoint2D_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSGGeometry_ColoredPoint2D_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QSGGeometry_ColoredPoint2D_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSGGeometry_ColoredPoint2D_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSGGeometry_ColoredPoint2D_spec = {
    "2:PySide6.QtQuick.QSGGeometry.ColoredPoint2D",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSGGeometry_ColoredPoint2D_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void ColoredPoint2D_PythonToCpp_ColoredPoint2D_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSGGeometry_ColoredPoint2D_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_ColoredPoint2D_PythonToCpp_ColoredPoint2D_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QSGGeometry_ColoredPoint2D_TypeF()))
        return ColoredPoint2D_PythonToCpp_ColoredPoint2D_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *ColoredPoint2D_PTR_CppToPython_ColoredPoint2D(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QSGGeometry::ColoredPoint2D *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QSGGeometry_ColoredPoint2D_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *ColoredPoint2D_COPY_CppToPython_ColoredPoint2D(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QSGGeometry::ColoredPoint2D *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QSGGeometry_ColoredPoint2D_TypeF(), new ::QSGGeometry::ColoredPoint2D(*source), true, true);
}

// Python to C++ copy conversion.
static void ColoredPoint2D_PythonToCpp_ColoredPoint2D_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QSGGeometry::ColoredPoint2D *>(cppOut) = *reinterpret_cast< ::QSGGeometry::ColoredPoint2D *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_ColoredPoint2D_PythonToCpp_ColoredPoint2D_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QSGGeometry_ColoredPoint2D_TypeF()))
        return ColoredPoint2D_PythonToCpp_ColoredPoint2D_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QSGGeometry_ColoredPoint2D_SignatureStrings[] = {
    "1:PySide6.QtQuick.QSGGeometry.ColoredPoint2D(self)",
    "0:PySide6.QtQuick.QSGGeometry.ColoredPoint2D(self,ColoredPoint2D:PySide6.QtQuick.QSGGeometry.ColoredPoint2D)",
    "PySide6.QtQuick.QSGGeometry.ColoredPoint2D.set(self,nx:float,ny:float,nr:uchar,ng:uchar,nb:uchar,na:uchar)",
    "PySide6.QtQuick.QSGGeometry.ColoredPoint2D.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QSGGeometry_ColoredPoint2D(PyObject *enclosingClass)
{
    if (SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX].type != nullptr)
        return SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX].type;

    Shiboken::AutoDecRef Sbk_QSGGeometry_ColoredPoint2D_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QSGGeometry_ColoredPoint2D_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "ColoredPoint2D",
        "QSGGeometry::ColoredPoint2D",
        &Sbk_QSGGeometry_ColoredPoint2D_spec,
        &Shiboken::callCppDestructor< ::QSGGeometry::ColoredPoint2D >,
        Sbk_QSGGeometry_ColoredPoint2D_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QSGGeometry_ColoredPoint2D_TypeF(); // references _Sbk_QSGGeometry_ColoredPoint2D_Type
    InitSignatureStrings(pyType, QSGGeometry_ColoredPoint2D_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSGGeometry_ColoredPoint2D_PropertyStrings);
    SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_ColoredPoint2D_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        ColoredPoint2D_PythonToCpp_ColoredPoint2D_PTR,
        is_ColoredPoint2D_PythonToCpp_ColoredPoint2D_PTR_Convertible,
        ColoredPoint2D_PTR_CppToPython_ColoredPoint2D,
        ColoredPoint2D_COPY_CppToPython_ColoredPoint2D);

    Shiboken::Conversions::registerConverterName(converter, "QSGGeometry::ColoredPoint2D");
    Shiboken::Conversions::registerConverterName(converter, "QSGGeometry::ColoredPoint2D*");
    Shiboken::Conversions::registerConverterName(converter, "QSGGeometry::ColoredPoint2D&");
    Shiboken::Conversions::registerConverterName(converter, "ColoredPoint2D");
    Shiboken::Conversions::registerConverterName(converter, "ColoredPoint2D*");
    Shiboken::Conversions::registerConverterName(converter, "ColoredPoint2D&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSGGeometry::ColoredPoint2D).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        ColoredPoint2D_PythonToCpp_ColoredPoint2D_COPY,
        is_ColoredPoint2D_PythonToCpp_ColoredPoint2D_COPY_Convertible);

    qRegisterMetaType< ::QSGGeometry::ColoredPoint2D >("ColoredPoint2D");
    qRegisterMetaType< ::QSGGeometry::ColoredPoint2D >("QSGGeometry::ColoredPoint2D");

    return pyType;
}
