// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtquick_python.h"

// main header
#include "qsgmaterialshader_graphicspipelinestate_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSGMaterialShader_GraphicsPipelineState_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSGMaterialShader::GraphicsPipelineState >()))
        return -1;

    ::QSGMaterialShader::GraphicsPipelineState *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.GraphicsPipelineState.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "GraphicsPipelineState", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: GraphicsPipelineState::GraphicsPipelineState()
    // 1: GraphicsPipelineState::GraphicsPipelineState(QSGMaterialShader::GraphicsPipelineState)
    if (numArgs == 0) {
        overloadId = 0; // GraphicsPipelineState()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), (pyArgs[0])))) {
        overloadId = 1; // GraphicsPipelineState(QSGMaterialShader::GraphicsPipelineState)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // GraphicsPipelineState()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // GraphicsPipelineState()
                cptr = new ::QSGMaterialShader::GraphicsPipelineState();
            }
            break;
        }
        case 1: // GraphicsPipelineState(const QSGMaterialShader::GraphicsPipelineState &GraphicsPipelineState)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QSGMaterialShader::GraphicsPipelineState cppArg0_local;
            ::QSGMaterialShader::GraphicsPipelineState *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // GraphicsPipelineState(QSGMaterialShader::GraphicsPipelineState)
                cptr = new ::QSGMaterialShader::GraphicsPipelineState(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSGMaterialShader::GraphicsPipelineState >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QSGMaterialShader_GraphicsPipelineState__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QSGMaterialShader_GraphicsPipelineState_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QSGMaterialShader_GraphicsPipelineState_EnumFlagInfo[] = {
    "BlendFactor:Enum",
    "ColorMaskComponent:Flag:ColorMask",
    "CullMode:Enum",
    "PolygonMode:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSGMaterialShader_GraphicsPipelineState_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_GraphicsPipelineState__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QSGMaterialShader_GraphicsPipelineState_get_blendEnable(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->blendEnable;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QSGMaterialShader_GraphicsPipelineState_set_blendEnable(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("blendEnable");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("blendEnable", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->blendEnable;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->blendEnable = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGMaterialShader_GraphicsPipelineState_get_srcColor(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QSGMaterialShader::GraphicsPipelineState::BlendFactor cppOut_local = cppSelf->srcColor;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_BlendFactor_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QSGMaterialShader_GraphicsPipelineState_set_srcColor(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("srcColor");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_BlendFactor_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("srcColor", "BlendFactor");
        return -1;
    }

    auto cppOut_local = cppSelf->srcColor;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->srcColor = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGMaterialShader_GraphicsPipelineState_get_dstColor(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QSGMaterialShader::GraphicsPipelineState::BlendFactor cppOut_local = cppSelf->dstColor;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_BlendFactor_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QSGMaterialShader_GraphicsPipelineState_set_dstColor(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("dstColor");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_BlendFactor_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("dstColor", "BlendFactor");
        return -1;
    }

    auto cppOut_local = cppSelf->dstColor;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->dstColor = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGMaterialShader_GraphicsPipelineState_get_colorWrite(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QFlags_QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent_IDX])))->converter, &cppSelf->colorWrite);
    return pyOut;
}
static int Sbk_QSGMaterialShader_GraphicsPipelineState_set_colorWrite(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("colorWrite");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QFlags_QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("colorWrite", "ColorMask");
        return -1;
    }

    auto cppOut_local = cppSelf->colorWrite;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->colorWrite = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGMaterialShader_GraphicsPipelineState_get_blendConstant(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->blendConstant)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->blendConstant))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->blendConstant)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &(cppSelf->blendConstant), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QSGMaterialShader_GraphicsPipelineState_set_blendConstant(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("blendConstant");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("blendConstant", "QColor");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->blendConstant;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QSGMaterialShader_GraphicsPipelineState_get_cullMode(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QSGMaterialShader::GraphicsPipelineState::CullMode cppOut_local = cppSelf->cullMode;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_CullMode_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QSGMaterialShader_GraphicsPipelineState_set_cullMode(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("cullMode");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_CullMode_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("cullMode", "CullMode");
        return -1;
    }

    auto cppOut_local = cppSelf->cullMode;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->cullMode = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGMaterialShader_GraphicsPipelineState_get_polygonMode(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QSGMaterialShader::GraphicsPipelineState::PolygonMode cppOut_local = cppSelf->polygonMode;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_PolygonMode_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QSGMaterialShader_GraphicsPipelineState_set_polygonMode(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("polygonMode");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_PolygonMode_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("polygonMode", "PolygonMode");
        return -1;
    }

    auto cppOut_local = cppSelf->polygonMode;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->polygonMode = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGMaterialShader_GraphicsPipelineState_get_separateBlendFactors(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->separateBlendFactors;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QSGMaterialShader_GraphicsPipelineState_set_separateBlendFactors(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("separateBlendFactors");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("separateBlendFactors", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->separateBlendFactors;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->separateBlendFactors = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGMaterialShader_GraphicsPipelineState_get_srcAlpha(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QSGMaterialShader::GraphicsPipelineState::BlendFactor cppOut_local = cppSelf->srcAlpha;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_BlendFactor_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QSGMaterialShader_GraphicsPipelineState_set_srcAlpha(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("srcAlpha");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_BlendFactor_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("srcAlpha", "BlendFactor");
        return -1;
    }

    auto cppOut_local = cppSelf->srcAlpha;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->srcAlpha = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGMaterialShader_GraphicsPipelineState_get_dstAlpha(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QSGMaterialShader::GraphicsPipelineState::BlendFactor cppOut_local = cppSelf->dstAlpha;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_BlendFactor_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QSGMaterialShader_GraphicsPipelineState_set_dstAlpha(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("dstAlpha");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_BlendFactor_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("dstAlpha", "BlendFactor");
        return -1;
    }

    auto cppOut_local = cppSelf->dstAlpha;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->dstAlpha = cppOut_local;

    return 0;
}

// Getters and Setters for GraphicsPipelineState
static PyGetSetDef Sbk_QSGMaterialShader_GraphicsPipelineState_getsetlist[] = {
    {const_cast<char *>("blendEnable"), Sbk_QSGMaterialShader_GraphicsPipelineState_get_blendEnable, Sbk_QSGMaterialShader_GraphicsPipelineState_set_blendEnable, nullptr, nullptr},
    {const_cast<char *>("srcColor"), Sbk_QSGMaterialShader_GraphicsPipelineState_get_srcColor, Sbk_QSGMaterialShader_GraphicsPipelineState_set_srcColor, nullptr, nullptr},
    {const_cast<char *>("dstColor"), Sbk_QSGMaterialShader_GraphicsPipelineState_get_dstColor, Sbk_QSGMaterialShader_GraphicsPipelineState_set_dstColor, nullptr, nullptr},
    {const_cast<char *>("colorWrite"), Sbk_QSGMaterialShader_GraphicsPipelineState_get_colorWrite, Sbk_QSGMaterialShader_GraphicsPipelineState_set_colorWrite, nullptr, nullptr},
    {const_cast<char *>("blendConstant"), Sbk_QSGMaterialShader_GraphicsPipelineState_get_blendConstant, Sbk_QSGMaterialShader_GraphicsPipelineState_set_blendConstant, nullptr, nullptr},
    {const_cast<char *>("cullMode"), Sbk_QSGMaterialShader_GraphicsPipelineState_get_cullMode, Sbk_QSGMaterialShader_GraphicsPipelineState_set_cullMode, nullptr, nullptr},
    {const_cast<char *>("polygonMode"), Sbk_QSGMaterialShader_GraphicsPipelineState_get_polygonMode, Sbk_QSGMaterialShader_GraphicsPipelineState_set_polygonMode, nullptr, nullptr},
    {const_cast<char *>("separateBlendFactors"), Sbk_QSGMaterialShader_GraphicsPipelineState_get_separateBlendFactors, Sbk_QSGMaterialShader_GraphicsPipelineState_set_separateBlendFactors, nullptr, nullptr},
    {const_cast<char *>("srcAlpha"), Sbk_QSGMaterialShader_GraphicsPipelineState_get_srcAlpha, Sbk_QSGMaterialShader_GraphicsPipelineState_set_srcAlpha, nullptr, nullptr},
    {const_cast<char *>("dstAlpha"), Sbk_QSGMaterialShader_GraphicsPipelineState_get_dstAlpha, Sbk_QSGMaterialShader_GraphicsPipelineState_set_dstAlpha, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QSGMaterialShader_GraphicsPipelineState_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSGMaterialShader_GraphicsPipelineState_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSGMaterialShader_GraphicsPipelineState_Type = nullptr;
static PyTypeObject *Sbk_QSGMaterialShader_GraphicsPipelineState_TypeF(void)
{
    return _Sbk_QSGMaterialShader_GraphicsPipelineState_Type;
}

static PyType_Slot Sbk_QSGMaterialShader_GraphicsPipelineState_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSGMaterialShader_GraphicsPipelineState_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSGMaterialShader_GraphicsPipelineState_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSGMaterialShader_GraphicsPipelineState_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QSGMaterialShader_GraphicsPipelineState_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSGMaterialShader_GraphicsPipelineState_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSGMaterialShader_GraphicsPipelineState_spec = {
    "2:PySide6.QtQuick.QSGMaterialShader.GraphicsPipelineState",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSGMaterialShader_GraphicsPipelineState_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_BlendFactor(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSGMaterialShader::GraphicsPipelineState::BlendFactor>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSGMaterialShader::GraphicsPipelineState::BlendFactor *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_BlendFactor_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_BlendFactor_IDX])))
        return Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_BlendFactor;
    return {};
}
static PyObject *QSGMaterialShader_GraphicsPipelineState_BlendFactor_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSGMaterialShader::GraphicsPipelineState::BlendFactor *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_BlendFactor_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent_IDX])))
        return Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent;
    return {};
}
static PyObject *QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_CullMode(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSGMaterialShader::GraphicsPipelineState::CullMode>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSGMaterialShader::GraphicsPipelineState::CullMode *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_CullMode_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_CullMode_IDX])))
        return Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_CullMode;
    return {};
}
static PyObject *QSGMaterialShader_GraphicsPipelineState_CullMode_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSGMaterialShader::GraphicsPipelineState::CullMode *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_CullMode_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_PolygonMode(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSGMaterialShader::GraphicsPipelineState::PolygonMode>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSGMaterialShader::GraphicsPipelineState::PolygonMode *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_PolygonMode_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_PolygonMode_IDX])))
        return Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_PolygonMode;
    return {};
}
static PyObject *QSGMaterialShader_GraphicsPipelineState_PolygonMode_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSGMaterialShader::GraphicsPipelineState::PolygonMode *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_PolygonMode_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void GraphicsPipelineState_PythonToCpp_GraphicsPipelineState_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSGMaterialShader_GraphicsPipelineState_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_GraphicsPipelineState_PythonToCpp_GraphicsPipelineState_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QSGMaterialShader_GraphicsPipelineState_TypeF()))
        return GraphicsPipelineState_PythonToCpp_GraphicsPipelineState_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *GraphicsPipelineState_PTR_CppToPython_GraphicsPipelineState(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QSGMaterialShader::GraphicsPipelineState *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QSGMaterialShader_GraphicsPipelineState_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *GraphicsPipelineState_COPY_CppToPython_GraphicsPipelineState(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QSGMaterialShader::GraphicsPipelineState *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QSGMaterialShader_GraphicsPipelineState_TypeF(), new ::QSGMaterialShader::GraphicsPipelineState(*source), true, true);
}

// Python to C++ copy conversion.
static void GraphicsPipelineState_PythonToCpp_GraphicsPipelineState_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QSGMaterialShader::GraphicsPipelineState *>(cppOut) = *reinterpret_cast< ::QSGMaterialShader::GraphicsPipelineState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_GraphicsPipelineState_PythonToCpp_GraphicsPipelineState_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QSGMaterialShader_GraphicsPipelineState_TypeF()))
        return GraphicsPipelineState_PythonToCpp_GraphicsPipelineState_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QSGMaterialShader_GraphicsPipelineState_SignatureStrings[] = {
    "1:PySide6.QtQuick.QSGMaterialShader.GraphicsPipelineState(self)",
    "0:PySide6.QtQuick.QSGMaterialShader.GraphicsPipelineState(self,GraphicsPipelineState:PySide6.QtQuick.QSGMaterialShader.GraphicsPipelineState)",
    "PySide6.QtQuick.QSGMaterialShader.GraphicsPipelineState.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QSGMaterialShader_GraphicsPipelineState(PyObject *enclosingClass)
{
    if (SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX].type != nullptr)
        return SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX].type;

    Shiboken::AutoDecRef Sbk_QSGMaterialShader_GraphicsPipelineState_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QSGMaterialShader_GraphicsPipelineState_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "GraphicsPipelineState",
        "QSGMaterialShader::GraphicsPipelineState",
        &Sbk_QSGMaterialShader_GraphicsPipelineState_spec,
        &Shiboken::callCppDestructor< ::QSGMaterialShader::GraphicsPipelineState >,
        Sbk_QSGMaterialShader_GraphicsPipelineState_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QSGMaterialShader_GraphicsPipelineState_TypeF(); // references _Sbk_QSGMaterialShader_GraphicsPipelineState_Type
    InitSignatureStrings(pyType, QSGMaterialShader_GraphicsPipelineState_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSGMaterialShader_GraphicsPipelineState_PropertyStrings);
    SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        GraphicsPipelineState_PythonToCpp_GraphicsPipelineState_PTR,
        is_GraphicsPipelineState_PythonToCpp_GraphicsPipelineState_PTR_Convertible,
        GraphicsPipelineState_PTR_CppToPython_GraphicsPipelineState,
        GraphicsPipelineState_COPY_CppToPython_GraphicsPipelineState);

    Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::GraphicsPipelineState");
    Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::GraphicsPipelineState*");
    Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::GraphicsPipelineState&");
    Shiboken::Conversions::registerConverterName(converter, "GraphicsPipelineState");
    Shiboken::Conversions::registerConverterName(converter, "GraphicsPipelineState*");
    Shiboken::Conversions::registerConverterName(converter, "GraphicsPipelineState&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSGMaterialShader::GraphicsPipelineState).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        GraphicsPipelineState_PythonToCpp_GraphicsPipelineState_COPY,
        is_GraphicsPipelineState_PythonToCpp_GraphicsPipelineState_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QSGMaterialShader_GraphicsPipelineState_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'BlendFactor'.
    const char *BlendFactor_Initializer[] = {
        "Zero",
        "One",
        "SrcColor",
        "OneMinusSrcColor",
        "DstColor",
        "OneMinusDstColor",
        "SrcAlpha",
        "OneMinusSrcAlpha",
        "DstAlpha",
        "OneMinusDstAlpha",
        "ConstantColor",
        "OneMinusConstantColor",
        "ConstantAlpha",
        "OneMinusConstantAlpha",
        "SrcAlphaSaturate",
        "Src1Color",
        "OneMinusSrc1Color",
        "Src1Alpha",
        "OneMinusSrc1Alpha",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t BlendFactor_InitializerValues[] = {
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::Zero),                  //  0x00  0
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::One),                   //  0x01  1
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::SrcColor),              //  0x02  2
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::OneMinusSrcColor),      //  0x03  3
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::DstColor),              //  0x04  4
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::OneMinusDstColor),      //  0x05  5
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::SrcAlpha),              //  0x06  6
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::OneMinusSrcAlpha),      //  0x07  7
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::DstAlpha),              //  0x08  8
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::OneMinusDstAlpha),      //  0x09  9
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::ConstantColor),         //  0x0a  10
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::OneMinusConstantColor), //  0x0b  11
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::ConstantAlpha),         //  0x0c  12
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::OneMinusConstantAlpha), //  0x0d  13
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::SrcAlphaSaturate),      //  0x0e  14
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::Src1Color),             //  0x0f  15
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::OneMinusSrc1Color),     //  0x10  16
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::Src1Alpha),             //  0x11  17
        uint8_t(QSGMaterialShader::GraphicsPipelineState::BlendFactor::OneMinusSrc1Alpha)      //  0x12  18
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSGMaterialShader_GraphicsPipelineState_TypeF(),
        "2:PySide6.QtQuick.QSGMaterialShader.GraphicsPipelineState.BlendFactor",
        BlendFactor_Initializer, BlendFactor_InitializerValues);
    SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_BlendFactor_IDX].type = EType;
    // Register converter for enum 'QSGMaterialShader::GraphicsPipelineState::BlendFactor'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSGMaterialShader_GraphicsPipelineState_BlendFactor_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_BlendFactor,
            is_Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_BlendFactor_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::GraphicsPipelineState::BlendFactor");
        Shiboken::Conversions::registerConverterName(converter, "GraphicsPipelineState::BlendFactor");
        Shiboken::Conversions::registerConverterName(converter, "BlendFactor");
    }
    // End of 'BlendFactor' enum.

    // Initialization of enum 'ColorMaskComponent'.
    const char *ColorMaskComponent_Initializer[] = {
        "R",
        "G",
        "B",
        "A",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ColorMaskComponent_InitializerValues[] = {
        uint8_t(QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent::R), //  0x01  1
        uint8_t(QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent::G), //  0x02  2
        uint8_t(QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent::B), //  0x04  4
        uint8_t(QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent::A)  //  0x08  8
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSGMaterialShader_GraphicsPipelineState_TypeF(),
        "2:PySide6.QtQuick.QSGMaterialShader.GraphicsPipelineState.ColorMaskComponent",
        ColorMaskComponent_Initializer, ColorMaskComponent_InitializerValues);
    SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtQuickTypeStructs[SBK_QFlags_QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent_IDX].type =
        EType;
    // Register converter for enum 'QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent,
            is_Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_ColorMaskComponent_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent");
        Shiboken::Conversions::registerConverterName(converter, "GraphicsPipelineState::ColorMaskComponent");
        Shiboken::Conversions::registerConverterName(converter, "ColorMaskComponent");
        // Register converter for flag 'QFlags<QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent>");
        Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::GraphicsPipelineState::ColorMask");
    }
    // End of 'ColorMaskComponent' enum/flags.

    // Initialization of enum 'CullMode'.
    const char *CullMode_Initializer[] = {
        "CullNone",
        "CullFront",
        "CullBack",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t CullMode_InitializerValues[] = {
        uint8_t(QSGMaterialShader::GraphicsPipelineState::CullMode::CullNone),  //  0x00  0
        uint8_t(QSGMaterialShader::GraphicsPipelineState::CullMode::CullFront), //  0x01  1
        uint8_t(QSGMaterialShader::GraphicsPipelineState::CullMode::CullBack)   //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSGMaterialShader_GraphicsPipelineState_TypeF(),
        "2:PySide6.QtQuick.QSGMaterialShader.GraphicsPipelineState.CullMode",
        CullMode_Initializer, CullMode_InitializerValues);
    SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_CullMode_IDX].type = EType;
    // Register converter for enum 'QSGMaterialShader::GraphicsPipelineState::CullMode'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSGMaterialShader_GraphicsPipelineState_CullMode_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_CullMode,
            is_Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_CullMode_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::GraphicsPipelineState::CullMode");
        Shiboken::Conversions::registerConverterName(converter, "GraphicsPipelineState::CullMode");
        Shiboken::Conversions::registerConverterName(converter, "CullMode");
    }
    // End of 'CullMode' enum.

    // Initialization of enum 'PolygonMode'.
    const char *PolygonMode_Initializer[] = {
        "Fill",
        "Line",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t PolygonMode_InitializerValues[] = {
        uint8_t(QSGMaterialShader::GraphicsPipelineState::PolygonMode::Fill), //  0x00  0
        uint8_t(QSGMaterialShader::GraphicsPipelineState::PolygonMode::Line)  //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSGMaterialShader_GraphicsPipelineState_TypeF(),
        "2:PySide6.QtQuick.QSGMaterialShader.GraphicsPipelineState.PolygonMode",
        PolygonMode_Initializer, PolygonMode_InitializerValues);
    SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_GraphicsPipelineState_PolygonMode_IDX].type = EType;
    // Register converter for enum 'QSGMaterialShader::GraphicsPipelineState::PolygonMode'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSGMaterialShader_GraphicsPipelineState_PolygonMode_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_PolygonMode,
            is_Enum_PythonToCpp_QSGMaterialShader_GraphicsPipelineState_PolygonMode_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::GraphicsPipelineState::PolygonMode");
        Shiboken::Conversions::registerConverterName(converter, "GraphicsPipelineState::PolygonMode");
        Shiboken::Conversions::registerConverterName(converter, "PolygonMode");
    }
    // End of 'PolygonMode' enum.

    qRegisterMetaType< ::QSGMaterialShader::GraphicsPipelineState >("GraphicsPipelineState");
    qRegisterMetaType< ::QSGMaterialShader::GraphicsPipelineState >("QSGMaterialShader::GraphicsPipelineState");
    qRegisterMetaType< ::QSGMaterialShader::GraphicsPipelineState::BlendFactor >("GraphicsPipelineState::BlendFactor");
    qRegisterMetaType< ::QSGMaterialShader::GraphicsPipelineState::BlendFactor >("QSGMaterialShader::GraphicsPipelineState::BlendFactor");
    qRegisterMetaType< ::QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent >("GraphicsPipelineState::ColorMaskComponent");
    qRegisterMetaType< ::QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent >("QSGMaterialShader::GraphicsPipelineState::ColorMaskComponent");
    qRegisterMetaType< ::QSGMaterialShader::GraphicsPipelineState::CullMode >("GraphicsPipelineState::CullMode");
    qRegisterMetaType< ::QSGMaterialShader::GraphicsPipelineState::CullMode >("QSGMaterialShader::GraphicsPipelineState::CullMode");
    qRegisterMetaType< ::QSGMaterialShader::GraphicsPipelineState::PolygonMode >("GraphicsPipelineState::PolygonMode");
    qRegisterMetaType< ::QSGMaterialShader::GraphicsPipelineState::PolygonMode >("QSGMaterialShader::GraphicsPipelineState::PolygonMode");

    return pyType;
}
