// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtquick_python.h"

// main header
#include "qsgmaterialshader_renderstate_wrapper.h"

// Argument includes
#include <QtGui/qmatrix4x4.h>
#include <qbytearray.h>
#include <qrect.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSGMaterialShader_RenderState_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSGMaterialShader::RenderState >()))
        return -1;

    ::QSGMaterialShader::RenderState *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "RenderState", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: RenderState::RenderState()
    // 1: RenderState::RenderState(QSGMaterialShader::RenderState)
    if (numArgs == 0) {
        overloadId = 0; // RenderState()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), (pyArgs[0])))) {
        overloadId = 1; // RenderState(QSGMaterialShader::RenderState)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // RenderState()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // RenderState()
                cptr = new ::QSGMaterialShader::RenderState();
            }
            break;
        }
        case 1: // RenderState(const QSGMaterialShader::RenderState &RenderState)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QSGMaterialShader::RenderState cppArg0_local;
            ::QSGMaterialShader::RenderState *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // RenderState(QSGMaterialShader::RenderState)
                cptr = new ::QSGMaterialShader::RenderState(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSGMaterialShader::RenderState >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_combinedMatrix(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.combinedMatrix";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // combinedMatrix()const
            QMatrix4x4 cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->combinedMatrix();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QMatrix4x4_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_determinant(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.determinant";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // determinant()const
            float cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->determinant();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_devicePixelRatio(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.devicePixelRatio";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // devicePixelRatio()const
            float cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->devicePixelRatio();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_deviceRect(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.deviceRect";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // deviceRect()const
            QRect cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->deviceRect();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRect_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_dirtyStates(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.dirtyStates";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // dirtyStates()const
            QFlags<QSGMaterialShader::RenderState::DirtyState> cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->dirtyStates();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QFlags_QSGMaterialShader_RenderState_DirtyState_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_isMatrixDirty(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.isMatrixDirty";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isMatrixDirty()const
            bool cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->isMatrixDirty();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_isOpacityDirty(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.isOpacityDirty";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isOpacityDirty()const
            bool cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->isOpacityDirty();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_modelViewMatrix(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.modelViewMatrix";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // modelViewMatrix()const
            QMatrix4x4 cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->modelViewMatrix();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QMatrix4x4_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_opacity(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.opacity";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // opacity()const
            float cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->opacity();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_projectionMatrix(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.projectionMatrix";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // projectionMatrix()const
            QMatrix4x4 cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->projectionMatrix();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QMatrix4x4_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_resourceUpdateBatch(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.resourceUpdateBatch";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // resourceUpdateBatch()
            QRhiResourceUpdateBatch * cppResult = cppSelf->resourceUpdateBatch();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_rhi(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.rhi";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // rhi()
            QRhi * cppResult = cppSelf->rhi();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhi_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_uniformData(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.uniformData";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // uniformData()
            QByteArray * cppResult = cppSelf->uniformData();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_viewportRect(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialShader.RenderState.viewportRect";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // viewportRect()const
            QRect cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->viewportRect();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRect_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderState__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QSGMaterialShader_RenderState_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QSGMaterialShader_RenderState_EnumFlagInfo[] = {
    "DirtyState:Flag:DirtyStates",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSGMaterialShader_RenderState_methods[] = {
    {"combinedMatrix", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_combinedMatrix), METH_NOARGS, nullptr},
    {"determinant", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_determinant), METH_NOARGS, nullptr},
    {"devicePixelRatio", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_devicePixelRatio), METH_NOARGS, nullptr},
    {"deviceRect", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_deviceRect), METH_NOARGS, nullptr},
    {"dirtyStates", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_dirtyStates), METH_NOARGS, nullptr},
    {"isMatrixDirty", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_isMatrixDirty), METH_NOARGS, nullptr},
    {"isOpacityDirty", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_isOpacityDirty), METH_NOARGS, nullptr},
    {"modelViewMatrix", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_modelViewMatrix), METH_NOARGS, nullptr},
    {"opacity", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_opacity), METH_NOARGS, nullptr},
    {"projectionMatrix", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_projectionMatrix), METH_NOARGS, nullptr},
    {"resourceUpdateBatch", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_resourceUpdateBatch), METH_NOARGS, nullptr},
    {"rhi", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_rhi), METH_NOARGS, nullptr},
    {"uniformData", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_uniformData), METH_NOARGS, nullptr},
    {"viewportRect", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_viewportRect), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderState__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QSGMaterialShader_RenderState_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSGMaterialShader_RenderState_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSGMaterialShader_RenderState_Type = nullptr;
static PyTypeObject *Sbk_QSGMaterialShader_RenderState_TypeF(void)
{
    return _Sbk_QSGMaterialShader_RenderState_Type;
}

static PyType_Slot Sbk_QSGMaterialShader_RenderState_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSGMaterialShader_RenderState_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSGMaterialShader_RenderState_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSGMaterialShader_RenderState_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSGMaterialShader_RenderState_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSGMaterialShader_RenderState_spec = {
    "2:PySide6.QtQuick.QSGMaterialShader.RenderState",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSGMaterialShader_RenderState_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QSGMaterialShader_RenderState_DirtyState(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSGMaterialShader::RenderState::DirtyState>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSGMaterialShader::RenderState::DirtyState *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QSGMaterialShader_RenderState_DirtyState_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_DirtyState_IDX])))
        return Enum_PythonToCpp_QSGMaterialShader_RenderState_DirtyState;
    return {};
}
static PyObject *QSGMaterialShader_RenderState_DirtyState_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSGMaterialShader::RenderState::DirtyState *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_DirtyState_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void RenderState_PythonToCpp_RenderState_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSGMaterialShader_RenderState_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_RenderState_PythonToCpp_RenderState_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QSGMaterialShader_RenderState_TypeF()))
        return RenderState_PythonToCpp_RenderState_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *RenderState_PTR_CppToPython_RenderState(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QSGMaterialShader::RenderState *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QSGMaterialShader_RenderState_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *RenderState_COPY_CppToPython_RenderState(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QSGMaterialShader::RenderState *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QSGMaterialShader_RenderState_TypeF(), new ::QSGMaterialShader::RenderState(*source), true, true);
}

// Python to C++ copy conversion.
static void RenderState_PythonToCpp_RenderState_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QSGMaterialShader::RenderState *>(cppOut) = *reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_RenderState_PythonToCpp_RenderState_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QSGMaterialShader_RenderState_TypeF()))
        return RenderState_PythonToCpp_RenderState_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QSGMaterialShader_RenderState_SignatureStrings[] = {
    "1:PySide6.QtQuick.QSGMaterialShader.RenderState(self)",
    "0:PySide6.QtQuick.QSGMaterialShader.RenderState(self,RenderState:PySide6.QtQuick.QSGMaterialShader.RenderState)",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.combinedMatrix(self)->PySide6.QtGui.QMatrix4x4",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.determinant(self)->float",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.devicePixelRatio(self)->float",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.deviceRect(self)->PySide6.QtCore.QRect",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.dirtyStates(self)->PySide6.QtQuick.QSGMaterialShader.RenderState.DirtyState",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.isMatrixDirty(self)->bool",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.isOpacityDirty(self)->bool",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.modelViewMatrix(self)->PySide6.QtGui.QMatrix4x4",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.opacity(self)->float",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.projectionMatrix(self)->PySide6.QtGui.QMatrix4x4",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.resourceUpdateBatch(self)->PySide6.QtGui.QRhiResourceUpdateBatch",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.rhi(self)->PySide6.QtGui.QRhi",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.uniformData(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.viewportRect(self)->PySide6.QtCore.QRect",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QSGMaterialShader_RenderState(PyObject *enclosingClass)
{
    if (SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX].type != nullptr)
        return SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX].type;

    Shiboken::AutoDecRef Sbk_QSGMaterialShader_RenderState_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QSGMaterialShader_RenderState_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "RenderState",
        "QSGMaterialShader::RenderState",
        &Sbk_QSGMaterialShader_RenderState_spec,
        &Shiboken::callCppDestructor< ::QSGMaterialShader::RenderState >,
        Sbk_QSGMaterialShader_RenderState_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QSGMaterialShader_RenderState_TypeF(); // references _Sbk_QSGMaterialShader_RenderState_Type
    InitSignatureStrings(pyType, QSGMaterialShader_RenderState_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSGMaterialShader_RenderState_PropertyStrings);
    SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        RenderState_PythonToCpp_RenderState_PTR,
        is_RenderState_PythonToCpp_RenderState_PTR_Convertible,
        RenderState_PTR_CppToPython_RenderState,
        RenderState_COPY_CppToPython_RenderState);

    Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::RenderState");
    Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::RenderState*");
    Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::RenderState&");
    Shiboken::Conversions::registerConverterName(converter, "RenderState");
    Shiboken::Conversions::registerConverterName(converter, "RenderState*");
    Shiboken::Conversions::registerConverterName(converter, "RenderState&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSGMaterialShader::RenderState).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        RenderState_PythonToCpp_RenderState_COPY,
        is_RenderState_PythonToCpp_RenderState_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QSGMaterialShader_RenderState_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'DirtyState'.
    const char *DirtyState_Initializer[] = {
        "DirtyMatrix",
        "DirtyOpacity",
        "DirtyCachedMaterialData",
        "DirtyAll",
        nullptr};
    // "uint16_t" used instead of "unsigned int"
    constexpr uint16_t DirtyState_InitializerValues[] = {
        uint16_t(QSGMaterialShader::RenderState::DirtyState::DirtyMatrix),             //  0x0001  1
        uint16_t(QSGMaterialShader::RenderState::DirtyState::DirtyOpacity),            //  0x0002  2
        uint16_t(QSGMaterialShader::RenderState::DirtyState::DirtyCachedMaterialData), //  0x0004  4
        uint16_t(QSGMaterialShader::RenderState::DirtyState::DirtyAll)                 //  0xffff  65535
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSGMaterialShader_RenderState_TypeF(),
        "2:PySide6.QtQuick.QSGMaterialShader.RenderState.DirtyState",
        DirtyState_Initializer, DirtyState_InitializerValues);
    SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_DirtyState_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtQuickTypeStructs[SBK_QFlags_QSGMaterialShader_RenderState_DirtyState_IDX].type =
        EType;
    // Register converter for enum 'QSGMaterialShader::RenderState::DirtyState'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSGMaterialShader_RenderState_DirtyState_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QSGMaterialShader_RenderState_DirtyState,
            is_Enum_PythonToCpp_QSGMaterialShader_RenderState_DirtyState_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::RenderState::DirtyState");
        Shiboken::Conversions::registerConverterName(converter, "RenderState::DirtyState");
        Shiboken::Conversions::registerConverterName(converter, "DirtyState");
        // Register converter for flag 'QFlags<QSGMaterialShader::RenderState::DirtyState>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QSGMaterialShader::RenderState::DirtyState>");
        Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::RenderState::DirtyStates");
    }
    // End of 'DirtyState' enum/flags.

    qRegisterMetaType< ::QSGMaterialShader::RenderState >("RenderState");
    qRegisterMetaType< ::QSGMaterialShader::RenderState >("QSGMaterialShader::RenderState");
    qRegisterMetaType< ::QSGMaterialShader::RenderState::DirtyState >("RenderState::DirtyState");
    qRegisterMetaType< ::QSGMaterialShader::RenderState::DirtyState >("QSGMaterialShader::RenderState::DirtyState");

    return pyType;
}
