// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGMaterialShaderWrapper_H
#define SBK_QSGMaterialShaderWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgmaterialshader.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSGMaterialShaderWrapper : public QSGMaterialShader
{
public:
    QSGMaterialShaderWrapper(const QSGMaterialShaderWrapper &) = delete;
    QSGMaterialShaderWrapper& operator=(const QSGMaterialShaderWrapper &) = delete;
    QSGMaterialShaderWrapper(QSGMaterialShaderWrapper &&) = delete;
    QSGMaterialShaderWrapper& operator=(QSGMaterialShaderWrapper &&) = delete;

    QSGMaterialShaderWrapper();
    bool updateGraphicsPipelineState(::QSGMaterialShader::RenderState & state, ::QSGMaterialShader::GraphicsPipelineState * ps, ::QSGMaterial * newMaterial, ::QSGMaterial * oldMaterial) override;
    bool updateUniformData(::QSGMaterialShader::RenderState & state, ::QSGMaterial * newMaterial, ::QSGMaterial * oldMaterial) override;
    ~QSGMaterialShaderWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QSGMaterialShaderWrapper_H

