// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGNodeVisitorWrapper_H
#define SBK_QSGNodeVisitorWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgnode.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSGNodeVisitorWrapper : public QSGNodeVisitor
{
public:
    QSGNodeVisitorWrapper(const QSGNodeVisitorWrapper &) = delete;
    QSGNodeVisitorWrapper& operator=(const QSGNodeVisitorWrapper &) = delete;
    QSGNodeVisitorWrapper(QSGNodeVisitorWrapper &&) = delete;
    QSGNodeVisitorWrapper& operator=(QSGNodeVisitorWrapper &&) = delete;

    QSGNodeVisitorWrapper();
    void enterClipNode(::QSGClipNode * arg__1) override;
    void enterGeometryNode(::QSGGeometryNode * arg__1) override;
    void enterOpacityNode(::QSGOpacityNode * arg__1) override;
    void enterTransformNode(::QSGTransformNode * arg__1) override;
    void leaveClipNode(::QSGClipNode * arg__1) override;
    void leaveGeometryNode(::QSGGeometryNode * arg__1) override;
    void leaveOpacityNode(::QSGOpacityNode * arg__1) override;
    void leaveTransformNode(::QSGTransformNode * arg__1) override;
    void visitChildren(::QSGNode * n) override;
    void visitNode(::QSGNode * n) override;
    ~QSGNodeVisitorWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10];
};

#endif // SBK_QSGNodeVisitorWrapper_H

