// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtscxml_python.h"

// main header
#include "qscxmlexecutablecontent_assignmentinfo_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>

using namespace QScxmlExecutableContent;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QScxmlExecutableContent_AssignmentInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QScxmlExecutableContent::AssignmentInfo >()))
        return -1;

    ::QScxmlExecutableContent::AssignmentInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtScxml.QScxmlExecutableContent.AssignmentInfo.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "AssignmentInfo", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: AssignmentInfo::AssignmentInfo()
    // 1: AssignmentInfo::AssignmentInfo(QScxmlExecutableContent::AssignmentInfo)
    if (numArgs == 0) {
        overloadId = 0; // AssignmentInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX]), (pyArgs[0])))) {
        overloadId = 1; // AssignmentInfo(QScxmlExecutableContent::AssignmentInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // AssignmentInfo()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // AssignmentInfo()
                cptr = new ::QScxmlExecutableContent::AssignmentInfo();
            }
            break;
        }
        case 1: // AssignmentInfo(const QScxmlExecutableContent::AssignmentInfo &AssignmentInfo)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QScxmlExecutableContent::AssignmentInfo cppArg0_local;
            ::QScxmlExecutableContent::AssignmentInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // AssignmentInfo(QScxmlExecutableContent::AssignmentInfo)
                cptr = new ::QScxmlExecutableContent::AssignmentInfo(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QScxmlExecutableContent::AssignmentInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QScxmlExecutableContent_AssignmentInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QScxmlExecutableContent::AssignmentInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QScxmlExecutableContent_AssignmentInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QScxmlExecutableContent_AssignmentInfo_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QScxmlExecutableContent_AssignmentInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QScxmlExecutableContent_AssignmentInfo_get_dest(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::AssignmentInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->dest;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_AssignmentInfo_set_dest(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::AssignmentInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("dest");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("dest", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->dest;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->dest = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_AssignmentInfo_get_expr(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::AssignmentInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->expr;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_AssignmentInfo_set_expr(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::AssignmentInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("expr");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("expr", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->expr;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->expr = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_AssignmentInfo_get_context(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::AssignmentInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->context;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_AssignmentInfo_set_context(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::AssignmentInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("context");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("context", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->context;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->context = cppOut_local;

    return 0;
}

// Getters and Setters for AssignmentInfo
static PyGetSetDef Sbk_QScxmlExecutableContent_AssignmentInfo_getsetlist[] = {
    {const_cast<char *>("dest"), Sbk_QScxmlExecutableContent_AssignmentInfo_get_dest, Sbk_QScxmlExecutableContent_AssignmentInfo_set_dest, nullptr, nullptr},
    {const_cast<char *>("expr"), Sbk_QScxmlExecutableContent_AssignmentInfo_get_expr, Sbk_QScxmlExecutableContent_AssignmentInfo_set_expr, nullptr, nullptr},
    {const_cast<char *>("context"), Sbk_QScxmlExecutableContent_AssignmentInfo_get_context, Sbk_QScxmlExecutableContent_AssignmentInfo_set_context, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QScxmlExecutableContent_AssignmentInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QScxmlExecutableContent_AssignmentInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QScxmlExecutableContent_AssignmentInfo_Type = nullptr;
static PyTypeObject *Sbk_QScxmlExecutableContent_AssignmentInfo_TypeF(void)
{
    return _Sbk_QScxmlExecutableContent_AssignmentInfo_Type;
}

static PyType_Slot Sbk_QScxmlExecutableContent_AssignmentInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_AssignmentInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_AssignmentInfo_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_AssignmentInfo_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_AssignmentInfo_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_AssignmentInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QScxmlExecutableContent_AssignmentInfo_spec = {
    "2:PySide6.QtScxml.QScxmlExecutableContent.AssignmentInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QScxmlExecutableContent_AssignmentInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void AssignmentInfo_PythonToCpp_AssignmentInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QScxmlExecutableContent_AssignmentInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_AssignmentInfo_PythonToCpp_AssignmentInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QScxmlExecutableContent_AssignmentInfo_TypeF()))
        return AssignmentInfo_PythonToCpp_AssignmentInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *AssignmentInfo_PTR_CppToPython_AssignmentInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QScxmlExecutableContent::AssignmentInfo *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QScxmlExecutableContent_AssignmentInfo_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *AssignmentInfo_COPY_CppToPython_AssignmentInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QScxmlExecutableContent::AssignmentInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QScxmlExecutableContent_AssignmentInfo_TypeF(), new ::QScxmlExecutableContent::AssignmentInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void AssignmentInfo_PythonToCpp_AssignmentInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QScxmlExecutableContent::AssignmentInfo *>(cppOut) = *reinterpret_cast< ::QScxmlExecutableContent::AssignmentInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_AssignmentInfo_PythonToCpp_AssignmentInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QScxmlExecutableContent_AssignmentInfo_TypeF()))
        return AssignmentInfo_PythonToCpp_AssignmentInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QScxmlExecutableContent_AssignmentInfo_SignatureStrings[] = {
    "1:PySide6.QtScxml.QScxmlExecutableContent.AssignmentInfo(self)",
    "0:PySide6.QtScxml.QScxmlExecutableContent.AssignmentInfo(self,AssignmentInfo:PySide6.QtScxml.QScxmlExecutableContent.AssignmentInfo)",
    "PySide6.QtScxml.QScxmlExecutableContent.AssignmentInfo.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QScxmlExecutableContent_AssignmentInfo(PyObject *enclosingClass)
{
    if (SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX].type != nullptr)
        return SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX].type;

    Shiboken::AutoDecRef Sbk_QScxmlExecutableContent_AssignmentInfo_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QScxmlExecutableContent_AssignmentInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "AssignmentInfo",
        "QScxmlExecutableContent::AssignmentInfo",
        &Sbk_QScxmlExecutableContent_AssignmentInfo_spec,
        &Shiboken::callCppDestructor< ::QScxmlExecutableContent::AssignmentInfo >,
        Sbk_QScxmlExecutableContent_AssignmentInfo_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QScxmlExecutableContent_AssignmentInfo_TypeF(); // references _Sbk_QScxmlExecutableContent_AssignmentInfo_Type
    InitSignatureStrings(pyType, QScxmlExecutableContent_AssignmentInfo_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QScxmlExecutableContent_AssignmentInfo_PropertyStrings);
    SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_AssignmentInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        AssignmentInfo_PythonToCpp_AssignmentInfo_PTR,
        is_AssignmentInfo_PythonToCpp_AssignmentInfo_PTR_Convertible,
        AssignmentInfo_PTR_CppToPython_AssignmentInfo,
        AssignmentInfo_COPY_CppToPython_AssignmentInfo);

    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::AssignmentInfo");
    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::AssignmentInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::AssignmentInfo&");
    Shiboken::Conversions::registerConverterName(converter, "AssignmentInfo");
    Shiboken::Conversions::registerConverterName(converter, "AssignmentInfo*");
    Shiboken::Conversions::registerConverterName(converter, "AssignmentInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QScxmlExecutableContent::AssignmentInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        AssignmentInfo_PythonToCpp_AssignmentInfo_COPY,
        is_AssignmentInfo_PythonToCpp_AssignmentInfo_COPY_Convertible);

    qRegisterMetaType< ::QScxmlExecutableContent::AssignmentInfo >("AssignmentInfo");
    qRegisterMetaType< ::QScxmlExecutableContent::AssignmentInfo >("QScxmlExecutableContent::AssignmentInfo");

    return pyType;
}
