// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QIRProximityFilterWrapper_H
#define SBK_QIRProximityFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qirproximitysensor.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QIRProximityFilterWrapper : public QIRProximityFilter
{
public:
    QIRProximityFilterWrapper(const QIRProximityFilterWrapper &) = delete;
    QIRProximityFilterWrapper& operator=(const QIRProximityFilterWrapper &) = delete;
    QIRProximityFilterWrapper(QIRProximityFilterWrapper &&) = delete;
    QIRProximityFilterWrapper& operator=(QIRProximityFilterWrapper &&) = delete;

    bool filter(::QIRProximityReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QIRProximityFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QIRProximityFilterWrapper_H

