// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtsensors_python.h"

// main header
#include "qoutputrange_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_qoutputrange_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::qoutputrange >()))
        return -1;

    ::qoutputrange *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSensors.qoutputrange.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "qoutputrange", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: qoutputrange::qoutputrange()
    // 1: qoutputrange::qoutputrange(qoutputrange)
    if (numArgs == 0) {
        overloadId = 0; // qoutputrange()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX]), (pyArgs[0])))) {
        overloadId = 1; // qoutputrange(qoutputrange)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // qoutputrange()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // qoutputrange()
                cptr = new ::qoutputrange();
            }
            break;
        }
        case 1: // qoutputrange(const qoutputrange &qoutputrange)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::qoutputrange cppArg0_local;
            ::qoutputrange *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // qoutputrange(qoutputrange)
                cptr = new ::qoutputrange(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::qoutputrange >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_qoutputrange__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::qoutputrange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_qoutputrange_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_qoutputrange_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_qoutputrange__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_qoutputrange_get_minimum(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::qoutputrange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->minimum);
    return pyOut;
}
static int Sbk_qoutputrange_set_minimum(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::qoutputrange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("minimum");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("minimum", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->minimum;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_qoutputrange_get_maximum(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::qoutputrange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->maximum);
    return pyOut;
}
static int Sbk_qoutputrange_set_maximum(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::qoutputrange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("maximum");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("maximum", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->maximum;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_qoutputrange_get_accuracy(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::qoutputrange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->accuracy);
    return pyOut;
}
static int Sbk_qoutputrange_set_accuracy(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::qoutputrange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("accuracy");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("accuracy", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->accuracy;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for qoutputrange
static PyGetSetDef Sbk_qoutputrange_getsetlist[] = {
    {const_cast<char *>("minimum"), Sbk_qoutputrange_get_minimum, Sbk_qoutputrange_set_minimum, nullptr, nullptr},
    {const_cast<char *>("maximum"), Sbk_qoutputrange_get_maximum, Sbk_qoutputrange_set_maximum, nullptr, nullptr},
    {const_cast<char *>("accuracy"), Sbk_qoutputrange_get_accuracy, Sbk_qoutputrange_set_accuracy, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_qoutputrange_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_qoutputrange_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_qoutputrange_Type = nullptr;
static PyTypeObject *Sbk_qoutputrange_TypeF(void)
{
    return _Sbk_qoutputrange_Type;
}

static PyType_Slot Sbk_qoutputrange_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_qoutputrange_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_qoutputrange_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_qoutputrange_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_qoutputrange_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_qoutputrange_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_qoutputrange_spec = {
    "2:PySide6.QtSensors.qoutputrange",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_qoutputrange_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void qoutputrange_PythonToCpp_qoutputrange_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_qoutputrange_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_qoutputrange_PythonToCpp_qoutputrange_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_qoutputrange_TypeF()))
        return qoutputrange_PythonToCpp_qoutputrange_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *qoutputrange_PTR_CppToPython_qoutputrange(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::qoutputrange *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_qoutputrange_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *qoutputrange_COPY_CppToPython_qoutputrange(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::qoutputrange *>(cppIn);
    return Shiboken::Object::newObject(Sbk_qoutputrange_TypeF(), new ::qoutputrange(*source), true, true);
}

// Python to C++ copy conversion.
static void qoutputrange_PythonToCpp_qoutputrange_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::qoutputrange *>(cppOut) = *reinterpret_cast< ::qoutputrange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_qoutputrange_PythonToCpp_qoutputrange_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_qoutputrange_TypeF()))
        return qoutputrange_PythonToCpp_qoutputrange_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *qoutputrange_SignatureStrings[] = {
    "1:PySide6.QtSensors.qoutputrange(self)",
    "0:PySide6.QtSensors.qoutputrange(self,qoutputrange:PySide6.QtSensors.qoutputrange)",
    "PySide6.QtSensors.qoutputrange.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_qoutputrange(PyObject *module)
{
    if (SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX].type != nullptr)
        return SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX].type;

    Shiboken::AutoDecRef Sbk_qoutputrange_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_qoutputrange_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "qoutputrange",
        "qoutputrange",
        &Sbk_qoutputrange_spec,
        &Shiboken::callCppDestructor< ::qoutputrange >,
        Sbk_qoutputrange_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_qoutputrange_TypeF(); // references _Sbk_qoutputrange_Type
    InitSignatureStrings(pyType, qoutputrange_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_qoutputrange_PropertyStrings);
    SbkPySide6_QtSensorsTypeStructs[SBK_qoutputrange_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        qoutputrange_PythonToCpp_qoutputrange_PTR,
        is_qoutputrange_PythonToCpp_qoutputrange_PTR_Convertible,
        qoutputrange_PTR_CppToPython_qoutputrange,
        qoutputrange_COPY_CppToPython_qoutputrange);

    Shiboken::Conversions::registerConverterName(converter, "qoutputrange");
    Shiboken::Conversions::registerConverterName(converter, "qoutputrange*");
    Shiboken::Conversions::registerConverterName(converter, "qoutputrange&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::qoutputrange).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        qoutputrange_PythonToCpp_qoutputrange_COPY,
        is_qoutputrange_PythonToCpp_qoutputrange_COPY_Convertible);

    qRegisterMetaType< ::qoutputrange >("qoutputrange");

    return pyType;
}
