// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QProximityFilterWrapper_H
#define SBK_QProximityFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qproximitysensor.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QProximityFilterWrapper : public QProximityFilter
{
public:
    QProximityFilterWrapper(const QProximityFilterWrapper &) = delete;
    QProximityFilterWrapper& operator=(const QProximityFilterWrapper &) = delete;
    QProximityFilterWrapper(QProximityFilterWrapper &&) = delete;
    QProximityFilterWrapper& operator=(QProximityFilterWrapper &&) = delete;

    bool filter(::QProximityReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QProximityFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QProximityFilterWrapper_H

