// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTapFilterWrapper_H
#define SBK_QTapFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qtapsensor.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QTapFilterWrapper : public QTapFilter
{
public:
    QTapFilterWrapper(const QTapFilterWrapper &) = delete;
    QTapFilterWrapper& operator=(const QTapFilterWrapper &) = delete;
    QTapFilterWrapper(QTapFilterWrapper &&) = delete;
    QTapFilterWrapper& operator=(QTapFilterWrapper &&) = delete;

    bool filter(::QTapReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QTapFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QTapFilterWrapper_H

