// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtserialbus_python.h"

// main header
#include "qcanbusframe_timestamp_wrapper.h"

// Argument includes
#include <QtSerialBus/qcanbusframe.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCanBusFrame_TimeStamp_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCanBusFrame::TimeStamp >()))
        return -1;

    ::QCanBusFrame::TimeStamp *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.TimeStamp.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:TimeStamp", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: TimeStamp::TimeStamp(QCanBusFrame::TimeStamp)
    // 1: TimeStamp::TimeStamp(qint64=,qint64=)
    if (numArgs == 0) {
        overloadId = 1; // TimeStamp(qint64,qint64)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // TimeStamp(qint64,qint64)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), (pyArgs[1])))) {
            overloadId = 1; // TimeStamp(qint64,qint64)
        }
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_TimeStamp_IDX]), (pyArgs[0])))) {
        overloadId = 0; // TimeStamp(QCanBusFrame::TimeStamp)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // TimeStamp(const QCanBusFrame::TimeStamp &TimeStamp)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QCanBusFrame::TimeStamp cppArg0_local;
            ::QCanBusFrame::TimeStamp *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // TimeStamp(QCanBusFrame::TimeStamp)
                cptr = new ::QCanBusFrame::TimeStamp(*cppArg0);
            }
            break;
        }
        case 1: // TimeStamp(qint64 s, qint64 usec)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_s = Shiboken::String::createStaticString("s");
                if (PyDict_Contains(kwds, key_s) != 0) {
                    value = PyDict_GetItem(kwds, key_s);
                    if (value != nullptr && pyArgs[0] != nullptr ) {
                        errInfo.reset(key_s);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[0] = value;
                        if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), (pyArgs[0]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_s);
                }
                static PyObject *const key_usec = Shiboken::String::createStaticString("usec");
                if (PyDict_Contains(kwds, key_usec) != 0) {
                    value = PyDict_GetItem(kwds, key_usec);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_usec);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), (pyArgs[1]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_usec);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            qint64 cppArg0 = 0;
            if (pythonToCpp[0])
                pythonToCpp[0](pyArgs[0], &cppArg0);
            qint64 cppArg1 = 0;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // TimeStamp(qint64,qint64)
                cptr = new ::QCanBusFrame::TimeStamp(cppArg0, cppArg1);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCanBusFrame::TimeStamp >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCanBusFrame_TimeStampFunc_fromMicroSeconds(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.TimeStamp.fromMicroSeconds";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static TimeStamp::fromMicroSeconds(qint64)->QCanBusFrame::TimeStamp
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), (pyArg)))) {
        overloadId = 0; // fromMicroSeconds(qint64)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        qint64 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // fromMicroSeconds(qint64)
            QCanBusFrame::TimeStamp cppResult = ::QCanBusFrame::TimeStamp::fromMicroSeconds(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_TimeStamp_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrame_TimeStampFunc_microSeconds(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame::TimeStamp *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_TimeStamp_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.TimeStamp.microSeconds";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // microSeconds()const
            qint64 cppResult = const_cast<const ::QCanBusFrame::TimeStamp *>(cppSelf)->microSeconds();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrame_TimeStampFunc_seconds(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame::TimeStamp *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_TimeStamp_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.TimeStamp.seconds";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // seconds()const
            qint64 cppResult = const_cast<const ::QCanBusFrame::TimeStamp *>(cppSelf)->seconds();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrame_TimeStamp__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCanBusFrame::TimeStamp *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_TimeStamp_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_TimeStamp_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCanBusFrame_TimeStamp_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCanBusFrame_TimeStamp_methods[] = {
    {"fromMicroSeconds", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrame_TimeStampFunc_fromMicroSeconds), METH_O|METH_STATIC, nullptr},
    {"microSeconds", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrame_TimeStampFunc_microSeconds), METH_NOARGS, nullptr},
    {"seconds", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrame_TimeStampFunc_seconds), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrame_TimeStamp__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QCanBusFrame_TimeStamp_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCanBusFrame_TimeStamp_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCanBusFrame_TimeStamp_Type = nullptr;
static PyTypeObject *Sbk_QCanBusFrame_TimeStamp_TypeF(void)
{
    return _Sbk_QCanBusFrame_TimeStamp_Type;
}

static PyType_Slot Sbk_QCanBusFrame_TimeStamp_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCanBusFrame_TimeStamp_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCanBusFrame_TimeStamp_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCanBusFrame_TimeStamp_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCanBusFrame_TimeStamp_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCanBusFrame_TimeStamp_spec = {
    "2:PySide6.QtSerialBus.QCanBusFrame.TimeStamp",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCanBusFrame_TimeStamp_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void TimeStamp_PythonToCpp_TimeStamp_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCanBusFrame_TimeStamp_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_TimeStamp_PythonToCpp_TimeStamp_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCanBusFrame_TimeStamp_TypeF()))
        return TimeStamp_PythonToCpp_TimeStamp_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *TimeStamp_PTR_CppToPython_TimeStamp(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QCanBusFrame::TimeStamp *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QCanBusFrame_TimeStamp_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *TimeStamp_COPY_CppToPython_TimeStamp(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QCanBusFrame::TimeStamp *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QCanBusFrame_TimeStamp_TypeF(), new ::QCanBusFrame::TimeStamp(*source), true, true);
}

// Python to C++ copy conversion.
static void TimeStamp_PythonToCpp_TimeStamp_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QCanBusFrame::TimeStamp *>(cppOut) = *reinterpret_cast< ::QCanBusFrame::TimeStamp *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_TimeStamp_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_TimeStamp_PythonToCpp_TimeStamp_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QCanBusFrame_TimeStamp_TypeF()))
        return TimeStamp_PythonToCpp_TimeStamp_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QCanBusFrame_TimeStamp_SignatureStrings[] = {
    "1:PySide6.QtSerialBus.QCanBusFrame.TimeStamp(self,TimeStamp:PySide6.QtSerialBus.QCanBusFrame.TimeStamp)",
    "0:PySide6.QtSerialBus.QCanBusFrame.TimeStamp(self,s:qint64=0,usec:qint64=0)",
    "PySide6.QtSerialBus.QCanBusFrame.TimeStamp.fromMicroSeconds(usec:qint64)->PySide6.QtSerialBus.QCanBusFrame.TimeStamp",
    "PySide6.QtSerialBus.QCanBusFrame.TimeStamp.microSeconds(self)->qint64",
    "PySide6.QtSerialBus.QCanBusFrame.TimeStamp.seconds(self)->qint64",
    "PySide6.QtSerialBus.QCanBusFrame.TimeStamp.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QCanBusFrame_TimeStamp(PyObject *enclosingClass)
{
    if (SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_TimeStamp_IDX].type != nullptr)
        return SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_TimeStamp_IDX].type;

    Shiboken::AutoDecRef Sbk_QCanBusFrame_TimeStamp_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QCanBusFrame_TimeStamp_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "TimeStamp",
        "QCanBusFrame::TimeStamp",
        &Sbk_QCanBusFrame_TimeStamp_spec,
        &Shiboken::callCppDestructor< ::QCanBusFrame::TimeStamp >,
        Sbk_QCanBusFrame_TimeStamp_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QCanBusFrame_TimeStamp_TypeF(); // references _Sbk_QCanBusFrame_TimeStamp_Type
    InitSignatureStrings(pyType, QCanBusFrame_TimeStamp_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCanBusFrame_TimeStamp_PropertyStrings);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_TimeStamp_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        TimeStamp_PythonToCpp_TimeStamp_PTR,
        is_TimeStamp_PythonToCpp_TimeStamp_PTR_Convertible,
        TimeStamp_PTR_CppToPython_TimeStamp,
        TimeStamp_COPY_CppToPython_TimeStamp);

    Shiboken::Conversions::registerConverterName(converter, "QCanBusFrame::TimeStamp");
    Shiboken::Conversions::registerConverterName(converter, "QCanBusFrame::TimeStamp*");
    Shiboken::Conversions::registerConverterName(converter, "QCanBusFrame::TimeStamp&");
    Shiboken::Conversions::registerConverterName(converter, "TimeStamp");
    Shiboken::Conversions::registerConverterName(converter, "TimeStamp*");
    Shiboken::Conversions::registerConverterName(converter, "TimeStamp&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCanBusFrame::TimeStamp).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        TimeStamp_PythonToCpp_TimeStamp_COPY,
        is_TimeStamp_PythonToCpp_TimeStamp_COPY_Convertible);

    qRegisterMetaType< ::QCanBusFrame::TimeStamp >("TimeStamp");
    qRegisterMetaType< ::QCanBusFrame::TimeStamp >("QCanBusFrame::TimeStamp");

    return pyType;
}
