// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtserialbus_python.h"

// main header
#include "qcansignaldescription_multiplexvaluerange_wrapper.h"

// Argument includes
#include <QtSerialBus/qcansignaldescription.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCanSignalDescription_MultiplexValueRange_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCanSignalDescription::MultiplexValueRange >()))
        return -1;

    ::QCanSignalDescription::MultiplexValueRange *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanSignalDescription.MultiplexValueRange.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "MultiplexValueRange", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: MultiplexValueRange::MultiplexValueRange()
    // 1: MultiplexValueRange::MultiplexValueRange(QCanSignalDescription::MultiplexValueRange)
    if (numArgs == 0) {
        overloadId = 0; // MultiplexValueRange()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX]), (pyArgs[0])))) {
        overloadId = 1; // MultiplexValueRange(QCanSignalDescription::MultiplexValueRange)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // MultiplexValueRange()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // MultiplexValueRange()
                cptr = new ::QCanSignalDescription::MultiplexValueRange();
            }
            break;
        }
        case 1: // MultiplexValueRange(const QCanSignalDescription::MultiplexValueRange &MultiplexValueRange)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QCanSignalDescription::MultiplexValueRange cppArg0_local;
            ::QCanSignalDescription::MultiplexValueRange *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // MultiplexValueRange(QCanSignalDescription::MultiplexValueRange)
                cptr = new ::QCanSignalDescription::MultiplexValueRange(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCanSignalDescription::MultiplexValueRange >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCanSignalDescription_MultiplexValueRange__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCanSignalDescription::MultiplexValueRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCanSignalDescription_MultiplexValueRange_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCanSignalDescription_MultiplexValueRange_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QCanSignalDescription_MultiplexValueRange__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QCanSignalDescription_MultiplexValueRange_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCanSignalDescription::MultiplexValueRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX]), (pyArg)))) {
                // operator!=(const QCanSignalDescription::MultiplexValueRange &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QCanSignalDescription::MultiplexValueRange cppArg0_local;
                ::QCanSignalDescription::MultiplexValueRange *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX]), (pyArg)))) {
                // operator==(const QCanSignalDescription::MultiplexValueRange &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QCanSignalDescription::MultiplexValueRange cppArg0_local;
                ::QCanSignalDescription::MultiplexValueRange *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

static PyObject *Sbk_QCanSignalDescription_MultiplexValueRange_get_minimum(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanSignalDescription::MultiplexValueRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppSelf->minimum);
    return pyOut;
}
static int Sbk_QCanSignalDescription_MultiplexValueRange_set_minimum(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QCanSignalDescription::MultiplexValueRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("minimum");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("minimum", "QVariant");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->minimum;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QCanSignalDescription_MultiplexValueRange_get_maximum(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanSignalDescription::MultiplexValueRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppSelf->maximum);
    return pyOut;
}
static int Sbk_QCanSignalDescription_MultiplexValueRange_set_maximum(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QCanSignalDescription::MultiplexValueRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("maximum");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("maximum", "QVariant");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->maximum;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for MultiplexValueRange
static PyGetSetDef Sbk_QCanSignalDescription_MultiplexValueRange_getsetlist[] = {
    {const_cast<char *>("minimum"), Sbk_QCanSignalDescription_MultiplexValueRange_get_minimum, Sbk_QCanSignalDescription_MultiplexValueRange_set_minimum, nullptr, nullptr},
    {const_cast<char *>("maximum"), Sbk_QCanSignalDescription_MultiplexValueRange_get_maximum, Sbk_QCanSignalDescription_MultiplexValueRange_set_maximum, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QCanSignalDescription_MultiplexValueRange_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCanSignalDescription_MultiplexValueRange_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QCanSignalDescription_MultiplexValueRange__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanSignalDescription::MultiplexValueRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCanSignalDescription_MultiplexValueRange_Type = nullptr;
static PyTypeObject *Sbk_QCanSignalDescription_MultiplexValueRange_TypeF(void)
{
    return _Sbk_QCanSignalDescription_MultiplexValueRange_Type;
}

static PyType_Slot Sbk_QCanSignalDescription_MultiplexValueRange_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QCanSignalDescription_MultiplexValueRange__repr__)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCanSignalDescription_MultiplexValueRange_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCanSignalDescription_MultiplexValueRange_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QCanSignalDescription_MultiplexValueRange_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCanSignalDescription_MultiplexValueRange_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QCanSignalDescription_MultiplexValueRange_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCanSignalDescription_MultiplexValueRange_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCanSignalDescription_MultiplexValueRange_spec = {
    "2:PySide6.QtSerialBus.QCanSignalDescription.MultiplexValueRange",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCanSignalDescription_MultiplexValueRange_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void MultiplexValueRange_PythonToCpp_MultiplexValueRange_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCanSignalDescription_MultiplexValueRange_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_MultiplexValueRange_PythonToCpp_MultiplexValueRange_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCanSignalDescription_MultiplexValueRange_TypeF()))
        return MultiplexValueRange_PythonToCpp_MultiplexValueRange_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *MultiplexValueRange_PTR_CppToPython_MultiplexValueRange(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QCanSignalDescription::MultiplexValueRange *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QCanSignalDescription_MultiplexValueRange_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *MultiplexValueRange_COPY_CppToPython_MultiplexValueRange(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QCanSignalDescription::MultiplexValueRange *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QCanSignalDescription_MultiplexValueRange_TypeF(), new ::QCanSignalDescription::MultiplexValueRange(*source), true, true);
}

// Python to C++ copy conversion.
static void MultiplexValueRange_PythonToCpp_MultiplexValueRange_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QCanSignalDescription::MultiplexValueRange *>(cppOut) = *reinterpret_cast< ::QCanSignalDescription::MultiplexValueRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_MultiplexValueRange_PythonToCpp_MultiplexValueRange_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QCanSignalDescription_MultiplexValueRange_TypeF()))
        return MultiplexValueRange_PythonToCpp_MultiplexValueRange_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QCanSignalDescription_MultiplexValueRange_SignatureStrings[] = {
    "1:PySide6.QtSerialBus.QCanSignalDescription.MultiplexValueRange(self)",
    "0:PySide6.QtSerialBus.QCanSignalDescription.MultiplexValueRange(self,MultiplexValueRange:PySide6.QtSerialBus.QCanSignalDescription.MultiplexValueRange)",
    "PySide6.QtSerialBus.QCanSignalDescription.MultiplexValueRange.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QCanSignalDescription_MultiplexValueRange(PyObject *enclosingClass)
{
    if (SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX].type != nullptr)
        return SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX].type;

    Shiboken::AutoDecRef Sbk_QCanSignalDescription_MultiplexValueRange_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QCanSignalDescription_MultiplexValueRange_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "MultiplexValueRange",
        "QCanSignalDescription::MultiplexValueRange",
        &Sbk_QCanSignalDescription_MultiplexValueRange_spec,
        &Shiboken::callCppDestructor< ::QCanSignalDescription::MultiplexValueRange >,
        Sbk_QCanSignalDescription_MultiplexValueRange_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QCanSignalDescription_MultiplexValueRange_TypeF(); // references _Sbk_QCanSignalDescription_MultiplexValueRange_Type
    InitSignatureStrings(pyType, QCanSignalDescription_MultiplexValueRange_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCanSignalDescription_MultiplexValueRange_PropertyStrings);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QCanSignalDescription_MultiplexValueRange_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        MultiplexValueRange_PythonToCpp_MultiplexValueRange_PTR,
        is_MultiplexValueRange_PythonToCpp_MultiplexValueRange_PTR_Convertible,
        MultiplexValueRange_PTR_CppToPython_MultiplexValueRange,
        MultiplexValueRange_COPY_CppToPython_MultiplexValueRange);

    Shiboken::Conversions::registerConverterName(converter, "QCanSignalDescription::MultiplexValueRange");
    Shiboken::Conversions::registerConverterName(converter, "QCanSignalDescription::MultiplexValueRange*");
    Shiboken::Conversions::registerConverterName(converter, "QCanSignalDescription::MultiplexValueRange&");
    Shiboken::Conversions::registerConverterName(converter, "MultiplexValueRange");
    Shiboken::Conversions::registerConverterName(converter, "MultiplexValueRange*");
    Shiboken::Conversions::registerConverterName(converter, "MultiplexValueRange&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCanSignalDescription::MultiplexValueRange).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        MultiplexValueRange_PythonToCpp_MultiplexValueRange_COPY,
        is_MultiplexValueRange_PythonToCpp_MultiplexValueRange_COPY_Convertible);

    qRegisterMetaType< ::QCanSignalDescription::MultiplexValueRange >("MultiplexValueRange");
    qRegisterMetaType< ::QCanSignalDescription::MultiplexValueRange >("QCanSignalDescription::MultiplexValueRange");

    return pyType;
}
