// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSqlResultWrapper_H
#define SBK_QSqlResultWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSql/qsqlresult.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSqlResultWrapper : public QSqlResult
{
public:
    QSqlResultWrapper(const QSqlResultWrapper &) = delete;
    QSqlResultWrapper& operator=(const QSqlResultWrapper &) = delete;
    QSqlResultWrapper(QSqlResultWrapper &&) = delete;
    QSqlResultWrapper& operator=(QSqlResultWrapper &&) = delete;

    QSqlResultWrapper(const ::QSqlDriver * db);
    void bindValue(const ::QString & placeholder, const ::QVariant & val, ::QFlags<QSql::ParamTypeFlag> type) override;
    void bindValue(int pos, const ::QVariant & val, ::QFlags<QSql::ParamTypeFlag> type) override;
    ::QVariant data(int i) override;
    void detachFromResultSet() override;
    bool exec() override;
    bool execBatch(bool arrayBind = false) override;
    bool fetch(int i) override;
    bool fetchFirst() override;
    bool fetchLast() override;
    bool fetchNext() override;
    bool fetchPrevious() override;
    ::QVariant handle() const override;
    bool isNull(int i) override;
    ::QVariant lastInsertId() const override;
    bool nextResult() override;
    int numRowsAffected() override;
    bool prepare(const ::QString & query) override;
    ::QSqlRecord record() const override;
    bool reset(const ::QString & sqlquery) override;
    bool savePrepare(const ::QString & sqlquery) override;
    void setActive(bool a) override;
    void setAt(int at) override;
    void setForwardOnly(bool forward) override;
    void setLastError(const ::QSqlError & e) override;
    void setNumericalPrecisionPolicy(::QSql::NumericalPrecisionPolicy policy) override;
    void setQuery(const ::QString & query) override;
    void setSelect(bool s) override;
    int size() override;
    ~QSqlResultWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[28];
};

#endif // SBK_QSqlResultWrapper_H

