// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QFinalStateWrapper_H
#define SBK_QFinalStateWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtStateMachine/qfinalstate.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QFinalStateWrapper : public QFinalState
{
public:
    QFinalStateWrapper(const QFinalStateWrapper &) = delete;
    QFinalStateWrapper& operator=(const QFinalStateWrapper &) = delete;
    QFinalStateWrapper(QFinalStateWrapper &&) = delete;
    QFinalStateWrapper& operator=(QFinalStateWrapper &&) = delete;

    QFinalStateWrapper(::QState * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * e) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void onEntry(::QEvent * event) override;
    void onExit(::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QFinalStateWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QFinalStateWrapper_H

