// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_SignalEventWrapper_H
#define SBK_SignalEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtStateMachine/qstatemachine.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class SignalEventWrapper : public QStateMachine::SignalEvent
{
public:
    SignalEventWrapper(const SignalEventWrapper &) = delete;
    SignalEventWrapper& operator=(const SignalEventWrapper &) = delete;
    SignalEventWrapper(SignalEventWrapper &&) = delete;
    SignalEventWrapper& operator=(SignalEventWrapper &&) = delete;

    SignalEventWrapper(::QObject * sender, int signalIndex, const ::QList<QVariant> & arguments);
    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~SignalEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_SignalEventWrapper_H

