// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebsockets_python.h"

// main header
#include "qwebsockethandshakeoptions_wrapper.h"

// Argument includes
#include <QStringList>
#include <QtWebSockets/qwebsockethandshakeoptions.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebSocketHandshakeOptions_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWebSocketHandshakeOptions >()))
        return -1;

    ::QWebSocketHandshakeOptions *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebSockets.QWebSocketHandshakeOptions.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QWebSocketHandshakeOptions", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QWebSocketHandshakeOptions::QWebSocketHandshakeOptions()
    // 1: QWebSocketHandshakeOptions::QWebSocketHandshakeOptions(QWebSocketHandshakeOptions)
    if (numArgs == 0) {
        overloadId = 0; // QWebSocketHandshakeOptions()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QWebSocketHandshakeOptions(QWebSocketHandshakeOptions)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QWebSocketHandshakeOptions()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QWebSocketHandshakeOptions()
                cptr = new ::QWebSocketHandshakeOptions();
            }
            break;
        }
        case 1: // QWebSocketHandshakeOptions(const QWebSocketHandshakeOptions &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QWebSocketHandshakeOptions cppArg0_local;
            ::QWebSocketHandshakeOptions *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QWebSocketHandshakeOptions(QWebSocketHandshakeOptions)
                cptr = new ::QWebSocketHandshakeOptions(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWebSocketHandshakeOptions >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QWebSocketHandshakeOptionsFunc_setSubprotocols(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebSocketHandshakeOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebSockets.QWebSocketHandshakeOptions.setSubprotocols";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebSocketHandshakeOptions::setSubprotocols(QStringList)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], (pyArg)))) {
        overloadId = 0; // setSubprotocols(QStringList)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QStringList cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setSubprotocols(QStringList)
            cppSelf->setSubprotocols(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebSocketHandshakeOptionsFunc_subprotocols(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebSocketHandshakeOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebSockets.QWebSocketHandshakeOptions.subprotocols";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // subprotocols()const
            QStringList cppResult = const_cast<const ::QWebSocketHandshakeOptions *>(cppSelf)->subprotocols();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebSocketHandshakeOptionsFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebSocketHandshakeOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebSockets.QWebSocketHandshakeOptions.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebSocketHandshakeOptions::swap(QWebSocketHandshakeOptions&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QWebSocketHandshakeOptions&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QWebSocketHandshakeOptions cppArg0_local;
        ::QWebSocketHandshakeOptions *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QWebSocketHandshakeOptions&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebSocketHandshakeOptions__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebSocketHandshakeOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebSocketHandshakeOptions_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebSocketHandshakeOptions_methods[] = {
    {"setSubprotocols", reinterpret_cast<PyCFunction>(Sbk_QWebSocketHandshakeOptionsFunc_setSubprotocols), METH_O, nullptr},
    {"subprotocols", reinterpret_cast<PyCFunction>(Sbk_QWebSocketHandshakeOptionsFunc_subprotocols), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QWebSocketHandshakeOptionsFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QWebSocketHandshakeOptions__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QWebSocketHandshakeOptions_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebSocketHandshakeOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX]), (pyArg)))) {
                // operator!=(const QWebSocketHandshakeOptions &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QWebSocketHandshakeOptions cppArg0_local;
                ::QWebSocketHandshakeOptions *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX]), (pyArg)))) {
                // operator==(const QWebSocketHandshakeOptions &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QWebSocketHandshakeOptions cppArg0_local;
                ::QWebSocketHandshakeOptions *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QWebSocketHandshakeOptions_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebSocketHandshakeOptions_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebSocketHandshakeOptions_Type = nullptr;
static PyTypeObject *Sbk_QWebSocketHandshakeOptions_TypeF(void)
{
    return _Sbk_QWebSocketHandshakeOptions_Type;
}

static PyType_Slot Sbk_QWebSocketHandshakeOptions_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebSocketHandshakeOptions_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebSocketHandshakeOptions_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QWebSocketHandshakeOptions_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebSocketHandshakeOptions_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QWebSocketHandshakeOptions_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebSocketHandshakeOptions_spec = {
    "2:PySide6.QtWebSockets.QWebSocketHandshakeOptions",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebSocketHandshakeOptions_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebSocketHandshakeOptions_PythonToCpp_QWebSocketHandshakeOptions_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebSocketHandshakeOptions_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebSocketHandshakeOptions_PythonToCpp_QWebSocketHandshakeOptions_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebSocketHandshakeOptions_TypeF()))
        return QWebSocketHandshakeOptions_PythonToCpp_QWebSocketHandshakeOptions_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebSocketHandshakeOptions_PTR_CppToPython_QWebSocketHandshakeOptions(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QWebSocketHandshakeOptions *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QWebSocketHandshakeOptions_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QWebSocketHandshakeOptions_COPY_CppToPython_QWebSocketHandshakeOptions(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QWebSocketHandshakeOptions *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QWebSocketHandshakeOptions_TypeF(), new ::QWebSocketHandshakeOptions(*source), true, true);
}

// Python to C++ copy conversion.
static void QWebSocketHandshakeOptions_PythonToCpp_QWebSocketHandshakeOptions_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QWebSocketHandshakeOptions *>(cppOut) = *reinterpret_cast< ::QWebSocketHandshakeOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QWebSocketHandshakeOptions_PythonToCpp_QWebSocketHandshakeOptions_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QWebSocketHandshakeOptions_TypeF()))
        return QWebSocketHandshakeOptions_PythonToCpp_QWebSocketHandshakeOptions_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QWebSocketHandshakeOptions_SignatureStrings[] = {
    "1:PySide6.QtWebSockets.QWebSocketHandshakeOptions(self)",
    "0:PySide6.QtWebSockets.QWebSocketHandshakeOptions(self,other:PySide6.QtWebSockets.QWebSocketHandshakeOptions)",
    "PySide6.QtWebSockets.QWebSocketHandshakeOptions.setSubprotocols(self,protocols:QStringList)",
    "PySide6.QtWebSockets.QWebSocketHandshakeOptions.subprotocols(self)->QStringList",
    "PySide6.QtWebSockets.QWebSocketHandshakeOptions.swap(self,other:PySide6.QtWebSockets.QWebSocketHandshakeOptions)",
    "PySide6.QtWebSockets.QWebSocketHandshakeOptions.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QWebSocketHandshakeOptions(PyObject *module)
{
    if (SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX].type != nullptr)
        return SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebSocketHandshakeOptions_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebSocketHandshakeOptions_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebSocketHandshakeOptions",
        "QWebSocketHandshakeOptions",
        &Sbk_QWebSocketHandshakeOptions_spec,
        &Shiboken::callCppDestructor< ::QWebSocketHandshakeOptions >,
        Sbk_QWebSocketHandshakeOptions_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QWebSocketHandshakeOptions_TypeF(); // references _Sbk_QWebSocketHandshakeOptions_Type
    InitSignatureStrings(pyType, QWebSocketHandshakeOptions_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebSocketHandshakeOptions_PropertyStrings);
    SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketHandshakeOptions_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebSocketHandshakeOptions_PythonToCpp_QWebSocketHandshakeOptions_PTR,
        is_QWebSocketHandshakeOptions_PythonToCpp_QWebSocketHandshakeOptions_PTR_Convertible,
        QWebSocketHandshakeOptions_PTR_CppToPython_QWebSocketHandshakeOptions,
        QWebSocketHandshakeOptions_COPY_CppToPython_QWebSocketHandshakeOptions);

    Shiboken::Conversions::registerConverterName(converter, "QWebSocketHandshakeOptions");
    Shiboken::Conversions::registerConverterName(converter, "QWebSocketHandshakeOptions*");
    Shiboken::Conversions::registerConverterName(converter, "QWebSocketHandshakeOptions&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebSocketHandshakeOptions).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QWebSocketHandshakeOptions_PythonToCpp_QWebSocketHandshakeOptions_COPY,
        is_QWebSocketHandshakeOptions_PythonToCpp_QWebSocketHandshakeOptions_COPY_Convertible);

    qRegisterMetaType< ::QWebSocketHandshakeOptions >("QWebSocketHandshakeOptions");

    return pyType;
}
