// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleWidgetWrapper_H
#define SBK_QAccessibleWidgetWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qaccessiblewidget.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAccessibleWidgetWrapper : public QAccessibleWidget
{
public:
    QAccessibleWidgetWrapper(const QAccessibleWidgetWrapper &) = delete;
    QAccessibleWidgetWrapper& operator=(const QAccessibleWidgetWrapper &) = delete;
    QAccessibleWidgetWrapper(QAccessibleWidgetWrapper &&) = delete;
    QAccessibleWidgetWrapper& operator=(QAccessibleWidgetWrapper &&) = delete;

    QAccessibleWidgetWrapper(::QWidget * o, ::QAccessible::Role r = QAccessible::Client, const ::QString & name = QString());
    ::QStringList actionNames() const override;
    ::QColor backgroundColor() const override;
    ::QAccessibleInterface * child(int index) const override;
    ::QAccessibleInterface * childAt(int x, int y) const override;
    int childCount() const override;
    void doAction(const ::QString & actionName) override;
    ::QAccessibleInterface * focusChild() const override;
    ::QColor foregroundColor() const override;
    int indexOfChild(const ::QAccessibleInterface * child) const override;
    void * interface_cast(::QAccessible::InterfaceType t) override;
    bool isValid() const override;
    ::QStringList keyBindingsForAction(const ::QString & actionName) const override;
    ::QString localizedActionDescription(const ::QString & name) const override;
    ::QString localizedActionName(const ::QString & name) const override;
    ::QObject * object() const override;
    ::QAccessibleInterface * parent() const override;
    ::QRect rect() const override;
    ::QList<std::pair< QAccessibleInterface*,QFlags<QAccessible::RelationFlag>>> relations(::QFlags<QAccessible::RelationFlag> match = QAccessible::AllRelations) const override;
    ::QAccessible::Role role() const override;
    void setText(::QAccessible::Text t, const ::QString & text) override;
    ::QAccessible::State state() const override;
    ::QString text(::QAccessible::Text t) const override;
    void virtual_hook(int id, void * data) override;
    ::QWindow * window() const override;
    ~QAccessibleWidgetWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[24];
};

#endif // SBK_QAccessibleWidgetWrapper_H

