// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDataWidgetMapperWrapper_H
#define SBK_QDataWidgetMapperWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qdatawidgetmapper.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QDataWidgetMapperWrapper : public QDataWidgetMapper
{
public:
    QDataWidgetMapperWrapper(const QDataWidgetMapperWrapper &) = delete;
    QDataWidgetMapperWrapper& operator=(const QDataWidgetMapperWrapper &) = delete;
    QDataWidgetMapperWrapper(QDataWidgetMapperWrapper &&) = delete;
    QDataWidgetMapperWrapper& operator=(QDataWidgetMapperWrapper &&) = delete;

    QDataWidgetMapperWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void setCurrentIndex(int index) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QDataWidgetMapperWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#endif // SBK_QDataWidgetMapperWrapper_H

