// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGestureEventWrapper_H
#define SBK_QGestureEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgesture.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGestureEventWrapper : public QGestureEvent
{
public:
    QGestureEventWrapper(const QGestureEventWrapper &) = delete;
    QGestureEventWrapper& operator=(const QGestureEventWrapper &) = delete;
    QGestureEventWrapper(QGestureEventWrapper &&) = delete;
    QGestureEventWrapper& operator=(QGestureEventWrapper &&) = delete;

    QGestureEventWrapper(const ::QList<QGesture*> & gestures);
    ::QEvent * clone() const override;
    ~QGestureEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QGestureEventWrapper_H

