// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsGridLayoutWrapper_H
#define SBK_QGraphicsGridLayoutWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicsgridlayout.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGraphicsGridLayoutWrapper : public QGraphicsGridLayout
{
public:
    QGraphicsGridLayoutWrapper(const QGraphicsGridLayoutWrapper &) = delete;
    QGraphicsGridLayoutWrapper& operator=(const QGraphicsGridLayoutWrapper &) = delete;
    QGraphicsGridLayoutWrapper(QGraphicsGridLayoutWrapper &&) = delete;
    QGraphicsGridLayoutWrapper& operator=(QGraphicsGridLayoutWrapper &&) = delete;

    QGraphicsGridLayoutWrapper(::QGraphicsLayoutItem * parent = nullptr);
    int count() const override;
    void getContentsMargins(qreal * left, qreal * top, qreal * right, qreal * bottom) const override;
    void invalidate() override;
    bool isEmpty() const override;
    ::QGraphicsLayoutItem * itemAt(int index) const override;
    void removeAt(int index) override;
    void setGeometry(const ::QRectF & rect) override;
    ::QSizeF sizeHint(::Qt::SizeHint which, const ::QSizeF & constraint = QSizeF()) const override;
    void updateGeometry() override;
    void widgetEvent(::QEvent * e) override;
    ~QGraphicsGridLayoutWrapper() override;
    // Inherited overloads, because the using keyword sux
    inline ::QGraphicsLayoutItem * itemAt(int row, int column) const { return QGraphicsGridLayout::itemAt(row, column); }
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10];
};

#endif // SBK_QGraphicsGridLayoutWrapper_H

