// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsItemAnimationWrapper_H
#define SBK_QGraphicsItemAnimationWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicsitemanimation.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGraphicsItemAnimationWrapper : public QGraphicsItemAnimation
{
public:
    QGraphicsItemAnimationWrapper(const QGraphicsItemAnimationWrapper &) = delete;
    QGraphicsItemAnimationWrapper& operator=(const QGraphicsItemAnimationWrapper &) = delete;
    QGraphicsItemAnimationWrapper(QGraphicsItemAnimationWrapper &&) = delete;
    QGraphicsItemAnimationWrapper& operator=(QGraphicsItemAnimationWrapper &&) = delete;

    QGraphicsItemAnimationWrapper(::QObject * parent = nullptr);
    void afterAnimationStep(qreal step) override;
    void beforeAnimationStep(qreal step) override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QGraphicsItemAnimationWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QGraphicsItemAnimationWrapper_H

