// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsLinearLayoutWrapper_H
#define SBK_QGraphicsLinearLayoutWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicslinearlayout.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGraphicsLinearLayoutWrapper : public QGraphicsLinearLayout
{
public:
    QGraphicsLinearLayoutWrapper(const QGraphicsLinearLayoutWrapper &) = delete;
    QGraphicsLinearLayoutWrapper& operator=(const QGraphicsLinearLayoutWrapper &) = delete;
    QGraphicsLinearLayoutWrapper(QGraphicsLinearLayoutWrapper &&) = delete;
    QGraphicsLinearLayoutWrapper& operator=(QGraphicsLinearLayoutWrapper &&) = delete;

    QGraphicsLinearLayoutWrapper(::QGraphicsLayoutItem * parent = nullptr);
    QGraphicsLinearLayoutWrapper(::Qt::Orientation orientation, ::QGraphicsLayoutItem * parent = nullptr);
    int count() const override;
    void getContentsMargins(qreal * left, qreal * top, qreal * right, qreal * bottom) const override;
    void invalidate() override;
    bool isEmpty() const override;
    ::QGraphicsLayoutItem * itemAt(int index) const override;
    void removeAt(int index) override;
    void setGeometry(const ::QRectF & rect) override;
    ::QSizeF sizeHint(::Qt::SizeHint which, const ::QSizeF & constraint = QSizeF()) const override;
    void updateGeometry() override;
    void widgetEvent(::QEvent * e) override;
    ~QGraphicsLinearLayoutWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10];
};

#endif // SBK_QGraphicsLinearLayoutWrapper_H

