// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsSceneDragDropEventWrapper_H
#define SBK_QGraphicsSceneDragDropEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGraphicsSceneDragDropEventWrapper : public QGraphicsSceneDragDropEvent
{
public:
    QGraphicsSceneDragDropEventWrapper(const QGraphicsSceneDragDropEventWrapper &) = delete;
    QGraphicsSceneDragDropEventWrapper& operator=(const QGraphicsSceneDragDropEventWrapper &) = delete;
    QGraphicsSceneDragDropEventWrapper(QGraphicsSceneDragDropEventWrapper &&) = delete;
    QGraphicsSceneDragDropEventWrapper& operator=(QGraphicsSceneDragDropEventWrapper &&) = delete;

    QGraphicsSceneDragDropEventWrapper(::QEvent::Type type = QEvent::Type::None);
    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QGraphicsSceneDragDropEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QGraphicsSceneDragDropEventWrapper_H

