// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QListWidgetItemWrapper_H
#define SBK_QListWidgetItemWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qlistwidget.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QListWidgetItemWrapper : public QListWidgetItem
{
public:
    QListWidgetItemWrapper(const QListWidgetItemWrapper &) = delete;
    QListWidgetItemWrapper& operator=(const QListWidgetItemWrapper &) = delete;
    QListWidgetItemWrapper(QListWidgetItemWrapper &&) = delete;
    QListWidgetItemWrapper& operator=(QListWidgetItemWrapper &&) = delete;

    QListWidgetItemWrapper(::QListWidget * listview = nullptr, int type = QListWidgetItem::ItemType::Type);
    QListWidgetItemWrapper(const ::QIcon & icon, const ::QString & text, ::QListWidget * listview = nullptr, int type = QListWidgetItem::ItemType::Type);
    QListWidgetItemWrapper(const QListWidgetItem& self) : QListWidgetItem(self)
    {
    }

    QListWidgetItemWrapper(const ::QString & text, ::QListWidget * listview = nullptr, int type = QListWidgetItem::ItemType::Type);
    ::QListWidgetItem * clone() const override;
    ::QVariant data(int role) const override;
    bool operator<(const ::QListWidgetItem & other) const override;
    void read(::QDataStream & in) override;
    void setData(int role, const ::QVariant & value) override;
    void write(::QDataStream & out) const override;
    ~QListWidgetItemWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[6];
};

#endif // SBK_QListWidgetItemWrapper_H

