// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMdiSubWindowWrapper_H
#define SBK_QMdiSubWindowWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qmdisubwindow.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QMdiSubWindowWrapper : public QMdiSubWindow
{
public:
    QMdiSubWindowWrapper(const QMdiSubWindowWrapper &) = delete;
    QMdiSubWindowWrapper& operator=(const QMdiSubWindowWrapper &) = delete;
    QMdiSubWindowWrapper(QMdiSubWindowWrapper &&) = delete;
    QMdiSubWindowWrapper& operator=(QMdiSubWindowWrapper &&) = delete;

    QMdiSubWindowWrapper(::QWidget * parent = nullptr, ::QFlags<Qt::WindowType> flags = Qt::WindowFlags());
    void actionEvent(::QActionEvent * event) override;
    void changeEvent(::QEvent * changeEvent) override;
    void childEvent(::QChildEvent * childEvent) override;
    void closeEvent(::QCloseEvent * closeEvent) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void contextMenuEvent(::QContextMenuEvent * contextMenuEvent) override;
    void customEvent(::QEvent * event) override;
    int devType() const override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void dragEnterEvent(::QDragEnterEvent * event) override;
    void dragLeaveEvent(::QDragLeaveEvent * event) override;
    void dragMoveEvent(::QDragMoveEvent * event) override;
    void dropEvent(::QDropEvent * event) override;
    void enterEvent(::QEnterEvent * event) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * object, ::QEvent * event) override;
    void focusInEvent(::QFocusEvent * focusInEvent) override;
    bool focusNextPrevChild(bool next) override;
    void focusOutEvent(::QFocusEvent * focusOutEvent) override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    void hideEvent(::QHideEvent * hideEvent) override;
    void initPainter(::QPainter * painter) const override;
    void inputMethodEvent(::QInputMethodEvent * event) override;
    ::QVariant inputMethodQuery(::Qt::InputMethodQuery arg__1) const override;
    void keyPressEvent(::QKeyEvent * keyEvent) override;
    void keyReleaseEvent(::QKeyEvent * event) override;
    void leaveEvent(::QEvent * leaveEvent) override;
    int metric(::QPaintDevice::PaintDeviceMetric arg__1) const override;
    ::QSize minimumSizeHint() const override;
    void mouseDoubleClickEvent(::QMouseEvent * mouseEvent) override;
    void mouseMoveEvent(::QMouseEvent * mouseEvent) override;
    void mousePressEvent(::QMouseEvent * mouseEvent) override;
    void mouseReleaseEvent(::QMouseEvent * mouseEvent) override;
    void moveEvent(::QMoveEvent * moveEvent) override;
    bool nativeEvent(const ::QByteArray & eventType, void * message, ::qintptr * result) override;
    ::QPaintEngine * paintEngine() const override;
    void paintEvent(::QPaintEvent * paintEvent) override;
    ::QPaintDevice * redirected(::QPoint * offset) const override;
    void resizeEvent(::QResizeEvent * resizeEvent) override;
    void setVisible(bool visible) override;
    ::QPainter * sharedPainter() const override;
    void showEvent(::QShowEvent * showEvent) override;
    ::QSize sizeHint() const override;
    void tabletEvent(::QTabletEvent * event) override;
    void timerEvent(::QTimerEvent * timerEvent) override;
    void wheelEvent(::QWheelEvent * event) override;
    ~QMdiSubWindowWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[47];
};

#endif // SBK_QMdiSubWindowWrapper_H

