// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QScrollerPropertiesWrapper_H
#define SBK_QScrollerPropertiesWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qscrollerproperties.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QScrollerPropertiesWrapper : public QScrollerProperties
{
public:
    QScrollerPropertiesWrapper(const QScrollerPropertiesWrapper &) = delete;
    QScrollerPropertiesWrapper& operator=(const QScrollerPropertiesWrapper &) = delete;
    QScrollerPropertiesWrapper(QScrollerPropertiesWrapper &&) = delete;
    QScrollerPropertiesWrapper& operator=(QScrollerPropertiesWrapper &&) = delete;

    QScrollerPropertiesWrapper();
    QScrollerPropertiesWrapper(const QScrollerProperties& self) : QScrollerProperties(self)
    {
    }

    ~QScrollerPropertiesWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QScrollerPropertiesWrapper_H

