// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwidgets_python.h"

// main header
#include "qstyleoptionheader_wrapper.h"

// Argument includes
#include <QtWidgets/qstyleoption.h>
#include <QtWidgets/qwidget.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionHeader_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QStyleOptionHeader >()))
        return -1;

    ::QStyleOptionHeader *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWidgets.QStyleOptionHeader.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QStyleOptionHeader", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QStyleOptionHeader::QStyleOptionHeader()
    // 1: QStyleOptionHeader::QStyleOptionHeader(QStyleOptionHeader)
    // 2: QStyleOptionHeader::QStyleOptionHeader(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionHeader()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 2; // QStyleOptionHeader(int)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QStyleOptionHeader(QStyleOptionHeader)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QStyleOptionHeader()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionHeader()
                cptr = new ::QStyleOptionHeader();
            }
            break;
        }
        case 1: // QStyleOptionHeader(const QStyleOptionHeader &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QStyleOptionHeader *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionHeader(QStyleOptionHeader)
                cptr = new ::QStyleOptionHeader(*cppArg0);
            }
            break;
        }
        case 2: // QStyleOptionHeader(int version)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionHeader(int)
                cptr = new ::QStyleOptionHeader(cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QStyleOptionHeader >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}


static const char *Sbk_QStyleOptionHeader_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QStyleOptionHeader_EnumFlagInfo[] = {
    "SectionPosition:Enum",
    "SelectedPosition:Enum",
    "SortIndicator:Enum",
    "StyleOptionType:Enum",
    "StyleOptionVersion:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QStyleOptionHeader_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QStyleOptionHeader_get_section(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->section;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionHeader_set_section(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("section");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("section", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->section;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->section = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionHeader_get_text(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppSelf->text);
    return pyOut;
}
static int Sbk_QStyleOptionHeader_set_text(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("text");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("text", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->text;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QStyleOptionHeader_get_textAlignment(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QFlags_Qt_AlignmentFlag_IDX])))->converter, &cppSelf->textAlignment);
    return pyOut;
}
static int Sbk_QStyleOptionHeader_set_textAlignment(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("textAlignment");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QFlags_Qt_AlignmentFlag_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("textAlignment", "Alignment");
        return -1;
    }

    auto cppOut_local = cppSelf->textAlignment;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->textAlignment = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionHeader_get_icon(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->icon)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->icon))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->icon)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_IDX]), &(cppSelf->icon), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QStyleOptionHeader_set_icon(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("icon");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("icon", "QIcon");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->icon;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QStyleOptionHeader_get_iconAlignment(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QFlags_Qt_AlignmentFlag_IDX])))->converter, &cppSelf->iconAlignment);
    return pyOut;
}
static int Sbk_QStyleOptionHeader_set_iconAlignment(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("iconAlignment");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QFlags_Qt_AlignmentFlag_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("iconAlignment", "Alignment");
        return -1;
    }

    auto cppOut_local = cppSelf->iconAlignment;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->iconAlignment = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionHeader_get_position(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QStyleOptionHeader::SectionPosition cppOut_local = cppSelf->position;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SectionPosition_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionHeader_set_position(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("position");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SectionPosition_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("position", "SectionPosition");
        return -1;
    }

    auto cppOut_local = cppSelf->position;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->position = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionHeader_get_selectedPosition(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QStyleOptionHeader::SelectedPosition cppOut_local = cppSelf->selectedPosition;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SelectedPosition_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionHeader_set_selectedPosition(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("selectedPosition");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SelectedPosition_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("selectedPosition", "SelectedPosition");
        return -1;
    }

    auto cppOut_local = cppSelf->selectedPosition;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->selectedPosition = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionHeader_get_sortIndicator(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QStyleOptionHeader::SortIndicator cppOut_local = cppSelf->sortIndicator;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SortIndicator_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionHeader_set_sortIndicator(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("sortIndicator");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SortIndicator_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("sortIndicator", "SortIndicator");
        return -1;
    }

    auto cppOut_local = cppSelf->sortIndicator;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->sortIndicator = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionHeader_get_orientation(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::Qt::Orientation cppOut_local = cppSelf->orientation;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_Orientation_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionHeader_set_orientation(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeader *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("orientation");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_Orientation_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("orientation", "Orientation");
        return -1;
    }

    auto cppOut_local = cppSelf->orientation;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->orientation = cppOut_local;

    return 0;
}

// Getters and Setters for QStyleOptionHeader
static PyGetSetDef Sbk_QStyleOptionHeader_getsetlist[] = {
    {const_cast<char *>("section"), Sbk_QStyleOptionHeader_get_section, Sbk_QStyleOptionHeader_set_section, nullptr, nullptr},
    {const_cast<char *>("text"), Sbk_QStyleOptionHeader_get_text, Sbk_QStyleOptionHeader_set_text, nullptr, nullptr},
    {const_cast<char *>("textAlignment"), Sbk_QStyleOptionHeader_get_textAlignment, Sbk_QStyleOptionHeader_set_textAlignment, nullptr, nullptr},
    {const_cast<char *>("icon"), Sbk_QStyleOptionHeader_get_icon, Sbk_QStyleOptionHeader_set_icon, nullptr, nullptr},
    {const_cast<char *>("iconAlignment"), Sbk_QStyleOptionHeader_get_iconAlignment, Sbk_QStyleOptionHeader_set_iconAlignment, nullptr, nullptr},
    {const_cast<char *>("position"), Sbk_QStyleOptionHeader_get_position, Sbk_QStyleOptionHeader_set_position, nullptr, nullptr},
    {const_cast<char *>("selectedPosition"), Sbk_QStyleOptionHeader_get_selectedPosition, Sbk_QStyleOptionHeader_set_selectedPosition, nullptr, nullptr},
    {const_cast<char *>("sortIndicator"), Sbk_QStyleOptionHeader_get_sortIndicator, Sbk_QStyleOptionHeader_set_sortIndicator, nullptr, nullptr},
    {const_cast<char *>("orientation"), Sbk_QStyleOptionHeader_get_orientation, Sbk_QStyleOptionHeader_set_orientation, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QStyleOptionHeader_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QStyleOptionHeader_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QStyleOptionHeader_Type = nullptr;
static PyTypeObject *Sbk_QStyleOptionHeader_TypeF(void)
{
    return _Sbk_QStyleOptionHeader_Type;
}

static PyType_Slot Sbk_QStyleOptionHeader_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QStyleOptionHeader_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QStyleOptionHeader_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QStyleOptionHeader_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QStyleOptionHeader_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QStyleOptionHeader_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QStyleOptionHeader_spec = {
    "2:PySide6.QtWidgets.QStyleOptionHeader",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QStyleOptionHeader_slots
};

} //extern "C"

static void *Sbk_QStyleOptionHeader_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    SBK_UNUSED(cptr)
    SBK_UNUSED(instanceType)
    if (qstyleoption_cast<const QStyleOptionHeader *>( reinterpret_cast< ::QStyleOption *>(cptr)) != nullptr)
        return cptr;
    return {};
}


// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QStyleOptionHeader_StyleOptionType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionHeader::StyleOptionType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionHeader::StyleOptionType *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleOptionHeader_StyleOptionType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_StyleOptionType_IDX])))
        return Enum_PythonToCpp_QStyleOptionHeader_StyleOptionType;
    return {};
}
static PyObject *QStyleOptionHeader_StyleOptionType_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionHeader::StyleOptionType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_StyleOptionType_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QStyleOptionHeader_StyleOptionVersion(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionHeader::StyleOptionVersion>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionHeader::StyleOptionVersion *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleOptionHeader_StyleOptionVersion_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_StyleOptionVersion_IDX])))
        return Enum_PythonToCpp_QStyleOptionHeader_StyleOptionVersion;
    return {};
}
static PyObject *QStyleOptionHeader_StyleOptionVersion_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionHeader::StyleOptionVersion *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_StyleOptionVersion_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QStyleOptionHeader_SectionPosition(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionHeader::SectionPosition>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionHeader::SectionPosition *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleOptionHeader_SectionPosition_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SectionPosition_IDX])))
        return Enum_PythonToCpp_QStyleOptionHeader_SectionPosition;
    return {};
}
static PyObject *QStyleOptionHeader_SectionPosition_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionHeader::SectionPosition *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SectionPosition_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QStyleOptionHeader_SelectedPosition(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionHeader::SelectedPosition>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionHeader::SelectedPosition *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleOptionHeader_SelectedPosition_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SelectedPosition_IDX])))
        return Enum_PythonToCpp_QStyleOptionHeader_SelectedPosition;
    return {};
}
static PyObject *QStyleOptionHeader_SelectedPosition_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionHeader::SelectedPosition *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SelectedPosition_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QStyleOptionHeader_SortIndicator(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionHeader::SortIndicator>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionHeader::SortIndicator *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleOptionHeader_SortIndicator_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SortIndicator_IDX])))
        return Enum_PythonToCpp_QStyleOptionHeader_SortIndicator;
    return {};
}
static PyObject *QStyleOptionHeader_SortIndicator_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionHeader::SortIndicator *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SortIndicator_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QStyleOptionHeader_PythonToCpp_QStyleOptionHeader_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QStyleOptionHeader_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QStyleOptionHeader_PythonToCpp_QStyleOptionHeader_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QStyleOptionHeader_TypeF()))
        return QStyleOptionHeader_PythonToCpp_QStyleOptionHeader_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QStyleOptionHeader_PTR_CppToPython_QStyleOptionHeader(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QStyleOptionHeader *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QStyleOptionHeader_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QStyleOptionHeader_SignatureStrings[] = {
    "2:PySide6.QtWidgets.QStyleOptionHeader(self)",
    "1:PySide6.QtWidgets.QStyleOptionHeader(self,other:PySide6.QtWidgets.QStyleOptionHeader)",
    "0:PySide6.QtWidgets.QStyleOptionHeader(self,version:int)",
    nullptr}; // Sentinel

PyTypeObject *init_QStyleOptionHeader(PyObject *module)
{
    if (SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX].type != nullptr)
        return SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX].type;

    Shiboken::AutoDecRef Sbk_QStyleOptionHeader_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOption_IDX]))));

    _Sbk_QStyleOptionHeader_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QStyleOptionHeader",
        "QStyleOptionHeader*",
        &Sbk_QStyleOptionHeader_spec,
        &Shiboken::callCppDestructor< ::QStyleOptionHeader >,
        Sbk_QStyleOptionHeader_Type_bases.object(),
        0);
    auto *pyType = Sbk_QStyleOptionHeader_TypeF(); // references _Sbk_QStyleOptionHeader_Type
    InitSignatureStrings(pyType, QStyleOptionHeader_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QStyleOptionHeader_PropertyStrings);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QStyleOptionHeader_PythonToCpp_QStyleOptionHeader_PTR,
        is_QStyleOptionHeader_PythonToCpp_QStyleOptionHeader_PTR_Convertible,
        QStyleOptionHeader_PTR_CppToPython_QStyleOptionHeader);

    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeader");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeader*");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeader&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QStyleOptionHeader).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(
        Sbk_QStyleOptionHeader_TypeF(), &Sbk_QStyleOptionHeader_typeDiscovery);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QStyleOptionHeader_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'StyleOptionType'.
    const char *StyleOptionType_Initializer[] = {
        "Type",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionType_InitializerValues[] = {
        uint8_t(QStyleOptionHeader::StyleOptionType::Type) //  0x08  8
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionHeader_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionHeader.StyleOptionType",
        StyleOptionType_Initializer, StyleOptionType_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_StyleOptionType_IDX].type = EType;
    // Register converter for enum 'QStyleOptionHeader::StyleOptionType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionHeader_StyleOptionType_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleOptionHeader_StyleOptionType,
            is_Enum_PythonToCpp_QStyleOptionHeader_StyleOptionType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeader::StyleOptionType");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionType");
    }
    // End of 'StyleOptionType' enum.

    // Initialization of enum 'StyleOptionVersion'.
    const char *StyleOptionVersion_Initializer[] = {
        "Version",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionVersion_InitializerValues[] = {
        uint8_t(QStyleOptionHeader::StyleOptionVersion::Version) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionHeader_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionHeader.StyleOptionVersion",
        StyleOptionVersion_Initializer, StyleOptionVersion_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_StyleOptionVersion_IDX].type = EType;
    // Register converter for enum 'QStyleOptionHeader::StyleOptionVersion'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionHeader_StyleOptionVersion_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleOptionHeader_StyleOptionVersion,
            is_Enum_PythonToCpp_QStyleOptionHeader_StyleOptionVersion_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeader::StyleOptionVersion");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionVersion");
    }
    // End of 'StyleOptionVersion' enum.

    // Initialization of enum 'SectionPosition'.
    const char *SectionPosition_Initializer[] = {
        "Beginning",
        "Middle",
        "End",
        "OnlyOneSection",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t SectionPosition_InitializerValues[] = {
        uint8_t(QStyleOptionHeader::SectionPosition::Beginning),     //  0x00  0
        uint8_t(QStyleOptionHeader::SectionPosition::Middle),        //  0x01  1
        uint8_t(QStyleOptionHeader::SectionPosition::End),           //  0x02  2
        uint8_t(QStyleOptionHeader::SectionPosition::OnlyOneSection) //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionHeader_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionHeader.SectionPosition",
        SectionPosition_Initializer, SectionPosition_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SectionPosition_IDX].type = EType;
    // Register converter for enum 'QStyleOptionHeader::SectionPosition'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionHeader_SectionPosition_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleOptionHeader_SectionPosition,
            is_Enum_PythonToCpp_QStyleOptionHeader_SectionPosition_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeader::SectionPosition");
        Shiboken::Conversions::registerConverterName(converter, "SectionPosition");
    }
    // End of 'SectionPosition' enum.

    // Initialization of enum 'SelectedPosition'.
    const char *SelectedPosition_Initializer[] = {
        "NotAdjacent",
        "NextIsSelected",
        "PreviousIsSelected",
        "NextAndPreviousAreSelected",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t SelectedPosition_InitializerValues[] = {
        uint8_t(QStyleOptionHeader::SelectedPosition::NotAdjacent),               //  0x00  0
        uint8_t(QStyleOptionHeader::SelectedPosition::NextIsSelected),            //  0x01  1
        uint8_t(QStyleOptionHeader::SelectedPosition::PreviousIsSelected),        //  0x02  2
        uint8_t(QStyleOptionHeader::SelectedPosition::NextAndPreviousAreSelected) //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionHeader_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionHeader.SelectedPosition",
        SelectedPosition_Initializer, SelectedPosition_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SelectedPosition_IDX].type = EType;
    // Register converter for enum 'QStyleOptionHeader::SelectedPosition'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionHeader_SelectedPosition_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleOptionHeader_SelectedPosition,
            is_Enum_PythonToCpp_QStyleOptionHeader_SelectedPosition_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeader::SelectedPosition");
        Shiboken::Conversions::registerConverterName(converter, "SelectedPosition");
    }
    // End of 'SelectedPosition' enum.

    // Initialization of enum 'SortIndicator'.
    const char *SortIndicator_Initializer[] = {
        "None_",
        "SortUp",
        "SortDown",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t SortIndicator_InitializerValues[] = {
        uint8_t(QStyleOptionHeader::SortIndicator::None),    //  0x00  0
        uint8_t(QStyleOptionHeader::SortIndicator::SortUp),  //  0x01  1
        uint8_t(QStyleOptionHeader::SortIndicator::SortDown) //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionHeader_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionHeader.SortIndicator",
        SortIndicator_Initializer, SortIndicator_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_SortIndicator_IDX].type = EType;
    // Register converter for enum 'QStyleOptionHeader::SortIndicator'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionHeader_SortIndicator_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleOptionHeader_SortIndicator,
            is_Enum_PythonToCpp_QStyleOptionHeader_SortIndicator_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeader::SortIndicator");
        Shiboken::Conversions::registerConverterName(converter, "SortIndicator");
    }
    // End of 'SortIndicator' enum.

    qRegisterMetaType< ::QStyleOptionHeader *>();
    qRegisterMetaType< ::QStyleOptionHeader::StyleOptionType >("QStyleOptionHeader::StyleOptionType");
    qRegisterMetaType< ::QStyleOptionHeader::StyleOptionVersion >("QStyleOptionHeader::StyleOptionVersion");
    qRegisterMetaType< ::QStyleOptionHeader::SectionPosition >("QStyleOptionHeader::SectionPosition");
    qRegisterMetaType< ::QStyleOptionHeader::SelectedPosition >("QStyleOptionHeader::SelectedPosition");
    qRegisterMetaType< ::QStyleOptionHeader::SortIndicator >("QStyleOptionHeader::SortIndicator");

    return pyType;
}
