// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwidgets_python.h"

// main header
#include "qstyleoptiontoolbar_wrapper.h"

// Argument includes
#include <QtWidgets/qstyleoption.h>
#include <QtWidgets/qwidget.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionToolBar_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QStyleOptionToolBar >()))
        return -1;

    ::QStyleOptionToolBar *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWidgets.QStyleOptionToolBar.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QStyleOptionToolBar", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QStyleOptionToolBar::QStyleOptionToolBar()
    // 1: QStyleOptionToolBar::QStyleOptionToolBar(QStyleOptionToolBar)
    // 2: QStyleOptionToolBar::QStyleOptionToolBar(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionToolBar()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 2; // QStyleOptionToolBar(int)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QStyleOptionToolBar(QStyleOptionToolBar)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QStyleOptionToolBar()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionToolBar()
                cptr = new ::QStyleOptionToolBar();
            }
            break;
        }
        case 1: // QStyleOptionToolBar(const QStyleOptionToolBar &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QStyleOptionToolBar *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionToolBar(QStyleOptionToolBar)
                cptr = new ::QStyleOptionToolBar(*cppArg0);
            }
            break;
        }
        case 2: // QStyleOptionToolBar(int version)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionToolBar(int)
                cptr = new ::QStyleOptionToolBar(cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QStyleOptionToolBar >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}


static const char *Sbk_QStyleOptionToolBar_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QStyleOptionToolBar_EnumFlagInfo[] = {
    "StyleOptionType:Enum",
    "StyleOptionVersion:Enum",
    "ToolBarFeature:Flag:ToolBarFeatures",
    "ToolBarPosition:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QStyleOptionToolBar_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QStyleOptionToolBar_get_positionOfLine(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QStyleOptionToolBar::ToolBarPosition cppOut_local = cppSelf->positionOfLine;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_ToolBarPosition_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionToolBar_set_positionOfLine(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("positionOfLine");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_ToolBarPosition_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("positionOfLine", "ToolBarPosition");
        return -1;
    }

    auto cppOut_local = cppSelf->positionOfLine;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->positionOfLine = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionToolBar_get_positionWithinLine(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QStyleOptionToolBar::ToolBarPosition cppOut_local = cppSelf->positionWithinLine;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_ToolBarPosition_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionToolBar_set_positionWithinLine(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("positionWithinLine");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_ToolBarPosition_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("positionWithinLine", "ToolBarPosition");
        return -1;
    }

    auto cppOut_local = cppSelf->positionWithinLine;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->positionWithinLine = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionToolBar_get_toolBarArea(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::Qt::ToolBarArea cppOut_local = cppSelf->toolBarArea;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_ToolBarArea_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionToolBar_set_toolBarArea(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("toolBarArea");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_ToolBarArea_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("toolBarArea", "ToolBarArea");
        return -1;
    }

    auto cppOut_local = cppSelf->toolBarArea;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->toolBarArea = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionToolBar_get_features(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFlags_QStyleOptionToolBar_ToolBarFeature_IDX])))->converter, &cppSelf->features);
    return pyOut;
}
static int Sbk_QStyleOptionToolBar_set_features(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("features");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFlags_QStyleOptionToolBar_ToolBarFeature_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("features", "ToolBarFeatures");
        return -1;
    }

    auto cppOut_local = cppSelf->features;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->features = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionToolBar_get_lineWidth(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->lineWidth;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionToolBar_set_lineWidth(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("lineWidth");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("lineWidth", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->lineWidth;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->lineWidth = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionToolBar_get_midLineWidth(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->midLineWidth;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionToolBar_set_midLineWidth(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("midLineWidth");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("midLineWidth", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->midLineWidth;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->midLineWidth = cppOut_local;

    return 0;
}

// Getters and Setters for QStyleOptionToolBar
static PyGetSetDef Sbk_QStyleOptionToolBar_getsetlist[] = {
    {const_cast<char *>("positionOfLine"), Sbk_QStyleOptionToolBar_get_positionOfLine, Sbk_QStyleOptionToolBar_set_positionOfLine, nullptr, nullptr},
    {const_cast<char *>("positionWithinLine"), Sbk_QStyleOptionToolBar_get_positionWithinLine, Sbk_QStyleOptionToolBar_set_positionWithinLine, nullptr, nullptr},
    {const_cast<char *>("toolBarArea"), Sbk_QStyleOptionToolBar_get_toolBarArea, Sbk_QStyleOptionToolBar_set_toolBarArea, nullptr, nullptr},
    {const_cast<char *>("features"), Sbk_QStyleOptionToolBar_get_features, Sbk_QStyleOptionToolBar_set_features, nullptr, nullptr},
    {const_cast<char *>("lineWidth"), Sbk_QStyleOptionToolBar_get_lineWidth, Sbk_QStyleOptionToolBar_set_lineWidth, nullptr, nullptr},
    {const_cast<char *>("midLineWidth"), Sbk_QStyleOptionToolBar_get_midLineWidth, Sbk_QStyleOptionToolBar_set_midLineWidth, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QStyleOptionToolBar_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QStyleOptionToolBar_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QStyleOptionToolBar_Type = nullptr;
static PyTypeObject *Sbk_QStyleOptionToolBar_TypeF(void)
{
    return _Sbk_QStyleOptionToolBar_Type;
}

static PyType_Slot Sbk_QStyleOptionToolBar_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QStyleOptionToolBar_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QStyleOptionToolBar_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QStyleOptionToolBar_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QStyleOptionToolBar_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QStyleOptionToolBar_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QStyleOptionToolBar_spec = {
    "2:PySide6.QtWidgets.QStyleOptionToolBar",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QStyleOptionToolBar_slots
};

} //extern "C"

static void *Sbk_QStyleOptionToolBar_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    SBK_UNUSED(cptr)
    SBK_UNUSED(instanceType)
    if (qstyleoption_cast<const QStyleOptionToolBar *>( reinterpret_cast< ::QStyleOption *>(cptr)) != nullptr)
        return cptr;
    return {};
}


// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QStyleOptionToolBar_StyleOptionType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionToolBar::StyleOptionType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionToolBar::StyleOptionType *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleOptionToolBar_StyleOptionType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_StyleOptionType_IDX])))
        return Enum_PythonToCpp_QStyleOptionToolBar_StyleOptionType;
    return {};
}
static PyObject *QStyleOptionToolBar_StyleOptionType_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionToolBar::StyleOptionType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_StyleOptionType_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QStyleOptionToolBar_StyleOptionVersion(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionToolBar::StyleOptionVersion>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionToolBar::StyleOptionVersion *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleOptionToolBar_StyleOptionVersion_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_StyleOptionVersion_IDX])))
        return Enum_PythonToCpp_QStyleOptionToolBar_StyleOptionVersion;
    return {};
}
static PyObject *QStyleOptionToolBar_StyleOptionVersion_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionToolBar::StyleOptionVersion *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_StyleOptionVersion_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QStyleOptionToolBar_ToolBarPosition(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionToolBar::ToolBarPosition>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionToolBar::ToolBarPosition *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleOptionToolBar_ToolBarPosition_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_ToolBarPosition_IDX])))
        return Enum_PythonToCpp_QStyleOptionToolBar_ToolBarPosition;
    return {};
}
static PyObject *QStyleOptionToolBar_ToolBarPosition_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionToolBar::ToolBarPosition *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_ToolBarPosition_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QStyleOptionToolBar_ToolBarFeature(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionToolBar::ToolBarFeature>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionToolBar::ToolBarFeature *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleOptionToolBar_ToolBarFeature_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_ToolBarFeature_IDX])))
        return Enum_PythonToCpp_QStyleOptionToolBar_ToolBarFeature;
    return {};
}
static PyObject *QStyleOptionToolBar_ToolBarFeature_CppToPython_Enum(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionToolBar::ToolBarFeature *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_ToolBarFeature_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QStyleOptionToolBar_PythonToCpp_QStyleOptionToolBar_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QStyleOptionToolBar_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QStyleOptionToolBar_PythonToCpp_QStyleOptionToolBar_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QStyleOptionToolBar_TypeF()))
        return QStyleOptionToolBar_PythonToCpp_QStyleOptionToolBar_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QStyleOptionToolBar_PTR_CppToPython_QStyleOptionToolBar(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QStyleOptionToolBar *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QStyleOptionToolBar_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QStyleOptionToolBar_SignatureStrings[] = {
    "2:PySide6.QtWidgets.QStyleOptionToolBar(self)",
    "1:PySide6.QtWidgets.QStyleOptionToolBar(self,other:PySide6.QtWidgets.QStyleOptionToolBar)",
    "0:PySide6.QtWidgets.QStyleOptionToolBar(self,version:int)",
    nullptr}; // Sentinel

PyTypeObject *init_QStyleOptionToolBar(PyObject *module)
{
    if (SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX].type != nullptr)
        return SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX].type;

    Shiboken::AutoDecRef Sbk_QStyleOptionToolBar_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOption_IDX]))));

    _Sbk_QStyleOptionToolBar_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QStyleOptionToolBar",
        "QStyleOptionToolBar*",
        &Sbk_QStyleOptionToolBar_spec,
        &Shiboken::callCppDestructor< ::QStyleOptionToolBar >,
        Sbk_QStyleOptionToolBar_Type_bases.object(),
        0);
    auto *pyType = Sbk_QStyleOptionToolBar_TypeF(); // references _Sbk_QStyleOptionToolBar_Type
    InitSignatureStrings(pyType, QStyleOptionToolBar_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QStyleOptionToolBar_PropertyStrings);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QStyleOptionToolBar_PythonToCpp_QStyleOptionToolBar_PTR,
        is_QStyleOptionToolBar_PythonToCpp_QStyleOptionToolBar_PTR_Convertible,
        QStyleOptionToolBar_PTR_CppToPython_QStyleOptionToolBar);

    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBar");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBar*");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBar&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QStyleOptionToolBar).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(
        Sbk_QStyleOptionToolBar_TypeF(), &Sbk_QStyleOptionToolBar_typeDiscovery);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QStyleOptionToolBar_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'StyleOptionType'.
    const char *StyleOptionType_Initializer[] = {
        "Type",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionType_InitializerValues[] = {
        uint8_t(QStyleOptionToolBar::StyleOptionType::Type) //  0x0e  14
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionToolBar_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionToolBar.StyleOptionType",
        StyleOptionType_Initializer, StyleOptionType_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_StyleOptionType_IDX].type = EType;
    // Register converter for enum 'QStyleOptionToolBar::StyleOptionType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionToolBar_StyleOptionType_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleOptionToolBar_StyleOptionType,
            is_Enum_PythonToCpp_QStyleOptionToolBar_StyleOptionType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBar::StyleOptionType");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionType");
    }
    // End of 'StyleOptionType' enum.

    // Initialization of enum 'StyleOptionVersion'.
    const char *StyleOptionVersion_Initializer[] = {
        "Version",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionVersion_InitializerValues[] = {
        uint8_t(QStyleOptionToolBar::StyleOptionVersion::Version) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionToolBar_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionToolBar.StyleOptionVersion",
        StyleOptionVersion_Initializer, StyleOptionVersion_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_StyleOptionVersion_IDX].type = EType;
    // Register converter for enum 'QStyleOptionToolBar::StyleOptionVersion'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionToolBar_StyleOptionVersion_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleOptionToolBar_StyleOptionVersion,
            is_Enum_PythonToCpp_QStyleOptionToolBar_StyleOptionVersion_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBar::StyleOptionVersion");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionVersion");
    }
    // End of 'StyleOptionVersion' enum.

    // Initialization of enum 'ToolBarPosition'.
    const char *ToolBarPosition_Initializer[] = {
        "Beginning",
        "Middle",
        "End",
        "OnlyOne",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ToolBarPosition_InitializerValues[] = {
        uint8_t(QStyleOptionToolBar::ToolBarPosition::Beginning), //  0x00  0
        uint8_t(QStyleOptionToolBar::ToolBarPosition::Middle),    //  0x01  1
        uint8_t(QStyleOptionToolBar::ToolBarPosition::End),       //  0x02  2
        uint8_t(QStyleOptionToolBar::ToolBarPosition::OnlyOne)    //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionToolBar_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionToolBar.ToolBarPosition",
        ToolBarPosition_Initializer, ToolBarPosition_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_ToolBarPosition_IDX].type = EType;
    // Register converter for enum 'QStyleOptionToolBar::ToolBarPosition'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionToolBar_ToolBarPosition_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleOptionToolBar_ToolBarPosition,
            is_Enum_PythonToCpp_QStyleOptionToolBar_ToolBarPosition_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBar::ToolBarPosition");
        Shiboken::Conversions::registerConverterName(converter, "ToolBarPosition");
    }
    // End of 'ToolBarPosition' enum.

    // Initialization of enum 'ToolBarFeature'.
    const char *ToolBarFeature_Initializer[] = {
        "None_",
        "Movable",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ToolBarFeature_InitializerValues[] = {
        uint8_t(QStyleOptionToolBar::ToolBarFeature::None),   //  0x00  0
        uint8_t(QStyleOptionToolBar::ToolBarFeature::Movable) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionToolBar_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionToolBar.ToolBarFeature",
        ToolBarFeature_Initializer, ToolBarFeature_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBar_ToolBarFeature_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtWidgetsTypeStructs[SBK_QFlags_QStyleOptionToolBar_ToolBarFeature_IDX].type =
        EType;
    // Register converter for enum 'QStyleOptionToolBar::ToolBarFeature'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionToolBar_ToolBarFeature_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleOptionToolBar_ToolBarFeature,
            is_Enum_PythonToCpp_QStyleOptionToolBar_ToolBarFeature_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBar::ToolBarFeature");
        Shiboken::Conversions::registerConverterName(converter, "ToolBarFeature");
        // Register converter for flag 'QFlags<QStyleOptionToolBar::ToolBarFeature>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QStyleOptionToolBar::ToolBarFeature>");
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBar::ToolBarFeatures");
    }
    // End of 'ToolBarFeature' enum/flags.

    qRegisterMetaType< ::QStyleOptionToolBar *>();
    qRegisterMetaType< ::QStyleOptionToolBar::StyleOptionType >("QStyleOptionToolBar::StyleOptionType");
    qRegisterMetaType< ::QStyleOptionToolBar::StyleOptionVersion >("QStyleOptionToolBar::StyleOptionVersion");
    qRegisterMetaType< ::QStyleOptionToolBar::ToolBarPosition >("QStyleOptionToolBar::ToolBarPosition");
    qRegisterMetaType< ::QStyleOptionToolBar::ToolBarFeature >("QStyleOptionToolBar::ToolBarFeature");

    return pyType;
}
